C FLUX7.COM include file. For version 7.9.4
C P.J.M.Smulders June 2018
C
      CHARACTER*28 VERSION
      CHARACTER*16 POTENTIAL
      COMMON /COMVRS/ VERSION, POTENTIAL

C  NL is the number of different atom species in the crystal
C  ML is twice NL to accomodate the MIXED lattice case
C  NLAYER is the number of different layers
      INTEGER NL,ML,NLAYER,NANGMAX,NLTOT,MLTOT
      PARAMETER (NL=7,ML=NL*2,NLAYER=2,NANGMAX=8000)
      PARAMETER (NLTOT=NL*NLAYER, MLTOT=ML*NLAYER)

C  ARRAY DIMENSIONS: X,Y,Z divided in NX,NY,NBIN bins, respectively.
C  Where NX * NY .LE. NF**2
      INTEGER NF,NV,NBIN,NEBIN,MAXRAAK,NTHICKMAX
      PARAMETER ( NF=100, NV=100,  NBIN =1000, NEBIN=NBIN, MAXRAAK = 99)
      PARAMETER ( NTHICKMAX = 16)

C  ACTUAL VALUES of NF,NV,NL,ML,NBIN,NEBIN,NLAYER:
      INTEGER NFA,NVA,NLA,MLA,NBINA,NEBINA,NLAY
      COMMON /COMDIM/ NFA,NVA,NLA(NLAYER),MLA,NBINA,NEBINA,NLAY

      CHARACTER*70    INFILE,FLXFILE,EFILE,STATFILE,YLDFILE,LOGFILE,
     +   CFILE
      CHARACTER*82 COMFIGNAME
      COMMON /COMFILE/INFILE,FLXFILE,EFILE,STATFILE,YLDFILE,LOGFILE,
     +   CFILE,COMFIGNAME(NLAYER)

C INLU=INFILE, LUN(1..3) = SCREEN, LOGFILE, FLXFILE, CFILE
C           LUOPEN(L) = 1 if the corresponding unit is open
      INTEGER INLU,LUN,LUOPEN,NSTART,NRSTART,CHECKONLY
      COMMON /LUNITS/INLU,LUN(4),LUOPEN(4)
      COMMON /STATUS/NSTART,NRSTART,CHECKONLY

C NLS(L) is number of atom species as read from file COMBIN.FIG
C NLA(L) is the actual number of atom species in layer L
C     (these may be different e.g. GaAs structure for Si: NLB=2 NLA=1)
C NIND  : number of different sites where collisions occur
C MODX,MODY,MODZ : period of X,Y,Z in units XUNIT,YUNIT,DUNIT
C APC(L): atoms per (3-dimensional) unit cell of kind L.
C NABUR(L): number of surrounding atom rows to take along.
C LATTICE : a flag used in subroutine BBLOOP, to identify the lattice
C XPOS,YPOS : the coordinates of the surrounding atom rows
C DUNIT,XUNIT,YUNIT: units for Z,X,Y (in units of the lattice constant)
C ZPOS(L): spacing between atoms of kind L in the atom rows
C IATOM(J,L): if non-zero an atom of kind L is present at Z=J
C             its x,y coordinates are stored in
C XATOM(k),YATOM(k), where k=IATOM(J,L)
C NLC is number of lattice constants (1 for cubic, 2 for hexagonal)
C UZ(L): z coordinates for MODZ+1 planes from z=0 to z=1
C DUZ(L): MODZ steps between consecutive  planes from z=0 to z=UD

      INTEGER NABURMAX, MAXIATOM, MAXIND,MODZMAX
      PARAMETER (NABURMAX=50,MAXIATOM=50,MAXIND=50,MODZMAX=50)

      CHARACTER*10 CONFIGID, CSYMM
      COMMON /CONFIG/ CONFIGID(NLAYER), CSYMM(NLAYER)

      INTEGER NLS, NLC,NLZ
      INTEGER NIND,MODX,MODY,MODZ,NABUR,LATTICE,IATOM,IP
      COMMON /COMFIG/ 
     + NLS(NLAYER),NLC(NLAYER),NLZ(NLAYER),
     + NIND(NLAYER),MODX(NLAYER),MODY(NLAYER),MODZ(NLAYER),
     + NABUR(NL,NLAYER),LATTICE(NLAYER),
     + IATOM(0:MAXIATOM,1:NL,NLAYER),
     + IP(3,2,NLAYER)
      REAL APC,XPOS,YPOS,DUNIT,XUNIT,YUNIT,ZPOS,XATOM0,YATOM0,UZ,DUZ
      COMMON /RCOMFIG/
     + APC(NL,NLAYER),XPOS(NABURMAX,NL,NLAYER),YPOS(NABURMAX,NL,NLAYER),
     + DUNIT(3,NLAYER),XUNIT(3,NLAYER),YUNIT(3,NLAYER),ZPOS(NL,NLAYER),
     + XATOM0(MAXIND,NLAYER),YATOM0(MAXIND,NLAYER),
     + UZ(0:MODZMAX,NLAYER),DUZ(0:MODZMAX,NLAYER)


C RAAK: the close encounter probability
C FLUX: the flux of ions
C DAV : the average energy loss
C DDAV: the second moment of the energy loss distribution
C NDELZ: number of Z steps per bin of RAAK,DAV,DDAV
C MDELZ: number of Z periods per bin of RAAK,DAV,DDAV
C LFLX: Layer number for which flux distribution is accumulated.
      INTEGER NDELZ,MDELZ,NFX,NFY,LFLX,NRAAK,KRAAK
      COMMON /COMFLUX/ NDELZ,MDELZ,NFX,NFY,LFLX,NRAAK,KRAAK(MAXRAAK)
      REAL ANORM0,ZMAX,ZSIG,FLUX,DAV,DDAV,APC1,RAAK
      COMMON /RCOMFLUX/ZMAX,ZSIG,ANORM0(ML,NLAYER),
     + FLUX(NF*NF), DAV(0:NBIN-1,ML),DDAV(0:NBIN-1,ML),APC1(NL,NLAYER),
     + RAAK(0:NBIN-1,ML,NLAYER)

      INTEGER ISEED
      COMMON /COMRAN/ ISEED

      REAL RM,TESQMAX,U2SQ,U2,U1,XUN,YUN,UD,XUM,YUM,XATOM,YATOM,ZZ0
      REAL XSDR,YSDR,ANGR,TWOXUN,TWOYUN,DXI,DYI,RSCREEN, ZZA2,ZZD2
      REAL CELL
      COMMON /COMCHAN/ RM(ML,NLAYER),TESQMAX,
     + U2SQ(ML,NLAYER),U2(ML,NLAYER),U1(ML,NLAYER),
     + XUN(NLAYER),YUN(NLAYER),UD(NLAYER),
     + XUM(NLAYER),YUM(NLAYER),
     + XATOM(MAXIND,NLAYER),YATOM(MAXIND,NLAYER),
     + ZZ0,XSDR,YSDR,ANGR,TWOXUN(NLAYER),TWOYUN(NLAYER),DXI,DYI,
     + RSCREEN(ML,NLAYER), ZZA2(ML,NLAYER), ZZD2(ML,NLAYER),CELL(NLAYER)
      INTEGER NXI,NYI,NBINF
      COMMON /ICOMCHAN/NXI,NYI,NBINF

Common COMPOTE used to pass parameters to subroutines FORCE, DVTM
      REAL ZZD,ZZA,ATF,U2A,U2ASQ,RHOA,XUNA,YUNA
      COMMON /COMPOTE/ ZZD,ZZA,ATF,U2A,U2ASQ,RHOA,XUNA,YUNA

      INTEGER NSEED,NTRX,NRUN,NANG,IXYOUT,WEIGHTDE
      COMMON /COMINP/NSEED,NTRX,NRUN,NANG,IXYOUT,WEIGHTDE
      REAL T0,TMIN,Z1,Z2,
     + A1,A2,DEBYE,TEMP,UA,
     + ZIMAX,ZIFWHM,XSD,YSD,ANGH,ANG,
     + CURPLANE, CURRADIUS, BEAMX, BEAMY
      COMMON /RCOMINP/ T0,TMIN,Z1,Z2(ML,NLAYER),
     + A1,A2(ML,NLAYER),DEBYE(ML,NLAYER),TEMP,UA(3,NLAYER),
     + ZIMAX,ZIFWHM,XSD,YSD,ANGH,ANG(3,NANGMAX),
     + CURPLANE, CURRADIUS(NLAYER), BEAMX, BEAMY

      INTEGER NSTOP, NSTOPMAX
      PARAMETER(NSTOPMAX=20)
      COMMON /ICOMLOS/ NSTOP
      REAL DEDXVL,DEDXVP,ELCORE,DEVL,DEVP,ESTOP
      COMMON /COMLOS/ DEDXVL(NLAYER,NSTOPMAX), DEDXVP(NLAYER,NSTOPMAX),
     + ELCORE(50,ML,NLAYER,NSTOPMAX),
     + DEVL(NLAYER,NSTOPMAX), DEVP(NLAYER,NSTOPMAX),
     + ESTOP(NSTOPMAX)

      REAL PROFIEL,ECROSS,CROSS
      COMMON /PROFILE/ PROFIEL(0:NBIN-1)
      COMMON /COMCROS/ ECROSS(200,0:ML,NLAYER), CROSS(200,0:ML,NLAYER)
      INTEGER NCROSS
      COMMON /ICOMCROS/ NCROSS(0:ML,NLAYER)

      LOGICAL JOPTION
      INTEGER NOPTION
      PARAMETER(NOPTION = 13)
      COMMON /FLXOPT/ JOPTION(NOPTION)
      INTEGER LFFLUX, LFVELO, LFNCHAN, LFSCORE, LFCOLLI, LFMAXAN,
     + LFEFINAL, LFXYOUT, LFEFILE, LEXITCO, LFCFILE, LSTARTCO, LMIXED
      PARAMETER(LFFLUX=1, LFVELO=2, LFNCHAN=3, LFSCORE=4, LFCOLLI=5,
     + LFEFINAL=6, LFXYOUT=7, LFEFILE=8, LEXITCO=9, LFCFILE=10, 
     + LSTARTCO=11, LMIXED=12, LFMAXAN=13 )
C
      INTEGER NP0,NTHICK,NAWBX
      COMMON /DBLAYER/ NP0,NTHICK,NAWBX
      REAL ZINTERF,WINTERF,ROTM,TRANSL,EBIN,PBIN,AMAWBEAM,CMAWBEAM,THICK
      REAL ROTI, TRANSI
      COMMON /RDBLAYER/ ZINTERF(NLAYER), WINTERF(NLAYER),
     + ROTM(3,3,NLAYER), TRANSL(3,NLAYER),THICK(NTHICKMAX),
     + EBIN, PBIN, AMAWBEAM, CMAWBEAM, ROTI(3,3), TRANSI(3)
C
      REAL CURMAT, CURMATT
      COMMON /CURVATURE/ CURMAT(3,3,NLAYER), CURMATT(3,3,NLAYER)
C
      INTEGER NFINAL
      COMMON /ICOMFINAL/ NFINAL
      DOUBLE PRECISION TFINAL, DTFINAL, PXFINAL, DPXFINAL,
     +   PYFINAL, DPYFINAL, PTFINAL, DPTFINAL
      COMMON /COMFINAL/ TFINAL, DTFINAL, PXFINAL, DPXFINAL,
     +   PYFINAL, DPYFINAL, PTFINAL, DPTFINAL
C
C Extra data and parameters
C ANGPMAX: angular range of final velocity distribution
C          (bin width of VFINAL is 2.0*SIN(ANGPMAX/2)/NVA)
C CRITX  : critical angle for channeling (x component)
C CRITY  :   "        "    "      "      (y     "    )
C ANGPMDG, CRITXDG, CRITYDG : same parameters, in degrees
C TMFIN, TFMAX: min and max of range of final energy,
C             used in energy distribution of exiting ions
C
      REAL ANGPMAX,CRITX,CRITY,ANGPMDG,CRITXDG,CRITYDG,TFMIN,TFMAX
      COMMON /XTRAPARM/ANGPMAX, CRITX, CRITY, ANGPMDG, CRITXDG, CRITYDG,
     + TFMIN, TFMAX
C
      INTEGER EFINAL
      COMMON /ICOMEXIT/ EFINAL(0:NEBIN)
      REAL VFINAL
      COMMON /COMEXIT/ VFINAL(NV*NV)
C
C NCHANNEL: number of 'channeling' particles as a function of depth
C LEFTOVER: number of particles with angle < AMAWBEAM to the beam
C SNUCLEAR, SCORE, SVALENCE: energy loss per collision as a function
C of depth
      INTEGER NCHANNEL, LEFTOVER
      COMMON /XTRADATA/ NCHANNEL(0:NBIN-1), LEFTOVER(0:NBIN-1)
      REAL SNUCLEAR, SCORE, SVALENCE
      COMMON /RXTRADATA/ 
     + SNUCLEAR(0:NBIN-1), SCORE(0:NBIN-1), SVALENCE(0:NBIN-1)

C parameters for initial energy spectrum
      REAL ZVAL,AVZVAL,TAPC,E0,ES,RENRGY
      COMMON /ESPEC/ZVAL(NL,NLAYER),AVZVAL(NLAYER),TAPC(NLAYER),
     + E0,ES,RENRGY
      INTEGER ICRATE,LOSS
      COMMON /IESPEC/ ICRATE(0:2048),LOSS

C parameters for mixed lattice
      REAL ATOMFRAC
      COMMON /MIXCOM/ ATOMFRAC(ML,NLAYER)
      INTEGER HITLIST
      INTEGER NLA0, NLA1, ILMAP
      COMMON /IMIXCOM/ HITLIST(NL,NL,NLAYER),
     + NLA0(NLAYER), NLA1(NL,NLAYER), ILMAP(NL,NLAYER)

C DEFINE SOME CONSTANTS:
      REAL ZERO,PI,TWOPI,DEGREE,AMU,AME
      PARAMETER ( ZERO=0 )
      PARAMETER(PI=3.14159265,TWOPI=2.0*PI,DEGREE=TWOPI/360.0)
      PARAMETER(AMU=931.5016,AME=0.511003)

************ end of include file FLUX7.COM **********************
