C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION FF(X)
      FUNCTION FF(X,IZ2)
C usage:  R = FF(X,IZ2)
C for the ZBL and Moliere potential, IZ2 is not used.
C FAST WAY OF CALCULATING THE DERIVATIVE OF THE CONTINUUM STRING
C POTENTIAL, USING INTERPOLATION. THE RESULT OF FF IS EQUIVALENT
C WITH THAT OF FUNCTION DPOT.
C THE INTERPOLATED FUNCTION LOG(X*DPOT) IS MUCH SMOOTHER THEN
C DPOT ITSELF. FOR X VALUES BELOW 0.05 (INTERPOLATION INACCURATE)
C STRAIGHTFORWARD CALCULATION IS DONE
C INTERPOLATION IS IN STEPS DX=0.05 UP TILL X=20, AND DX=0.5 UP TILL
C X=120. FOR LARGER X VALUES EXTRAPOLATION IS DONE, WHICH MAY LEAD TO
C LARGE ERRORS. THEREFORE DON'T USE THIS ROUTINE IF THIS PART OF THE
C TAIL IS IMPORTANT.
C FOR THE ZBL POTENTIAL THE ACCURACY IS BETTER THEN 1:2E4 FOR
C X < 120, AND GRADUALLY DEGRADES TO ABOUT 10% AT X=210
C FUNCTION DPOT IS CALLED
      COMMON /COMMOL/ FFR(600)
      LOGICAL INIT
      SAVE INIT
      DATA INIT /.FALSE./
      IF( .NOT. INIT)THEN
          DO 1 K=1,600
          IF(K.LE.400)THEN
              Z=0.05*K
          ELSE
              Z=(K-401)*0.5 + 20.0
          ENDIF
          FFR(K)=ALOG(Z*DPOT(Z))
    1     CONTINUE
          INIT= .TRUE.
      ENDIF
      Y=X-20.0
      IF(Y.LE.0.0) THEN
          Y=X*20.0
      ELSE
          Y=Y*2.0 + 401
      ENDIF
      K=Y
      IF(K.EQ.0)THEN
          FF=DPOT(X)
          RETURN
      ENDIF
      IF(K.LT.1)THEN
        write(6,*)'FF illegal arguments: X, Y, K:',X,Y,K
      ENDIF
      IF(K.GT.599)K=599
      FF = EXP( FFR(K) + ( Y - K )*( FFR(K+1) - FFR(K) ) ) / X
      END
