C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION APOL(A,X,Y,N,MAX)
C     APOL FINDS THE VALUE OF Y FOR X=A BY N-POINTS INTERPOLATION
C     FROM THE ARRAYS X AND Y, BOTH WITH SIZE MAX.  N MAY BE 2 TO 6.
      REAL FUNCTION APOL (A,X,Y,N,MAX)
      IMPLICIT NONE
C usage: R=APOL(A,X,Y,N,MAX)
      INTEGER N, MAX
      REAL A, X(MAX),Y(MAX)

      REAL PX(6),PY(6)
      INTEGER I1,I2,I,K
      REAL S

C     FIND I1 AND I2 SUCH THAT A IS BETWEEN X(I1) AND X(I2)
      I1=1
      I2=MAX

      IF(X(MAX).GT.X(1))THEN
        S=1.0
      ELSE
        S=-1.0
      ENDIF

1     I=(I1+I2)/2
      IF ((A - X(I))*S .GT. 0) THEN
        I1=I
      ELSE
        I2=I
      ENDIF
      IF (I2-I1 .GT. 1) GOTO 1

C     NOW,SET I1 TO INDEX-1 OF FIRST ELEMENTS TO BE USED
      I1=I1-N/2
      IF(I1 .LT. 0) I1=0
      IF (I1+N .GT. MAX) I1=MAX-N
C     TRANSFER  A-X AND Y TO AUXILIARY ARRAYS
      DO 5 I=1,N
      I1=I1+1
      PX(I)=A-X(I1)
5     PY(I)=Y(I1)
C   FINALLY, USE AITKEN ALGORITHM FOR LAGRANGE INTERPOLATION
      DO 6 K=1,N-1
      DO 6 I=K+1,N
6     PY(I)=(PY(I)*PX(K)-PY(K)*PX(I))/(PX(K)-PX(I))
      APOL=PY(N)
      END
