C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION AVXSQ(A,THETA,T)
      REAL FUNCTION AVXSQ(A,THETA,T)
      IMPLICIT NONE
      REAL A,THETA,T

C usage:  R = AVXSQ(A,THETA,T)
CALCULATE AVERAGE X**2 IN DEBYE MODEL.
C RESULT IN SQUARE ANGSTROMS.
C A IN ATOMIC MASS UNITS, THETA AND T IN KELVINS.
C EXTERNAL FUNCTION CALLED: QZ

      REAL QZ
      EXTERNAL QZ

      REAL HBAR, C, BOLS, METER, JOULE, AMU, CONS
C PARAMETERS IN S.I. UNITS:
      PARAMETER(HBAR=1.054589E-34,C=2.997925E8, BOLS=1.380662E-23)
C CONVERSION FACTORS, AMU TO MeV, METER TO ANGSTROM, JOULE TO MeV:
      PARAMETER(AMU=931.5016,METER=1.0E10,JOULE=1.0E-6/1.602189E-19)
CONSTANT APPEARING IN THE EXPRESSION FOR X**2:
      PARAMETER (CONS=0.75*(HBAR*C*METER)**2*JOULE/AMU/BOLS)
C
C NOTE:
C     if the input value of THETA is negative, it is considerd
C     to be the value of -x in Angstrom units. 
C     In that case no calculations are done and A and T are ignored
C
      REAL Z, P

      IF ( THETA .LE. 0.0 ) THEN
          AVXSQ=THETA*THETA
          RETURN
      ENDIF
      Z=THETA/T
      P=1.0+4.0*QZ(Z)/(Z*Z)
      AVXSQ=CONS*P/(A*THETA)
      END
