C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ BATINIT
      SUBROUTINE BATINIT
C usage: CALL BATINIT
C
C This subroutine reads the parameters
C  INFILE, OUTFILE, LOGFILE, YLFDILE, NSTART, NRSTART
C from file 'batflux.ini'
C and opens the files needed by FLUX

       INCLUDE 'FLUX7.COM'

      character*8 KNOWN
      character*80 LINE
      INTEGER IGETARG, IARGC

C The following UNITS are used throughout the program FLUX:
C
C     Logical Unit 1 = ENERGYFILE (user-specified)
C     Logical Unit 2 = STATUS FILE='batflux.ini'
C     Logical Unit 3 = COMMONBLOCKFILE (='combin.fig')
C     Logical Unit INLU =5 = INPUTFILE (user-specified)
C     Logical Unit LUN(1)=6 = SCREEN
C     Logical Unit LUN(2)=8 = LOGFILE (user-specified)
C     Logical Unit LUN(3)=7 = FLXFILE (user-specified)
C     Logical Unit LUN(4)=4 = Coordinates File (user-specified)
C
      STATFILE='batflux.ini'

C any command-line arguments?
C The following provides the possibility to use an alternate
C filename for the STATUS FILE. The name is given as a command
C line argument. If your system does not support IARGC and
C IGETARG (or GETARG), just scrap the following two lines
      NARGS = IARGC()
      if(NARGS.ge.1) LEN= IGETARG(1,STATFILE,70)

      CALL LFOPEN(2,STATFILE,'OLD',0,0)
      READ(2,70) INFILE
      READ(2,70) FLXFILE
      READ(2,70) LOGFILE
      READ(2,70) YLDFILE
      READ(2,*) NSTART
      READ(2,*) NRSTART
      READ(2,71,END=34) KNOWN
      if(KNOWN.eq.' ')goto 34
      goto 35
C if batflux.ini does not contain a KNOWN status, assume 'NEW' FLXFILE
  34  KNOWN='NEW'
  35  continue
      CLOSE (2)

      IF(LUN(2).ne.0 .and. LOGFILE.ne.' ')THEN
        CALL LFOPEN(LUN(2),LOGFILE,'UNKNOWN',1,0)
        LUOPEN(2)=1
        call strwrite(LUN(1),'# logfile is: '//LOGFILE)
      ELSE
        LUOPEN(2)=0
      ENDIF

      IF(LUN(3).ne.0)THEN
        do 47 L=1,2
        IF(LUOPEN(L).eq.1)
     +   call strwrite(LUN(L),'# flxfile is: '//FLXFILE)
  47    continue
        CALL LFOPEN(LUN(3),FLXFILE,KNOWN,1,0)
        LUOPEN(3)=1
      ELSE
        LUOPEN(3)=0
      ENDIF

      do 48 L=1,3
      if(LUOPEN(L).eq.1) then
        call strwrite(LUN(L),'# input file: '//INFILE)
      endif
  48  continue

      CALL LFOPEN (5, INFILE, 'OLD', 0,0)
      IF(KNOWN.EQ.'NEW' .and. LUOPEN(3).eq.1)THEN
C copy the input file to LU 7
  67    READ(5,'(A80)',END=68)LINE
        call strwrite(LUN(3),LINE)
        goto 67
  68    continue
        WRITE(LUN(3),'(A3)',ERR=1526)'EOI'
        rewind 5
      ENDIF
      RETURN

  70  FORMAT(A70)
  71  FORMAT(A8)

 1503 FORMAT(A16,A70)
 1526 WRITE(6,1503)'error writing to ',FLXFILE
      STOP
      END
