C ~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION CROSSECT(A,NCROSS,ECROSS,CROSS)
      REAL FUNCTION CROSSECT (A,NCROSS,ECROSS,CROSS)
      IMPLICIT NONE
      REAL A
      INTEGER NCROSS
      REAL ECROSS(NCROSS),CROSS(NCROSS)
C usage:  R = CROSSECT (A,NCROSS,ECROSS,CROSS)
C CROSSECT FINDS THE VALUE OF CROSS(A) BY LANGRANGE INTERPOLATION
C USING N POINTS. (SEE PARAMETER N).
C ARRAYS ECROSS AND CROSS CONTAIN NCROSS VALUES OF THE ENERGY AND
C THE CORRESPONDING CROSS SECTION, RESPECTIVELY.
C THE VALUES OF ECROSS MUST BE IN ASCENDING ORDER.
C IT IS ASSUMED THAT NCROSS .GE. N
      INTEGER N, I,J,K,I1,I2
      PARAMETER(N=3)
      REAL PX(N),PY(N)
      SAVE I2
      DATA I2/200/
C     FIND I1 AND I2 SUCH THAT A IS BETWEEN ECROSS(I1) AND ECROSS(I2)
C     FIRST GUESS: ECROSS(I2-2) < A < ECROSS(I2), USING OLD I2
      IF(I2.LE.2)I2=3
      IF(I2.GT.NCROSS)I2=NCROSS
      I1=I2-2
      IF (A.LT.ECROSS(I1)) THEN
          I1=1
      ELSE IF (A.GT.ECROSS(I2)) THEN
          I2=NCROSS
      ENDIF
1     I=(I1+I2)/2
      IF (A.LT.ECROSS(I)) THEN
          I2=I
      ELSE
          I1=I
      ENDIF
      IF (I2-I1.GT.1) GOTO 1
C     NOW,SET J TO INDEX-1 OF FIRST ELEMENTS TO BE USED
      J=I1-N/2
      IF(J .LT. 0) J=0
      IF (J+N .GT. NCROSS) J=NCROSS-N
C     TRANSFER  ECROSS AND CROSS TO AUXILIARY ARRAYS
      DO 5 I=1,N
      J=J+1
      PX(I)=A-ECROSS(J)
5     PY(I)=CROSS(J)
C   FINALLY, USE AITKEN ALGORITHM FOR LAGRANGE INTERPOLATION
      DO 6 K=1,N-1
      DO 6 I=K+1,N
6     PY(I)=(PY(I)*PX(K)-PY(K)*PX(I))/(PX(K)-PX(I))
      CROSSECT=PY(N)
      END
