C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE DBESK(X,N,BK,IER)
      SUBROUTINE DBESK(X,N,BK,IER)
* double precision version of BESK
C usage:  CALL DBESK(X,N,BK,IER)  with double precision X and BK
C         see comments of BESK
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      DIMENSION T(12)
      BK=.0
      IER=0
      G0=1.7D38
      GJ=1.7D38
C FOR USE ON THE VAX USE THE FOLLOWING TO AVOID COMPILER ERRORS
      G0=9.9D305
      GJ=9.9D305
      IF(N.LT.0)IER=1
      IF(X.LE.0.0)IER=2
      IF(X.GT.740.0)IER=3
      IF(IER.NE.0)RETURN
      IF(X.LE.1.0)GOTO 36
      A=EXP(-X)
      B=1./X
      C=SQRT(B)
      T(1)=B
      DO 26 L=2,12
   26 T(L)=T(L-1)*B
      IF(N.EQ.1)GOTO 29
C
C     COMPUTE KO USING POLYNOMIAL APPROXIMATION
C
      G0=A*(1.25331414D0-.1566642D0*T(1)+.08811128D0*T(2)-.09139095D0
     2*T(3)+.1344596D0*T(4)-.2299850D0*T(5)+.3792410D0*T(6)-.5247277D0*
     3T(7)+.5575368D0*T(8)-.4262633D0*T(9)+.2184518D0*T(10)-.06680977D0*
     4T(11)+.009189383D0*T(12))*C
      IF(N.NE.0)GOTO 29
      BK=G0
      RETURN
C
C     COMPUTE K1 USING POLYNOMIAL APPROXIMATION
C
   29 G1=A*(1.25331414D0+.4699927D0*T(1)-.1468583D0*T(2)+.1280427D0*T(3)
     2-.1736432D0*T(4)+.2847618D0*T(5)-.4594342D0*T(6)+.6283381D0*T(7)
     3-.6632295D0*T(8)+.5050239D0*T(9)-.2581304D0*T(10)+.07880001D0
     4*T(11)-.01082418D0*T(12))*C
      IF(N.NE.1)GOTO 31
      BK=G1
      RETURN
C
C     FROM KO,K1 COMPUTE KN USING RECURRENCE RELATION
C
   31 DO 35 J=2,N
      GJ=2.*(FLOAT(J)-1.)*G1/X+G0

C THE FOLLOWING LINE IS PC/VAX/860-SPECIFIC
      IF(GJ.GT.1.0D305 .OR. G0.GT.1.0D305)THEN

C FOR USE ON THE VAX USE THE FOLLOWING LINE TO AVOID COMPILER ERRORS
C     IF(GJ.GT.1.6D38)THEN


          IER=4
          GOTO 34
      ENDIF
      G0=G1
   35 G1=GJ
   34 BK=GJ
      RETURN
   36 B=X/2.
      A=0.57721566490153D0+LOG(B)
      C=B*B
      IF(N.EQ.1)GOTO 43
C
C     COMPUTE KO USING SERIES EXPANSION
C
      G0=-A
      X2J=1.
      FACT=1.
      HJ=.0
C FOLLOWING LOOP HAD A FIXED NUMBER (6) OF ITERATIONS.
C MODIFIED TO AVOID UNDERFLOW FOR VERY SMALL ARGUMENTS. 10/11/81.
C A SIMILAR CHANGE WAS MADE IN THE CALCULATION OF K1.
      QJ=0.0
  40  QJ=QJ+1.0
      RJ=1.0/QJ
      X2J=X2J*C
      FACT=FACT*RJ*RJ
      HJ=HJ+RJ
      G0=G0+X2J*FACT*(HJ-A)
      IF(X2J.LT.1.0D-4)GOTO 41
      GO TO 40
   41 IF(N.NE.0)GOTO 43
      BK=G0
      RETURN
C
C     COMPUTE K1 USING SERIES EXPANSION
C
   43 X2J=B
      FACT=1.
      HJ=1.
      G1=1./X+X2J*(.5+A-HJ)
      FLJ=2.0
   50 X2J=X2J*C
      RJ=1./FLJ
      FACT=FACT*RJ*RJ
      HJ=HJ+RJ
      G1=G1+X2J*FACT*(.5+(A-HJ)*FLJ)
      IF(X2J.LT.1.0D-4)GOTO 51
      FLJ=FLJ+1.0
      GOTO 50
   51 IF(N.NE.1)GOTO 31
      BK=G1
      END
