      FUNCTION DVTM(RHOA1)
C usage:  R = DVTM(RHOA1)
C MINUS FIRST DERIVATIVE D/DRHOA1 OF DVM.
C USES U2A AND U2ASQ OF COMMON BLOCK COMPOTE
C SETS RHOA          "     "      "       "
C
      EXTERNAL DGRAND
      COMMON /COMPOTE/ ZZD,ZZA,ATF,U2A,U2ASQ,RHOA,XUNA,YUNA
      RHOA=RHOA1
      IF(RHOA.GT.U2A*5.0)THEN
          DVTM= (0.5-0.25*(U2A/RHOA)**2) * DPOT(RHOA) + 0.25 *
     *    ((1.0-0.5*U2A/RHOA)*DPOT(RHOA-U2A)+
     +     (1.0+0.5*U2A/RHOA)*DPOT(RHOA+U2A))
      ELSE
          XSIMAX=5.0*U2A+RHOA
          IF(XSIMAX.GT.75.0)XSIMAX=75.0
          XSI0=RHOA-6.0*U2A
          IF(XSI0.LT.1.0E-5)XSI0=1.0E-5
          SUMM=0.0
          XSI1=XSI0+0.125*U2A

    1     PREC=0.001*(XSI1-XSI0)
****      write(6,*)'dvtm: call romberg',XSI0,XSI1,ZZD,U2A,RHOA,XUNA
          CALL ROMBERG(DGRAND,XSI0,XSI1,0.5E-3,SINT,PREC,H,KERR)
          IF(KERR.NE.0)THEN 
            CALL ERRMESS('DVTM',KERR)
            IF(KERR.EQ.2)THEN
              WRITE(6,'(A,E12.3)')'H/PREC       =',H/PREC
              WRITE(6,'(A,E12.3)')'H/(XSI1-XSI0)=',H/(XSI1-XSI0)
            ENDIF
          ENDIF

          SUMM=SUMM+SINT
          IF(XSI1.LT.XSIMAX*0.999)THEN
            XSI0=XSI1
            XSI1=XSI1+0.125*U2A
            IF(XSI1.GT.XSIMAX)XSI1=XSIMAX
            GOTO 1
          ENDIF
          DVTM=SUMM * 2.0 / U2ASQ
      ENDIF
      END
C
      FUNCTION DGRAND(X)
C usage:  R = DGRAND(X)
C THIS FUNCTION SUBROUTINE SUPPLIES THE INTEGRAND OF DVTM.
      COMMON /COMPOTE/ ZZD,ZZA,ATF,U2A,U2ASQ,RHOA,XUNA,YUNA
      DGRAND = - X*POT(X)/EXP((X-RHOA)**2/U2ASQ)*FI1(X,RHOA,U2ASQ)
      END
C
      FUNCTION FI1(X,R,U2SQ)
C usage:  R = FI1(A)
CALLED BY DGRAND
      A=X*R/U2SQ
      SUM=0.0
      TERM=EXP(-A)
      RN=0.0
   1  FACTOR = 2.0 * (RN/R - R/U2SQ)
      SUM1=SUM+TERM*TERM*FACTOR
      IF(SUM1.NE.SUM.OR.ABS(FACTOR*R).LT.1.0)THEN
C THE SECOND CONDITION TAKES CARE OF ACCIDENTALLY ZERO TERMS.
        SUM=SUM1
        RN=RN+1.0
        TERM=TERM*A/RN
        GOTO 1
      ENDIF
      FI1=SUM1
      END
