      subroutine getcoord(lu,iopt,x,y,px,py,T,ier)
      implicit none
      integer lu,iopt,ier
      real x,y,px,py,T

c get coordinates, written by FLUX option EXITCO
c lu: logical unit
c iopt=0: read next line beginning with exit
c iopt=1: read next record beginning with offsets:
c iopt=2: read next line beginning with scalefactor:
c iopt=3: read next line beginning with start
c iopt=4: read next line beginning with start or exit
c         return value of iopt is set to 0 (exit) or 4 (start)
c x,y,px,py,T: the data
c ier=0: everything went smoothly
c ier=1: short line
c ier=2: end of record
c ier=3: end of file
c ier=-1: read error

      character*80 string
      character*12 searchst
      integer DIMW,I,IPT,IDUM,ITERM,ERRO, lsearch
c PFACTOR and TFACTOR are scaling factors for PX, PY, T
      real XFACTOR, YFACTOR, PXFACTOR, PYFACTOR, TFACTOR
      parameter(DIMW=10)
      real WORK(DIMW)
      real offx, offy, offpx, offpy, offT
      integer myopt
      save XFACTOR, YFACTOR, PXFACTOR, PYFACTOR, TFACTOR
      save offx, offy, offpx, offpy, offT
      DATA XFACTOR, YFACTOR, PXFACTOR, PYFACTOR, TFACTOR
     + / 1.0, 1.0, 1000.0, 1000.0, 1000.0 /

  70  myopt= iopt
      if(iopt.eq.0)then
        searchst='exit'
        lsearch=4
      else if(iopt.eq.1)then
        searchst='offsets:'
        lsearch=8
      else if(iopt.eq.2)then
        searchst='scalefactor:'
        lsearch=12
      else if(iopt.eq.3)then
        searchst='start'
        lsearch=5
      else if(iopt.eq.4)then
        searchst='start'
        lsearch=5
      else
        lsearch=0
      endif

  74  continue
      read(lu,'(A)',ERR=9999, end=747) string
      if(string(1:4) .eq. '*new') then
        goto 748
      endif
      if(STRING(1:1).eq. '#') goto 74
      if(lsearch .gt. 0)THEN
        if(string(1:8).eq.'offsets:')then
         myopt=1
         lsearch=8
        else if(string(1:12).eq.'scalefactor:')then
         myopt=2
         lsearch=12
        else if(string(1:lsearch) .ne. searchst(1:lsearch))then
         if(myopt.eq.4 .and. string(1:4).eq.'exit')then
          iopt=0
          myopt=0
         else
          goto 74
         endif
        endif
        IPT= lsearch
      else
        IPT=0
      endif
      I=0
  742 continue
      I= I+1
      call GETNUM(WORK(I),IDUM,string,80,IPT,ITERM,ERRO)
      if(ERRO.eq.0 .and. I.lt.DIMW)goto 742
      if(myopt.eq.0)then
c exit coordinates
        if(I.lt.6)goto 749
        x=(work(2)+offx)/XFACTOR
        y=(work(3)+offy)/YFACTOR
        px=(work(4)+offpx)/PXFACTOR
        py=(work(5)+offpy)/PYFACTOR
        T=(offT-work(6))/TFACTOR
      else if(myopt.eq.1)then
c offsets
        if(I.lt.5)goto 749
        offx=work(1)
        offy=work(2)
        offpx=work(3)
        offpy=work(4)
        offT=work(5)
        x=offx
        y=offy
        px=offpx/PXFACTOR
        py=offpy/PYFACTOR
        T=offT/TFACTOR
      else if(myopt.eq.2)then
c scalefactors
        if(I.lt.5)goto 749
        XFACTOR=work(1)
        YFACTOR=work(2)
        PXFACTOR=work(3)
        PYFACTOR=work(4)
        TFACTOR=work(5)
        x=XFACTOR
        y=YFACTOR
        px=PXFACTOR
        py=PYFACTOR
        T=TFACTOR
      else if(myopt.eq.3 .or. myopt.eq.4)then
c start coordinates
        if(I.lt.6)goto 749
        x=(work(2))/XFACTOR
        y=(work(3))/YFACTOR
        px=(work(4)+offpx)/PXFACTOR
        py=(work(5)+offpy)/PYFACTOR
        T=(offT+work(6))/TFACTOR
      endif
      if(myopt.ne.iopt)goto 70
      ier=0
      return

c come here at end-of-file
  747 continue
      ier = 3
      return
c come here at end-of-record
  748 continue
      ier = 2
      return
c come here at short line
  749 continue
      write(6,*) 'SHORT LINE:'//string 
      ier = 1
      return
c come here at read error
 9999 continue
      ier = -1
      end
