C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE FINDFLX
      SUBROUTINE FINDFLX(LU,NBIN,NBINF,NX,NY,NV,NL,NLA,NLAY,
     + WEIGHTDE,IER)
      INTEGER            LU,NBIN,NBINF,NX,NY,NV,NL,NLA(*),NLAY,
     + WEIGHTDE,IER
C INPUT:
C LU = unit to read from

C OUTPUT:
C NBIN = array size RAAK, DAV, DDAV (as dimensioned)
C NBINF = array size actually used
C NX,NY = size of flux array is NX*NY
C NV    = size of velocity array is NV*NV
C NL = max. number of different atom species
C NLA = actual number of different atom species in each layer
C NLAY= actual number of different layers
C WEIGHTDE = 1 DAV, DDAV, weighted with close enc prob.
C           -1 unweighted
C            0 unknown
C              when WEIGHTDE= -1 DAV,DDAV are only stored for L=1
C              else they are stored for L=1,NLA(KL)
C SKIP TO BEGINNING OF RECORD AND RETURN PARAMETERS NBIN ETC.
C ALWAYS CHECK PARAMETER IER AFTER RETURN
C IER=0: RECORD FOUND, DATA VALID
C IER=-1: END OF FILE

      PARAMETER(NLAYER=6)
      CHARACTER*5 SEPARATR
      CHARACTER*64 DIMDAT
      INTEGER NLB(NLAYER)
      INTEGER k, j
  70  FORMAT(A5,A64)
C SEARCH FOR RECORD SEPARATOR, LINE STARTING WITH |===|
   1  READ(LU,70,END=998,ERR=999,IOSTAT=IOS) SEPARATR,DIMDAT
      IF(SEPARATR.NE.'|===|')GOTO 1
      do 2 j=1,64
      if(DIMDAT(j:j).lt.' ')DIMDAT(j:j)=' '
   2  continue
      READ(DIMDAT,73)NBIN,NBINF,NX,NY,NL,NV,WEIGHTDE,(NLB(k),k=1,NLAYER)
  73  FORMAT(6I5,7I3)
      NLAY=1
      NLA(1)=NL
      do 80 NB=1,NLAYER
      if(NLB(NB).gt.0)then
        NLA(NB)=NLB(NB)
        NLAY=NB
      else
        goto 81
      endif
   80 continue
   81 continue
      IER=0
      RETURN
  998 IER=-1
      RETURN
  999 IER=-2
      WRITE(6,*)'FINDFLX: IO-error, IOSTAT=', ios
      END
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE  GETFLX
      SUBROUTINE GETFLX(LU,NBIN,NX,NY,NV,NL,NLA,NLAY,IWEIGHT,
     +                  FLKOP,RAAK,DAV,DDAV,FLUX,VELO)
C READ FLUX FILE FROM LOGICAL UNIT LU
C CALL FINDFLX BEFOREHAND
C SUBROUTINE CALLED: READ7
C
C parameters as in FINDFLX.
C Note that NL is only used for specification of array dimensions
C The actually used numbers of constituents are in NLA()
C See also the corresponding subroutine PUTFLX

      INTEGER NLA(NLAY)
      CHARACTER*160 FLKOP
      DIMENSION RAAK(0:NBIN-1,NL,NLAY),DAV(0:NBIN-1,NL),
     + DDAV(0:NBIN-1,NL),FLUX(NX,NY),VELO(NV,NV)
C

c for testing: echo some input parameters
*     write(6,*) ' entering getflx'
*     write(6,34) LU,NBIN,NX,NY,NV,NL,NLAY
*     write(6,34) (NLA(L),L=1,NLAY)
* 34  FORMAT(8I8)    

 100  FORMAT(A160)
      READ(LU,100)FLKOP

      NLAMAX=0

      DO 72 K=1,NLAY
      IF(NLA(K).GT.NLAMAX)NLAMAX=NLA(K)
  72  CONTINUE

      IF(NLAMAX.eq.0)NLAMAX=NL

      DO 74 L=1,NLAMAX
      DO 75 KL=1,NLAY
      CALL READ7(LU,RAAK(0,L,KL),NBIN)
  75  CONTINUE
      IF(IWEIGHT.LT.0 .AND. L.GT.1)GOTO 74
      CALL READ7(LU,DAV(0,L) ,NBIN)
      CALL READ7(LU,DDAV(0,L),NBIN)
  74  CONTINUE

      CALL READ7(LU,FLUX,NX*NY)
      CALL READ7(LU,VELO,NV*NV)
      END
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE SKIPFLX
      SUBROUTINE SKIPFLX(LU,KSEQ,NBIN,NRK,NX,NY,NV,NL,NLA,NLAY,
     + IWGHT,IER)
       INTEGER NLA(*)
C FIRST SKIP KSEQ-1 RECORDS, THEN
C SKIP TO BEGINNING OF RECORD AND RETURN PARAMETERS NBIN ETC.
C THUS IT IS EQUIVALENT TO KSEQ CONSECUTIVE CALLS OF FINDFLX
C ALWAYS CHECK PARAMETER IER AFTER RETURN
C IER=0: RECORD FOUND, DATA VALID
C IER=-1: END OF FILE
      DO 770 K=1,KSEQ
      CALL FINDFLX(LU,NBIN,NRK,NX,NY,NV,NL,NLA,NLAY,IWGHT,IER)
      IF(IER .LT. 0) RETURN
 770  CONTINUE
      END
