      subroutine GETNUM(RE,INT,LINE,LEN,IPT,ITERM,IER)
      implicit NONE

      real RE
      integer INT
      character*(*) LINE
      integer LEN
      integer IPT
      integer ITERM
      integer IER

C decode a number from the ascii text 'LINE' of length 'LEN'
C IPT is the current pointer into 'LINE'
C     it should be a variable (not a constant) set to 0 before
C     the first call
C ITERM is terminating character
C IER is status flag
C     0 : O.K.
C     1 : error in number
C     2 : non-numeric character before any digits
C     3 : LINE exhausted, no number decoded
C The number decoded is returned in RE as well as INT

      character*1 sym
      integer digit
      integer sign
      integer nfrac
      integer i
      logical empty
      double precision result, fraction
      result=0.0D0
      fraction=0.0D0
      sign=1
      nfrac=0
      ITERM=0
      empty= .TRUE.

c skip leading spaces
 22   IPT = 1+IPT
      if (IPT .gt. LEN) then
        IER= 3
        RETURN
      endif
      sym = LINE(IPT:IPT)
      if (sym .le. ' '  .and.  IPT .lt. LEN) then
        ITERM= ichar(sym)
        goto 22
      endif

c check for sign
      if (sym .eq. '-') then
        sign= -1
        IPT = 1+IPT
      else if(sym .eq. '+') then
        IPT = 1+IPT
      endif

c expect digits
  33  continue
      if (IPT .gt. LEN) then
        goto 67
      endif
      sym = LINE(IPT:IPT)
      digit = ICHAR(sym) - ICHAR('0')
      if (digit.ge.0 .and. digit.le.9) then
        result= result*10.0 + digit
        IPT = IPT+1
        empty= .FALSE.
        goto 33
      endif

c inspect terminating symbol
c finished if not '.'
      if(sym .ne. '.') goto 66

c process fraction
  44  IPT= IPT+1
      if (IPT .gt. LEN) then
        goto 50
      endif
      sym = LINE(IPT:IPT)
      digit = ICHAR(sym) - ICHAR('0')
      if (digit.ge.0 .and. digit.le.9) then
        fraction= fraction*10 + digit
        nfrac= nfrac+1
        empty= .FALSE.
        goto 44
      endif
  50  do 55 i=1, nfrac
      fraction= 0.1D0 * fraction
  55  enddo
      result = fraction + result

  66  continue
  67  continue
      IER=0
      if(empty) IER=2
      if (sign .lt. 0) result = -result
      RE = real(result)
      INT = nint(result)
      ITERM = ichar(sym)
      end

      integer function INTCHAR(text)
      implicit NONE
      character*(*) text
C simple version. only integers. no error checking
      real RE
      integer INTF
      integer LENG
      integer IPT
      integer ITERM
      integer IER

      LENG= LEN(text)
      IPT=0
      INTF=0
      call GETNUM(RE,INTF,text,LENG,IPT,ITERM,IER)
      INTCHAR = INTF
      end
