C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ LINEAR LEAST SQUARES PACKAGE
      SUBROUTINE HFTI(A,MDA,M,N,B,MDB,NB,TAU,KRANK,RNORM,H,G,IP)
C usage: see LAWSON AND HANSON 'SOLVING LEAST SQUARES PROBLEMS',1974.
      DIMENSION A(MDA,N+1),B(MDB,NB),H(N),G(N),RNORM(NB),IP(N)
      DOUBLE PRECISION SM,DZERO
      DZERO=0.0D0
      FACTOR=0.001
      K=0
      LDIAG=MIN0(M,N)
      IF(LDIAG.LE.0)GOTO 270
      DO 80J=1,LDIAG
      IF(J.EQ.1)GOTO 20
      LMAX=J
      DO 10 L=J,N
      H(L)=H(L)-A(J-1,L)**2
      IF(H(L).GT.H(LMAX))LMAX=L
10    CONTINUE
      IF(DIFF(HMAX+FACTOR*H(LMAX),HMAX))20,20,50
20    LMAX=J
      DO 40 L=J,N
      H(L)=0.0
      DO 30 I=J,M
30    H(L)=H(L)+A(I,L)**2
      IF(H(L).GT.H(LMAX))LMAX=L
40    CONTINUE
      HMAX=H(LMAX)
50    CONTINUE
      IP(J)=LMAX
      IF(IP(J).EQ.J)GOTO70
      DO 60 I=1,M
      TMP=A(I,J)
      A(I,J)=A(I,LMAX)
60    A(I,LMAX)=TMP
      H(LMAX)=H(J)
70    CALL H12(1,J,J+1,M,A(1,J),1,H(J),A(1,J+1),1,MDA,N-J)
80    CALL H12(2,J,J+1,M,A(1,J),1,H(J),B(1,1),1,MDB,NB)
      DO 90 J=1,LDIAG
      IF(ABS(A(J,J)).LE.TAU)GOTO 100
90    CONTINUE
      K=LDIAG
      GOTO 110
100   K=J-1
110   KP1=K+1
      IF(NB.LE.0)GOTO 140
      DO 130 JB=1,NB
      TMP=0.0
      IF(KP1.GT.M)GOTO 130
      DO 120 I=KP1,M
120   TMP=TMP+B(I,JB)**2
130   RNORM(JB)=SQRT(TMP)
140   CONTINUE
C SPECIAL FOR PSEUDORANK 0
      IF (K.GT.0)GOTO 160
      IF (NB.LE.0)GOTO 270
      DO 150 JB=1,NB
      DO 150 I=1,N
150   B(I,JB)=0.0
      GOTO 270
160   IF(K.EQ.N)GOTO 180
      DO 170 II=1,K
      I=KP1-II
170   CALL H12(1,I,KP1,N,A(I,1),MDA,G(I),A(1,1),MDA,1,I-1)
180   CONTINUE
      IF(NB.LE.0)GOTO 270
      DO 260 JB=1,NB
      DO 210 L=1,K
      SM=DZERO
      I=KP1-L
      IF(I.EQ.K)GOTO 200
      IP1=I+1
      DO 190 J=IP1,K
190   SM=SM+A(I,J)*DBLE(B(J,JB))
200   SM1=SM
210   B(I,JB)=(B(I,JB)-SM1)/A(I,I)
      IF(K.EQ.N)GOTO 240
      DO 220 J=KP1,N
220   B(J,JB)=0.0
      DO 230 I=1,K
230   CALL H12(2,I,KP1,N,A(I,1),MDA,G(I),B(1,JB),1,MDB,1)
240   DO 250 JJ=1,LDIAG
      J=LDIAG+1-JJ
      IF(IP(J).EQ.J)GOTO 250
      L=IP(J)
      TMP=B(L,JB)
      B(L,JB)=B(J,JB)
      B(J,JB)=TMP
250   CONTINUE
260   CONTINUE
270   KRANK=K
      RETURN
      END

      SUBROUTINE H12(MODE,LPIVOT,L1,M,U,IUE,UP,C,ICE,ICV,NCV)
      DIMENSION U(IUE,M),C(100)
      DOUBLE PRECISION SM,B
      IF(0.GE.LPIVOT.OR.LPIVOT.GE.L1.OR.L1.GT.M)RETURN
      CL=ABS(U(1,LPIVOT))
      IF(MODE.EQ.2)GOTO 60
      DO 10 J=L1,M
10    CL=AMAX1(ABS(U(1,J)),CL)
      IF(CL)130,130,20
20    CLINV=1.0/CL
      SM=(DBLE(U(1,LPIVOT))*CLINV)**2
      DO 30 J=L1,M
30    SM=SM+(DBLE(U(1,J))*CLINV)**2
      SM1=SM
      CL=CL*SQRT(SM1)
      IF(U(1,LPIVOT))50,50,40
40    CL=-CL
50    UP=U(1,LPIVOT)-CL
      U(1,LPIVOT)=CL
      GOTO 70
60    IF(CL)130,130,70
70    IF(NCV.LE.0)RETURN
      B=DBLE(UP)*U(1,LPIVOT)
      IF(B)80,130,130
80    B=1.0D0/B
      I2=1-ICV+ICE*(LPIVOT-1)
      INCR=ICE*(L1-LPIVOT)
      DO 120 J=1,NCV
      I2=I2+ICV
      I3=I2+INCR
      I4=I3
      SM=C(I2)*DBLE(UP)
      DO 90 I=L1,M
      SM=SM+C(I3)*DBLE(U(1,I))
90    I3=I3+ICE
      IF(SM)100,120,100
100   SM=SM*B
      C(I2)=C(I2)+SM*DBLE(UP)
      DO 110 I=L1,M
      C(I4)=C(I4)+SM*DBLE(U(1,I))
110   I4=I4+ICE
120   CONTINUE
130   RETURN
      END

      SUBROUTINE COV(A,MDA,N,G,IP,FACTOR)
      DIMENSION A(MDA,N),G(N),IP(N)
      DOUBLE PRECISION SM
      DO 40 J=1,N
40    A(J,J)=1.0/A(J,J)
      IF(N.EQ.1)GOTO 70
      NM1=N-1
      DO 60 I=1,NM1
      IP1=I+1
      DO 60 J=IP1,N
      JM1=J-1
      SM=0.0D0
      DO 50 L=I,JM1
50    SM=SM+A(I,L)*DBLE(A(L,J))
60    A(I,J)=-SM*A(J,J)
70    DO 90 I=1,N
      DO 90 J=1,N
      SM=0.0D0
      DO 80 L=J,N
80    SM=SM+A(I,L)*DBLE(A(J,L))
90    A(I,J)=SM
      IF(N.LT.2)GOTO 160
      DO 150 II=2,N
      I=N+1-II
      IF(IP(I).EQ.I)GOTO 150
      K=IP(I)
      TMP=A(I,I)
      A(I,I)=A(K,K)
      A(K,K)=TMP
      IF(I.EQ.1)GOTO 110
      DO 100 L=2,I
      TMP=A(L-1,I)
      A(L-1,I)=A(L-1,K)
100   A(L-1,K)=TMP
110   IP1=I+1
      KM1=K-1
      IF(IP1.GT.KM1)GOTO 130
      DO 120 L=IP1,KM1
      TMP=A(I,L)
      A(I,L)=A(L,K)
120   A(L,K)=TMP
130   IF(K.EQ.N)GOTO 150
      KP1=K+1
      DO 140 L=KP1,N
      TMP=A(I,L)
      A(I,L)=A(K,L)
140   A(K,L)=TMP
150   CONTINUE
160   CONTINUE
      DO 180 I=1,N
      DO 170 K=I,N
170   A(I,K)=A(I,K)*FACTOR
      G(I)=SQRT(A(I,I))
180   CONTINUE
      RETURN
      END
