      BLOCK DATA FLUXDATA
      IMPLICIT NONE
      INCLUDE 'FLUX7.COM' 
      INTEGER SIZELCORE,SIZENCROSS,SIZEDEDX
      PARAMETER(SIZELCORE=50*ML*NLAYER*NSTOPMAX)
      PARAMETER(SIZENCROSS=(ML+1)*NLAYER)
      PARAMETER(SIZEDEDX=NLAYER*NSTOPMAX)
      DATA NLAY,NFA,NVA,NBINA,NEBINA/3*0,100,100/
      DATA NLA/NLAYER*0/
      DATA UA/NLAYER*0.0, NLAYER*0.0, NLAYER*0.0/
      DATA ANG/NANGMAX*0.0, NANGMAX*0.0,NANGMAX*0.0/
      DATA LFLX/1/
      DATA JOPTION/NOPTION*.FALSE./
      DATA ATOMFRAC/MLTOT*-1/
      DATA NLA0/NLAYER*0/
      DATA NLA1/NLTOT*0/
      DATA T0,TMIN/2*0.0/
      DATA TESQMAX/0.0/
      DATA Z1/0.0/
      DATA WEIGHTDE/0/
      DATA NSTOP/1/
      DATA ELCORE/SIZELCORE*0/
      DATA LOSS/1/
      DATA ROTM/1.0, 0.0, 0.0,  0.0, 1.0, 0.0,  0.0, 0.0, 1.0 ,
     2          1.0, 0.0, 0.0,  0.0, 1.0, 0.0,  0.0, 0.0, 1.0/
      DATA TRANSL/0.0, 0.0, 0.0,
     2            0.0, 0.0, 0.0/
      DATA ROTI/1.0, 0.0, 0.0,  0.0, 1.0, 0.0,  0.0, 0.0, 1.0 /
      DATA TRANSI/0.0, 0.0, 0.0/
      DATA ZINTERF, WINTERF/1.0E20, 0.0, 1.0E18, 0.0/
      DATA NTHICK /0/
      DATA DEDXVL, DEDXVP/SIZEDEDX*0.0, SIZEDEDX*0.0/
      DATA ZIMAX, ZIFWHM/0.0, 0.0/
      DATA CURPLANE/0.0/
      DATA CURRADIUS/NLAYER*0.0/
      DATA NCROSS/SIZENCROSS*0/
      DATA NSEED/0/
      DATA NTRX,NRUN,NANG/0,1,0/
      DATA XSD,YSD,ANGH/3*0.0/
      DATA INLU,LUN,LUOPEN/5,6,8,7,4,1,0,0,0/
      DATA BEAMX,BEAMY/0.0,0.0/
      DATA POTENTIAL /'??????????'/
      DATA AMAWBEAM,CMAWBEAM /45.0,0.707107/
      DATA CHECKONLY/0/
      END
C ------------------------------------------------ SUBROUTINE INP
      SUBROUTINE INP(unit,ier)
      IMPLICIT NONE
      integer unit,ier,natoms
      INCLUDE 'FLUX7.COM' 

C Input consists of records, consisting of a keyword, followed by
C additional input, if any.
C These records may be interspersed with comment lines, starting with
C the character #, and empty lines.
C A keyword is a character string, starting at the begin of a new line.

C keyword 'NLAYER'
C NLAYER: (1 or 2), number of layers in the repeating structure.
C The sample is supposed to consist of a structure on NLAYER layers
C that is repeated several times. Scematically, if NLAYER=2:
C  lattice1  || lattice2  ||  lattice1  ||  lattice2 ....
C The layer thicknesses and possible discontinuities at the
C interfaces are specified by keyword INTERFACE, see below.
C It is assumed that all layers of each sublattice have the same
C thickness, unless option THICKNESS is given.

C keyword 'MIXED'
C This keyword may only be given before 'LATTICE'
C Use when the sample contains a mixture of different kinds of atoms
C that occupy the same kind of sites, e.g. Si_x Ge_(1-x).
C Also useful to create a fraction of vacancies.
C Input the following information, for K=1..NLAYER
C NLA0(K): Number of constituents in the unmixed host lattice
C NLA1(L,K), L=1..NLA0(K) : Number of actual constituents for each site.
C for L=1..NLA0(K):
C   ATOMFRAC(LL,L,K), (LL=1,NLA1(L,K)) : Atomic fractions.
C         normalized to 1 for each constituent site.
C         If the sum is less then 1 the remainder will be treated as
C         vacancies. A sum > 1 or a negative fraction is illegal.
C Example: Layer 1 is GaAs, layer 2 is In_x Ga_(1-x) As
C 2         (GaAs has 2 constituents)
C  1 1      (only 1 kind of atom on the Ga sites, same for As sites)
C  0.95     (Ga atomfrac=0.95)
C  1.0      (As atomfrac=1)
C 2         (layer 2, GaAs structure has only 2 constituents)
C  2 1      (but now 2 kinds of atoms on the Ga sites)
C  0.15 0.85 (with these fractions)
C  1.0      
C          Here layer 1 has 2 constituents each with 1 kind of atom.
C                       the Ga site 0.95 occupancy, i.e. 5% vacancies.
C          Layer 2 has 2 constituents, the first occupied by 2 kinds of
C                       atoms, (fractions 0.15 and 0.85), the second by
C                       1 kind ("fraction" 1.0).
C          For a Si_x Ge_(1-x) layer with x=0.15 the input would be:
C 1
C  2
C  0.15 0.85 
C          (1 constituent in original lattice, 2 actual constituents)  
C
C keyword 'LATTICE'
C the following information, for K=1..NLAYER
C NAME  : Identifier of lattice type and projection, exactly as in file
C         COMBIN.FIG. Example: GAAS100.
C         If the config file is other then COMBIN.FIG precede NAME with
C         the file name followed by a ':'
C         Example: COMBI4.FIG:LINB0441
C NLA(K): Number of constituents in host lattice
C         In the MIXED case, set NLA(K) to the sum over L of NLA1(L,K),
C         see above; and in the following, first specify the data for
C         the atom type(s) at the site of the first constituent, and
C         then for the next constituent if any.
C         Thus, for the example given above NLA(1) = 2, NLA(2) = 3 ,
C         Layer 1: L=1 and L=2 correspond to the atoms Ga and As
C         Layer 2: L=1,2,3 correspond to the atoms In, Ga and As
C Z1,(Z2(L,K),L=1..NLA(K)): Z of ion and lattice atoms
C A1,(A2(L,K),L=1..NLA(K)): Mass numbers.
C DEBYE(L,K), L=1..NLA(K) : Debye temperatures.
C TEMP  : Temperature of lattice in Kelvin.
C         Note: if a negative value is input for the Debye temperature
C         it is considered to be -u1 in Angstrom units. In that case
C         TEMP is not used.
C UA(K) : Lattice constant in Angstrom
C         in general 3 lattice constants UA(K), UB(K), UC(L)
C         for hexagonal or tetragonal lattices, 2 constants: UA(K),UC(K)
C         for cubic symmetry, input 1 lattice constant UA(K)
C         (the number of lattice constants needed is given in the
C          file COMBIN.FIG of COMBI4.FIG)
C keyword 'T0'
C T0    : Initial energy of channeling particle in MeV.
C TMIN  : Minimum energy of channeling particle in MeV.
C         Ion history is no longer followed if T < TMIN

C keyword 'EFILE'
C EFILE : file name of file containing initial energy distribution
C (ZVAL(L,K),L=1,NL,K=1,NLAYER): number of valence electrons
C         This is an alternative to keyword 'T0'
C         When EFILE is specified, keyword DEDX VALENCE is not needed
C         except when keyword ENERGY DEPENDENT STOPPING is also given.

C keyword 'CFILE'
C CFILE : file name of file containing initial coordinates.
C ((ROTI(I,J),I=1,3),J=1,3): rotation matrix
C (TRANSI(I), I=1,3): XY translation vector
C         The format of the file is as output for keyword EXITCOORD.
C         keywords 'T0' and 'ANGLES' give mostly redundant information
C         but should nevertheless be given when this option is used

C keyword 'ENERGY LOSS' (optional)
C LOSS:   if LOSS > 0, energy is lost (default, ion beam studies)
C         if LOSS < 0, energy is gained (emission channeling)
C         if LOSS = 0, no electronic energy loss

C keyword 'NBIN' (optional)
C NBIN:   Number of bins to use in distributions of NEP, dE, etc.
C         versus depth. Default: NBIN=100

C keyword 'DEDX WEIGHTED' (use if RBS spectra are to be simulated)

C keyword 'DEDX UNWEIGHTED' (use for transmitted energy distribution)

C keyword 'ENERGY DEPENDENT STOPPING'
C NSTOP:  Number of energy values for which stopping parameters are
C         given. (Default is NSTOP=1, no energy dependence).
C ESTOP(I), I=1,NSTOP : those energy values, in MeV.
C         The energy values should be consecutive, highest energy first.

C keyword 'DEDX VALENCE'
C ((DEDXVL(K,M), DEDXVP(K,M)), K=1,NLAYER), M=1,NSTOP)
C          where DEDXVL : (dE/dx)_valence,local (in eV/Angstrom)
C                DEDXVP : (dE/dx)_valence,plasma      "

C keyword 'ELCORE':
C ELCORE(I,L,K,M), I=1,50, L=1,NLA(K), K=1,NLAYER, M=1,NSTOP
C    (NLA(K) as defined under 'LATTICE'):
C          50 values for deltaE(b) due to core electrons
C          for b= 2/50 step 2/50 to 2 Angstrom.
C          deltaE in eV/atom.
C  --->   If NLA(K)=2: 50 values for L=1, then 50 values for L=2.

C keyword 'ZDIST GAUSS' (One of the ZDIST keywords is required)
C ZIMAX : average depth of impurity atoms (top of the gaussian).
C ZIFWHM: FWHM of impurity distribution. ( both in Angstrom )

C keyword 'ZDIST UNIFORM'
C ZIMAX : Maximum depth.
C         A uniform impurity distribution is assumed.

C keyword 'ZDIST EXPON'
C ZIMAX : Maximum depth.
C ZIFWHM: Width of the exponential distribution (both in Angstrom).
C         C(Z) = exp (-Z/ZIFWHM) , Z=[0..ZIMAX]

C keyword 'CROSS SECTION' (optional)
C NCROSS : Number of values of (ECROSS,CROSS) for the impurity
C ECROSS(J),CROSS(J), for J=1,NCROSS : Energy (MeV) and cross section
C       The values of ECROSS must be in ascending order.
C       if NCROSS=0 : Use no cross section
C       if NCROSS<0 : Use Rutherford cross section
C --->  NCROSS(L,K), (ECROSS(J,L,K),CROSS(J,L,K),J=1..NCROSS(L),
C       for L=1,NLA(K), for K=1,NLAYER
C      i.e. the same type of information for the host atoms
C     (NLA(K) as defined under 'LATTICE')

C keyword 'BEAM DIVERGENCE' (optional)
C XSD   : Beam standard deviation horizontal (degrees)
C YSD   :  "      "         "     vertical       "
C ANGH  : Angle of horizontal with scan direction
C        (angle of horizontal with crystal X-Z plane is PHI + ANGH)
C        default: no angular beam spread
C

C keyword 'COLLIMATE' (optional )
C AMAWBEAM: The maximum permitted angle (in degrees) between the ion
C        velocity and the beam.
C        This affects quantities for the transmitted beam only.
C        see also keyword 'MAXANGLE'
C Note:  the test is made at the end of each ion trajectory.

C keyword 'MAXANGLE' (optional )
C AMAWBEAM: The maximum permitted angle (in degrees) between the ion
C        velocity and the beam.
C        If the angle is larger the ion is considered 'lost' and not
C        further followed. 
C        This affects also the energy loss and straggling versus depth
C        if DEDX WEIGHTED is used.
C Note:  The test is made after every collision.

C keyword 'BEAMSPOT' (optional)
C BEAMX, BEAMY: size of the incident beam spot, in Angstrom units
C        Normally the incident beam spot is taken to be one unit cell.
C        With this option it may be enlarged to a size BEAMX x BEAMY.
C        The user should take care to take BEAMX and BEAMY equal to
C        an integer number of X or Y units.

C keyword 'INTERFACE' (optional)
C (All of the following information), for K=1..NLAYER:
C (The information pertains to the interface and the END of layer K)
C ZINTERF(K): Layer thickness = DEPTH (ANGSTROM) OF INTERFACE
C           (possibly overruled by keyword THICKNESS, below)
C WINTERF(K): FWHM of spread in interface depth (Angstrom)
C ((ROTM(I,J,K),I=1,3),J=1,3): rotation matrix
C (TRANSL(I,K), I=1,3): XY translation vector

C keyword 'THICKNESS' (optional)
C NTHICK : number of data that follow
C (THICK(N), N=1,NTHICK) : layer thickness in angstrom
C          Here the layers are counted consecutively, i.e. each
C          interface increases N by 1.
C Note:    this option may only be used in conjunction with 'INTERFACE'
C          but overrules the value of ZINTERF(K) given there.

C keyword 'CURVATURE' (optional)
C CURPLANE: specifies a plane perpendicular to the cylinder axis.
C           by giving angle phi of intersection with the xy plane
C (CURRADIUS(K), K=1,NLAYER): radius of curvature (Angstrom)

C keyword 'NSEED' (optional)
C ISEED : arbitrary integer for random number generator.
C         default value 0: program selects NSEED.

C keyword 'NTRACKS'
C NTRX  : Number of tracks to follow.

C keyword 'NREPEAT' (optional)
C NRUN  : Number of runs with NTRX tracks.
C       (In order to estimate uncertainties the whole calculations
C        may be split up in a number of runs).
C        default value: NRUN=1

C keyword 'ANGLES':
C NANG  : Number of incident angles
C ANG(1,K),ANG(2,K), FOR K=1,NANG : THETA and PHI in degrees.
C    If PHI>360 is given, the program will select a random PHI for
C    every track.
C
C keyword 'ANGLES_P':
C NANG  : Number of incident angles
C THETA0, PHI0, TILT, FOR K=1,NANG : THETA0, PHI0, TILT in degrees.
C This is an alternative to keyword 'ANGLES'.
C The ion beam is tilted by an angle TILT away from the plane
C defined by PHI0. The plane through the ion beam and the direction
C (THETA0, PHI0) is perpendicular to the plane defined by PHI0.
C 
C OUTPUT OPTIONS
C The energy loss and straggling distributions are always output,
C but one  of the keywords DEDX WEIGHTED or DEDX UNWEIGHTED
C must be specified. Other distributions, including the flux (!)
C are only output when requested.

C keyword 'FLUX' (optional)
C NF:   flux distribution is accumulated in a NF*NF array
C       The following only if NLAYER > 1:
C LFLX: Layer number for which flux distribution is accumulated.

C keyword 'VFINAL' (optional)
C NV: final velocity vector distribution accumulated in NV*NV array
C ANGPMDG: angular range at exit of sample (in degrees)

C keyword 'NCHAN' (optional)
C CRITXDG: Critical angle (x 'component')
C CRITYDG: Critical angle (y 'component')
C          These values are only used to calculate the number of
C          'channeled' particles as a funtion of depthi, i.e.
C          particles within the angular range specified. 
C          Needless to say this is not a good criterion for
C          'channeling' (should be based on transverse kinetic +
C          *potential* energy).

C keyword 'EFINAL' (optional)
C TFMIN, TFMAX: (MeV) min and max of range of final energy,
C             used in energy distribution of exiting ions
C

C keyword 'XYOUT' (optional)
C IXYOUT: XY coordinates are output every IXYOUT collisions
C         when option XYOUT is selected.
C  Note: with this option the output is excessively large
C        don't use it with more then a few hundred tracks

C keyword 'SCORE' (optional)
C         output the effective values of the contributions of the
C         core electrons and the valence electrons as a function of depth
C keyword 'EXITCOORD' (optional)
C         output the values of x,y (Angstrom) px, py (direction cosines)
C         and final energy (MeV) at the end of each track

C keyword 'STARTCOORD' (optional)
C         output the values of x,y (Angstrom) px, py (direction cosines)
C         and final energy (MeV) at the beginning of each track

C keyword 'EOI' (optional)
C         end of input. Default: end of file indicates end of input
**********************************************************************

      character*16 keyword

      INTEGER LU1, LU2, KL, I,J,K,L,M,N, IAUTO, NLAP, L1,L2
      REAL AIMP, THIMP, TMPSUM

      REWIND unit
      ier=0
      LU1=1
      LU2=1
      if(LUOPEN(2).eq.1)LU2=2
      keyword=' '

      MLA=NL

c read next keyword                         
  10  continue
      read(unit,'(A16)',err=558,end=100)keyword
      if(keyword(1:1).eq.'#' .or. keyword.le.' ')goto 10
      call UPCASE(keyword)
      write(6,11) keyword
   11 format(' keyword read:', A)

      if(keyword.eq.'NLAYER')then
        read(unit,*,err=555,end=557)NLAY
        if(NLAY.gt.NLAYER)then
           write(6,*)'error: illegal value for NLAYER', NLAY
           ier=ier+1
           goto 100
        endif
        goto 10
      endif

      if(keyword.eq.'MIXED')then
        if(NLAY.le.0)then
           write(6,*)'error: NLAYER must precede option MIXED'
           ier=ier+1
           goto 100
        endif
        if(NLA(1).ne.0)then
           write(6,*)'error: MIXED must precede option LATTICE'
           ier=ier+1
           goto 100
        endif
        JOPTION(LMIXED)=.TRUE.
        do 330 KL=1,NLAY
        read(unit,*,err=555,end=557)
     1    NLA0(KL),
     2    (NLA1(L,KL),L=1,NLA0(KL))
        L2=0
        do 345 L=1,NLA0(KL)
          TMPSUM=0
          read(unit,*,err=555,end=557)
     3    (ATOMFRAC(L2+L1,KL),L1=1,NLA1(L,KL))
          do 377 L1=1, NLA1(L,KL)
          if (ATOMFRAC(L1+L2,KL).lt.0) then
            write(6,*)'error: negative atom fraction',ATOMFRAC(L1+L2,KL)
            ier=ier+1
          endif
          TMPSUM= TMPSUM + ATOMFRAC(L1+L2,KL)
  377     continue
          if (TMPSUM .gt. 1.001) then
            write(6,*)'error: total of atom fractions is > 1 !!'
            ier=ier+1
          endif
          L2=L2+NLA1(L,KL)
  345   continue
  330   continue
        goto 10
      endif

      if(keyword.eq.'LATTICE')then
        natoms=0
        if(NLAY.le.0)then
           write(6,*)'error: NLAYER must precede option LATTICE'
           ier=ier+1
           goto 100
        endif
        do 250 KL=1,NLAY
  371   read(unit,372) COMFIGNAME(KL)
        if(COMFIGNAME(KL).le.' '.or.COMFIGNAME(KL)(1:1).eq.'#')goto 371
  372   FORMAT(A)
        call COMBIFIG(KL,0)
        read(unit,*,err=555,end=557)NLA(KL)
        NLAP=NLA(KL)
        if( JOPTION(LMIXED) ) then
          NLAP= 0
          do 354 L=1,NLA0(KL)
          if(NLA0(KL).gt.NLS(KL))then
            write(6,*)'error: nr of atom species:',NLA0(KL),
     +      ' exceeds value read from COMBIN.FIG:',NLS(KL)
           ier=ier+1
          endif
          DO 420 L2=1,NLA1(L,KL)
          NLAP=NLAP+1
  420     CONTINUE
  354     continue
          if(NLAP .ne. NLA(KL)) then
            write(6,*)'error: inconsistent values for NLA',NLAP, NLA(KL)
            ier=ier+1
          endif
        else
          NLA0(KL)=NLA(KL)
          if(NLA0(KL).gt.NLS(KL))then
            write(6,*)'error: nr of atom species:',NLA0(KL),
     +      ' exceeds value read from COMBIN.FIG:',NLS(KL)
            ier=ier+1
          endif
          do 404 L=1,NLA0(KL)
            NLA1(L,KL)=1
  404     continue
        endif
        if(NLAP.gt.natoms)natoms=NLAP
        if(NLAP.gt.MLA)then
           write(6,*)'error: too large value for NLA', NLA(KL)
           ier=ier+1
           goto 100
        endif
C NLC is number of lattice constants (1 for cubic, 2 for hexagonal)
        if(CSYMM(KL).eq. 'hexagonal' .or. CSYMM(KL).eq. 'tetragonal')
     +   then
          NLC(KL)= 2
         else if(NLC(KL).ne.1 .and. NLC(KL).ne.3)then
         write(6,*)'error: illegal value for NLC in comfig file',NLC(KL)
           ier=ier+1
           goto 100
         endif
        read(unit,*,err=555,end=557)
     +   Z1,(Z2(L,KL),L=1,NLA(KL)),
     +   A1,(A2(L,KL),L=1,NLA(KL)),
     +   (DEBYE(L,KL),L=1,NLA(KL)),
     +   TEMP,
     +   (UA(L,KL),L=1,NLC(KL))
  250   continue
        MLA=natoms
        write(6,*)'number of different atoms:', natoms
        goto 10
      endif

      if(keyword.eq.'T0')then
        read(unit,*,err=555,end=557)T0,TMIN
      else if(keyword.eq.'EFILE')then
        read(unit,'(A70)',err=555,end=557)EFILE
        if(NLA(1).eq.0)then
           write(6,*)'error: option LATTICE must precede EFILE'
           ier=ier+1
        endif
        read(unit,*,err=555,end=557)((ZVAL(L,K),L=1,NLA(K)),K=1,NLAY)
        JOPTION(LFEFILE)=.TRUE.
      else if(keyword.eq.'CFILE')then
        read(unit,'(A70)',err=555,end=557)CFILE
        read(unit,*,err=555,end=557)
     +    ((ROTI(I,J),I=1,3),J=1,3),(TRANSI(I),I=1,3)
        JOPTION(LFCFILE)=.TRUE.
      else if(keyword.eq.'ENERGY LOSS')then
        read(unit,*,err=555,end=557)LOSS
      else if(keyword.eq.'NBIN')then
        read(unit,*,err=555,end=557)NBINA
        NEBINA=NBINA
        if(NBINA.gt.NBIN)then
          write(6,*)'error: NBIN too large, max =',NBIN
          ier=ier+1
        endif
      else if(keyword.eq.'DEDX WEIGHTED')then
        WEIGHTDE=1
      else if(keyword.eq.'DEDX UNWEIGHTED')then
        WEIGHTDE=-1
      else if(keyword.eq.'ENERGY DEPENDENT')then
        read(unit,*,err=555,end=557) NSTOP
        if(NSTOP.le.0)then
          write(6,*)'error: NSTOP (=',NSTOP,') not positive'
          ier=ier+1
        endif
        if(NSTOP.gt.NSTOPMAX)then
          write(6,*)'error: NSTOP too large, max =',NSTOPMAX
          ier=ier+1
          goto 555
        endif
        read(unit,*,err=555,end=557) (ESTOP(I), I=1,NSTOP)
      else if(keyword.eq.'DEDX VALENCE')then
        read(unit,*,err=555,end=557)((DEDXVL(K,M), DEDXVP(K,M),
     +                               K=1,NLAY),M=1,NSTOP)
      else if(keyword.eq.'ELCORE')then
        if(NLA(1).eq.0)then
           write(6,*)'error: option LATTICE must precede ELCORE'
           ier=ier+1
        endif
        read(unit,*,err=555,end=557)
     +  ((((ELCORE(J,L,K,M),J=1,50),L=1,NLA(K)),K=1,NLAY),M=1,NSTOP)
      else if(keyword.eq.'ZDIST UNIFORM')then
        read(unit,*,err=555,end=557)ZIMAX
        ZIFWHM=0
      else if(keyword.eq.'ZDIST GAUSS')then
        read(unit,*,err=555,end=557)ZIMAX,ZIFWHM
      else if(keyword.eq.'ZDIST EXPON')then
        read(unit,*,err=555,end=557)ZIMAX,ZIFWHM
        if(ZIFWHM.gt.0)ZIFWHM = -ZIFWHM
      else if(keyword.eq.'CROSS SECTION')then
        read(unit,*,err=555,end=557)
     +     NCROSS(0,1),(ECROSS(J,0,1),CROSS(J,0,1),J=1,NCROSS(0,1))
        read(unit,*,err=555,end=557)
     +   ((NCROSS(L,K),(ECROSS(J,L,K),CROSS(J,L,K),J=1,NCROSS(L,K)),
     +     L=1,NLA(K)),K=1,NLAY)
      else if(keyword.eq.'BEAM DIVERGENCE')then
        read(unit,*,err=555,end=557)XSD,YSD,ANGH
      else if(keyword.eq.'NSEED')then
        read(unit,*,err=555,end=557)NSEED
      else if(keyword.eq.'NTRACKS')then
        read(unit,*,err=555,end=557)NTRX
      else if(keyword.eq.'NREPEAT')then
        read(unit,*,err=555,end=557)NRUN
      else if(keyword.eq.'EXITCOORD')then
        JOPTION(LEXITCO)=.TRUE.
      else if(keyword.eq.'STARTCOORD')then
        JOPTION(LSTARTCO)=.TRUE.
      else if(keyword.eq.'ANGLES')then
        read(unit,*,err=555,end=557)NANG,(ANG(1,K),ANG(2,K),K=1,NANG)
      else if(keyword.eq.'ANGLES_P')then
        read(unit,*,err=555,end=557)NANG,(ANG(1,K),ANG(2,K),ANG(3,K),
     +   K=1,NANG)
      else if(keyword.eq.'XYOUT')then
        read(unit,*,err=555,end=557)IXYOUT
        JOPTION(LFXYOUT)=.TRUE.
      else if(keyword.eq.'FLUX')then
        if(NLAY.eq.1)then
          LFLX=1
          read(unit,*,err=555,end=557)NFA
        else
          read(unit,*,err=555,end=557)NFA,LFLX
        endif
        if(NFA.gt.NF)then
          write(6,*)'error: NF too large, max =',NF
          ier=ier+1
        endif
        if(LFLX.gt.NLAY)then
          write(6,*)'error: LFLX larger than number of layers'
          ier=ier+1
        endif
        JOPTION(LFFLUX)=.TRUE.
      else if(keyword.eq.'VFINAL')then
        read(unit,*,err=555,end=557)NVA,ANGPMDG
        if(NVA.gt.NV)then
          write(6,*)'error: NV too large, max =',NV
          ier=ier+1
        endif
        JOPTION(LFVELO)=.TRUE.
      else if(keyword.eq.'INTERFACE')then
        read(unit,*,err=555,end=557)
     +   (ZINTERF(K),WINTERF(K),
     +    ((ROTM(I,J,K),I=1,3),J=1,3),(TRANSL(I,K),I=1,3),K=1,NLAY)
      else if(keyword .eq. 'THICKNESS')then
        read(unit,*,err=555,end=557) NTHICK
        if(NTHICK .gt. NTHICKMAX)then
          write(6,*)'too many layers, increase NTHICKMAX'
          ier=ier+1
        else
          read(unit,*,err=555,end=557) (THICK(N), N=1,NTHICK)
        endif
      else if(keyword.eq.'CURVATURE')then
        read(unit,*,err=555,end=557)
     +   CURPLANE, (CURRADIUS(K),K=1,NLAY)
      else if(keyword.eq.'BEAMSPOT')then
        read(unit,*,err=555,end=557)BEAMX, BEAMY
      else if(keyword.eq.'COLLIMATE')then
        read(unit,*,err=555,end=557)AMAWBEAM
        JOPTION(LFCOLLI)=.TRUE.
      else if(keyword.eq.'MAXANGLE')then
        read(unit,*,err=555,end=557)AMAWBEAM
        JOPTION(LFMAXAN)=.TRUE.
      else if(keyword.eq.'EFINAL')then
        read(unit,*,err=555,end=557)TFMIN,TFMAX
        JOPTION(LFEFINAL)=.TRUE.
      else if(keyword.eq.'NCHAN')then
        read(unit,*,err=555,end=557)CRITXDG,CRITYDG
        JOPTION(LFNCHAN)=.TRUE.
      else if(keyword.eq.'SCORE')then
        JOPTION(LFSCORE)=.TRUE.
      else if(keyword.eq.'IMPURITY')then
        read(unit,*,err=555,end=557)AIMP,THIMP,IAUTO
      else if(keyword.eq.'EOI') then
        goto 100
      else
        write(6,*) 'error: unrecognized keyword ',keyword
        ier=ier+1
      endif
      goto 10

  100 continue

      do 368 N=1,NTHICK
      if (N .le. NLAYER) ZINTERF(N)= THICK(N)
  368 continue

      if(T0.LE.0 .and.
     + (.not. JOPTION(LFEFILE)))then
        write(6,*) 'error: no T0 given'
        ier=ier+1
      endif
      if(NLA(1) .le. 0) then
        write(6,*) 'error: no LATTICE specified'
        ier=ier+1
      endif
      if(NBINA .le. 0)then
        write(6,*) 'error: illegal value for NBIN'
        ier=ier+1
      endif
      if(NTRX .le. 0) then
        write(6,*) 'error: no trajectories requested'
        ier=ier+1
      endif
      if(NANG .le. 0) then
        write(6,*) 'error: no ANGLES given'
        ier=ier+1
      endif
      if(ZIMAX .eq. 0 .and. ZIFWHM.eq.0) then
        write(6,*) 'error: no ZDIST given'
        ier=ier+1
      endif
      if(WEIGHTDE .eq. 0)then
        write(6,*) 'error: no DEDX WEIGHTED / UNWEIGHTED given'
        ier=ier+1
      endif

      RETURN
C     PANIC STOPS:
  555 write(6,*) 'read ERROR in subroutine INP'
      goto 599
  557 write(6,*) 'UNEXPECTED END OF FILE in subroutine INP'
      goto 599
  558 write(6,*) 'read ERROR in keyword, subroutine INP'
      goto 599
  599 write(6,'(''current keyword:'',A16)')keyword
      stop
      END
