C machine dependent file OPEN manipulations.

      INTEGER FUNCTION LFOPEN(unit,filename,oldnew,position,erswitch)
      IMPLICIT NONE

      INTEGER unit
      CHARACTER*(*) filename
      CHARACTER*(*) oldnew
      INTEGER position, erswitch

C oldnew   (input) should contain 'OLD' or 'NEW' or 'UNKNOWN'
C position (input) should be 0 (begin of file) or 1 (append).
C erswitch (input) should be 0 (stop on error) or 1 (return iostat).
C 
C The file access mode is assumed to be sequential.

      INTEGER lfopenstat
      CHARACTER*10 ac
      ac = 'SEQUENTIAL'

C for Fortran implementations that support "access='APPEND':

      IF(position .ne. 0 .and. oldnew .ne. 'NEW') ac= 'APPEND'

      IF(erswitch .eq.0)THEN
        OPEN(unit,FILE=filename,ACCESS=ac,STATUS=oldnew,
     +   IOSTAT=lfopenstat, ERR=222)
      ELSE
        OPEN(unit,FILE=filename,ACCESS=ac,STATUS=oldnew,
     +   IOSTAT=lfopenstat, ERR=999)
      ENDIF

C when access='APPEND' is not implemented try the following:
*C read till end of file
*      IF(position .ne. 0) THEN
*  33    READ(unit,'(A1)',END=66)ac
*        GOTO 33
*  66    CONTINUE
*C Some implementations may require a backspace statement here
*C (but on others it may have a disastrous effect)
*C       BACKSPACE unit
*      ENDIF

 999  LFOPEN= lfopenstat
      RETURN
 222  CONTINUE
      write(6,224) unit,filename,ac,oldnew,lfopenstat
 224  format('LFOPEN error unit=',I3, ', file=',A,
     + /,'ACCESS=',A10,', STATUS=',A7,', IOSTAT=',I4)
      STOP
      END
