C -------------------------------------------------- SUBROUTINE OUTP1
      SUBROUTINE OUTP1
C OUTPUT INPUT DATA AND RELATED QUANTITIES. CALLED ONLY ONCE.
      IMPLICIT NONE
      INCLUDE 'FLUX7.COM' 

      CHARACTER*20 TIME
      REAL PLI(3)
      CHARACTER*16 OPTION(NOPTION)
      INTEGER I,J,K,KK,IL,L,LC,IZ,NTH,M
      REAL PSI1,TH,DELZ,RNDELZ,RANGE,COSPHI,SINPHI,CD,CURDP
      REAL THETA,PHI,PLIJ,YMAX
      REAL ARCCOS,ZZE2D,AVXSQ
      EXTERNAL ARCCOS,ZZE2D,AVXSQ

      DATA OPTION /'flux distr',
     2             'velocity distr',
     3             'Nchan vs depth',
     4             'dE core/valence',
     5             'dE collimated',
     6             'E_final',
     7             'xy coordinates',
     8             'E_initial file',
     9             'exit coordinates',
     A             'x,p initial file',
     B             'start coordinate',
     C             'mixed lattice',
     D             'max angle'/
c     PARAMETER(LFFLUX=1, LFVELO=2, LFNCHAN=3, LFSCORE=4,
c    + LFCOLLI=5, LFEFINAL=6, LFXYOUT=7)

      CALL SYSTIM(TIME)

      DO 100 L=1,3
      if(LUOPEN(L).ne.1)goto 100
      WRITE(LUN(L),1)VERSION,TIME
  1   FORMAT(//' PROGRAM FLUX ',4X,A28,4X,A20)
      WRITE(LUN(L),127)POTENTIAL
  127 FORMAT(//,' Using the ',A,'potential',//)
C
      IF(NSTART.GT.1)THEN
         if(NSTART.le.NANG)then
           WRITE(LUN(L),113)
     +      NSTART,ANG(1,NSTART), ANG(2,NSTART), ANG(3,NSTART)
  113      FORMAT(' restart from point',I4,', angles:',3F8.3)
         endif
         if(L.gt.1)goto 99
      ENDIF
      IF (LOSS.GT.0) THEN
        WRITE(LUN(L),20)
      ELSE IF (LOSS.LT.0)THEN
        WRITE(LUN(L),22)
      ELSE
        WRITE(LUN(L),25)
      END IF
  20  FORMAT(/' INCIDENT PARTICLE (ION BEAM CHANNELING VERSION)')
  22  FORMAT(/' OUTGOING PARTICLE (EMISSION CHANNELING VERSION)')
  25  FORMAT(/' INCIDENT PARTICLE (NO ELECTRONIC E-LOSS VERSION)')
      IF(JOPTION(LFEFILE))THEN
        WRITE(LUN(L),65)'AVERAGE ENERGY (MeV)',T0, ' from spectrum:',
     +   EFILE
      ELSE IF(JOPTION(LFCFILE))THEN
        WRITE(LUN(L),'(1X,A,A25)')
     +  'Initial coordinates and energies from file:', CFILE
      ELSE
         WRITE(LUN(L),66)'ENERGY (MeV)',T0
      ENDIF
      WRITE(LUN(L),66)'ATOMIC NUMBER',Z1,'MASS NUMBER',A1
      DO 700 K=1,NLAY
      WRITE(LUN(L),3)K, COMFIGNAME(K)
  3   FORMAT(/' LATTICE, LAYER ',I1,26X,A24)
      DO 75 M=1, NLA(K)
      WRITE(LUN(L),68)M,'ATOMIC NUMBER',Z2(M,K),'MASS NUMBER',A2(M,K)
  75  CONTINUE
      IF(JOPTION(LMIXED))THEN
        DO 777 M=1, NLA(K)
        WRITE(LUN(L),68)M,'ATOMIC FRACTION',ATOMFRAC(M,K)
 777    CONTINUE
      ENDIF
      WRITE(LUN(L),67)'LATTICE CONSTANTS (ANGSTR)',
     + (UA(LC,K), LC=1,NLC(K))
      WRITE(LUN(L),66)'DEPTH STEP (ANGSTR)',UD(K),'TEMPERATURE',TEMP
      WRITE(LUN(L),66)'DEBYE TEMPERATURE, 1',DEBYE(1,K),'2',DEBYE(2,K)
      DO 81 M=1, NLA(K)
      WRITE(LUN(L),68)M,'SCREENING RADIUS',RSCREEN(M,K),
     +           'THERMAL VIBR. AMPL. U2',U2(M,K)
  81  CONTINUE
      WRITE(LUN(L),66)'(DE/DX)V,L(eV/A)',DEDXVL(K,1),
     + '(DE/DX)V,P',DEDXVP(K,1)
      DO 92 M=1, NLA(K)
      PSI1 = SQRT( 2.0*ZZD2(M,K)/T0 ) / DEGREE
      WRITE(LUN(L),68)M,'CRITICAL ANGLE',PSI1,
     + 'ZZD(eV)',ZZD2(M,K)*1.0E6
  92  CONTINUE
      WRITE(LUN(L),66)'XUN (ANGSTROM)',XUN(K),'YUN (ANGSTROM)',YUN(K)
      IF(K .eq.LFLX)THEN
        IF(JOPTION(LFFLUX))THEN
          WRITE(LUN(L),71)
   71     FORMAT(/' FLUX CALCULATED FOR THIS LAYER')
        ENDIF
        WRITE(LUN(L),66)'BIN WIDTH X',XUN(LFLX)/NFX,
     +   'BIN WIDTH Y',YUN(LFLX)/NFY
      ENDIF
 700  CONTINUE
      WRITE(LUN(L),66)'max angle',ARCCOS(SQRT(TESQMAX))/DEGREE
      WRITE(LUN(L),4)
  4   FORMAT(/' IMPURITY DISTRIBUTION')
      WRITE(LUN(L),66)'MAXIMUM (ANGSTR)',ZIMAX,'FWHM',ZIFWHM
      WRITE(LUN(L),66)'MAXIMUM RANGE',ZMAX+ZIMAX
      IF(ZIFWHM.NE.0)THEN
        YMAX=0
        DO 111 IZ=0,NBINF-1
        IF(PROFIEL(IZ).GT.YMAX)YMAX=PROFIEL(IZ)
  111   CONTINUE
        IF(YMAX.EQ.0)YMAX=1.0
        WRITE(LUN(L),42) (PROFIEL(IZ)/YMAX,IZ=0,NBINF-1)
  42      FORMAT(/' DEPTH PROFILE:'/,(10F8.3))
      ELSE
        WRITE(LUN(L),421)
  421     FORMAT(' DEPTH DISTRIBUTION UNIFORM')
      ENDIF
      IF (NCROSS(0,1).LT.0) THEN
        WRITE(LUN(L),401)
      ELSE IF (NCROSS(0,1).EQ.0) THEN
        WRITE(LUN(L),402)
      ELSE
        WRITE(LUN(L),403)
        WRITE(LUN(L),66) 'ENERGY RANGE FROM',ECROSS(1,0,1),'TO',
     +                 ECROSS(NCROSS(0,1),0,1)
      ENDIF
  401 FORMAT(' IMPURITY CROSS SECTION: RUTHERFORD')
  402 FORMAT(' IMPURITY CROSS SECTION NOT TAKEN INTO ACCOUNT')
  403 FORMAT(' IMPURITY CROSS SECTION BY INTERPOLATION:')
      RNDELZ = NDELZ
      DELZ   = RNDELZ * UD(1)
      WRITE(LUN(L),41)
  41  FORMAT(/' CLOSE ENCOUNTER YIELD')
      WRITE(LUN(L),66)'DELZ (ANGSTR.)',DELZ,'DELZ (PLANES)',RNDELZ
      DO 417 K=1,NLAY
      WRITE(LUN(L),414) K
      DO 419 IL=1,NLA(K)
      IF (NCROSS(IL,K).LT.0) THEN
        WRITE(LUN(L),411) IL
      ELSE IF (NCROSS(IL,K).EQ.0) THEN
        WRITE(LUN(L),412) IL
      ELSE
        WRITE(LUN(L),413) IL
        WRITE(LUN(L),66) 'ENERGY RANGE FROM',ECROSS(1,IL,K),'TO',
     +                 ECROSS(NCROSS(IL,K),IL,K)
      ENDIF
  419 CONTINUE
  417 CONTINUE
  414 FORMAT(/'LAYER',I2)
  411 FORMAT(' ATOM SPECIES',I2,' CROSS SECTION: RUTHERFORD')
  412 FORMAT(' ATOM SPECIES',I2,' CROSS SECTION NOT TAKEN INTO ACCOUNT')
  413 FORMAT(' ATOM SPECIES',I2,' CROSS SECTION BY INTERPOLATION:')
      WRITE(LUN(L),43)
  43  FORMAT(/' BEAM DIVERGENCE')
      WRITE(LUN(L),66)'S.D. HORIZONTAL',XSD,'VERTICAL',YSD
      WRITE(LUN(L),66)'ANGLE HORIZ. - SCAN PLANE',ANGH
C
      DO 711 K=1,NLAY
      if(ZINTERF(K) .lt. ZIMAX +2.0*ABS(ZIFWHM))then
        WRITE(LUN(L),66)'INTERFACE AT DEPTH', ZINTERF(K),
     +    'WIDTH (ANGSTROM)', WINTERF(K)
  79    FORMAT(' ROTATION MATRIX'/ (3F12.5))
        WRITE(LUN(L),79) ((ROTM(I,J,K),I=1,3),J=1,3)
  792   FORMAT(' TRANSLATION VECTOR (Angstrom):',3F12.5)
        WRITE(LUN(L),792) (TRANSL(I,K),I=1,3)
      endif
  711 CONTINUE
C
      NTH= NTHICK
      IF(NTHICK.eq.0)NTH=NLAY
      K= 0
      DO 1375 KK=1,NTH
      if(K .ge. NLAY)K=0
      K= K + 1
      IF(KK .le. NLAY )THEN
        TH= ZINTERF(K)
      ELSE
        TH=THICK(KK)
      ENDIF
      RANGE = ZMAX+ZIMAX
      IF(TH .gt. RANGE) TH=RANGE
 1371 FORMAT(' Layer',I2,' thickness', F13.0, ' Angstr.')
      WRITE(LUN(L),1371)KK, TH
      IF(CURRADIUS(K).EQ.0) goto 1375
 1372 FORMAT(' Crystal is bent, in plane phi=',F12.5)
      IF(KK .le. NLAY )WRITE(LUN(L),1372)CURPLANE
C        WRITE(LUN(L),79) ((CURMATT(I,J,K),I=1,3),J=1,3)
 1374 FORMAT(' Layer',I2,' radius of curvature',F11.0, ' Angstr.',
     +  ' Total deflection is',F7.2,' deg')
      CURDP= 2.0 * ASIN(0.5*TH/CURRADIUS(K))*180.0/PI
      WRITE(LUN(L),1374) KK, CURRADIUS(K), CURDP
 1375 CONTINUE
C
      IF(JOPTION(LFCOLLI).or.JOPTION(LFMAXAN)) WRITE(LUN(L),66)
     + 'MAX. ANGLE WITH BEAM', AMAWBEAM
C
      IF(BEAMX.gt.0.0 .or. BEAMY.gt.0.0)
     +  WRITE(LUN(L),66)'Incident beam spot x=',BEAMX,'y=',BEAMY
C
      WRITE(LUN(L),5) NANG,NTRX,NSEED
  5   FORMAT(//1X,I4,' ANGLES',3X,I7,' TRACKS',5X,'ISEED=',I11)
      WRITE(LUN(L),6)((NABUR(J,K),J=1,NLS(K)),K=1,NLAY)
  6   FORMAT(/' NUMBER OF NEIGHBOUR STRINGS =',6I3)
      WRITE(LUN(L),62)
      DO 656 J= 1,NOPTION
      IF(JOPTION(J))WRITE(LUN(L),63) J,OPTION(J)
  656 CONTINUE
  62  FORMAT(1X,'SELECTED OPTIONS:')
  63  FORMAT(I4,': ',A16)
      WRITE(LUN(L),10)'theta0','phi0','tilt','theta','phi'
      do 751 K=1,NANG
      CALL THETAPHI(THETA,PHI,K)
      WRITE(LUN(L),11)ANG(1,K),ANG(2,K),ANG(3,K),THETA,PHI
  751 continue
      PHI=ANG(2,NANG)*PI/180.0
      COSPHI=COS(PHI)*
     + SQRT(FLOAT(IP(1,2,1)**2+IP(2,2,1)**2+IP(3,2,1)**2))
      SINPHI=SIN(PHI)*
     + SQRT(FLOAT(IP(1,1,1)**2+IP(2,1,1)**2+IP(3,1,1)**2))
      CD=2.0
      DO 77 J=1,3
      PLI(J)=IP(J,1,1)*COSPHI + IP(J,2,1)*SINPHI
      PLIJ=ABS(PLI(J))
      IF(PLIJ.LT.CD .AND. PLIJ.GT.0.1)CD=PLIJ
  77  CONTINUE
      DO 76 J=1,3
  76  PLI(J)=PLI(J)/CD
      WRITE(LUN(L),78) ANG(2,NANG),PLI
  78  FORMAT(/1X,'SCAN PLANE (FOR PHI=',F8.3,'): ',3F8.3)
      if(NSTART.gt.NANG)then
        write(LUN(L),*)'NSTART in file .ini larger then NANG'
      endif
  99  CALL SYNCF(LUN(L))
  100 CONTINUE
      if(NSTART.gt.NANG)then
        if(CHECKONLY.eq.0)stop 'illegal NSTART or NANG'
        write(LUN(1),*)
     +   'warning: old .ini file, renew before running flux'
      endif

  10  FORMAT(/' INCIDENT ANGLES:'/, 5A8)
  11  FORMAT(5F8.3)
  65  FORMAT(1X,A25,':',F12.5, A16,A25)
  66  FORMAT(2(1X,A25,':',F12.5))
  67  FORMAT(1X,A25,':',3F12.5)
  68  FORMAT(I8,':',A17,':',F12.5,1X,A25:,':',F12.5)

      END
