C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ FUNCTION QZ(Z)
      REAL FUNCTION QZ(Z)
      IMPLICIT NONE
      REAL Z

C usage:  R = QZ(Z)
C RETURNS QZ(Z)= INTEGRAL FROM 0 TO Z OF X/(EXP(X)-1)
C CALLED BY AVXSQ

      REAL PI, PI26
      PARAMETER(PI=3.14159265,PI26=PI**2/6.0)

      REAL Q, RJ, ZJ, T

      IF(Z .LT. 0.3)THEN
C POWER SERIES FOR SMALL Z:
          QZ=((Z/36.0 - 0.25) * Z + 1.0) * Z
      ELSE
C SERIES IN TERMS OF EXP(-J*Z) FOR LARGER Z:
          Q=PI26
          RJ=1.0
   1      ZJ=Z*RJ
          IF (ZJ .GT. 20.0) GOTO 2
          T=(ZJ + 1.0) / (EXP(ZJ) * RJ * RJ)
          Q=Q-T
          RJ=RJ+1.0
          IF (T .GT. 1.0E-8) GOTO 1
   2      QZ=Q
      ENDIF
      END
