C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINES RANMAR AND RMARIN
C provide portable random number generator of good quality
C See F.James, Computer Physics Communications 60 (1990) 329
      BLOCK DATA RMARBD
      LOGICAL INIT
      COMMON /RASET1/U(97),C,CD,CM,I97,J97,INIT
      DATA INIT / .FALSE. /
      END
C
      SUBROUTINE RANMAR(RVEC,LEN)
C Universal random number generator proposed by Marsaglia and Zaman
C in report FSU-SCRI-87-50
C slightly modified by F. James, Computer Physics Comm. 60 (1990) 329
      PARAMETER (SMALL=0.5**24, SMALLER=SMALL*0.5)
      DIMENSION RVEC(*)
      LOGICAL INIT
      COMMON /RASET1/U(97),C,CD,CM,I97,J97,INIT
      IF(.NOT.INIT)THEN
          WRITE(6,'(A)')' ***** Warning: RANMAR not initialised ! *****'
          CALL RMARIN(54217137)
      ENDIF
C
!$OMP CRITICAL
      DO 100 IVEC=1,LEN
      UNI=U(I97)-U(J97)
      IF(UNI.LT.0)UNI=UNI+1.0
      U(I97)=UNI
      I97=I97-1
      IF(I97.EQ.0)I97=97
      J97=J97-1
      IF(J97.EQ.0)J97=97
      C=C-CD
      IF(C.LT.0)C=C+CM
      UNI=UNI-C
      IF(UNI.LT.0)UNI=UNI+1.0
C the following code prevents exact zero values.
      IF(UNI.LT.SMALLER)THEN
          UNI=U(J97)*SMALL
          IF(UNI.LT.SMALLER)UNI=SMALLER
      ENDIF
      RVEC(IVEC)=UNI
  100 CONTINUE
!$OMP END CRITICAL  
      END
C
      SUBROUTINE RMARIN(IJKL)
C Initializing routine for RANMAR.
C Must be called before generating any pseudorandom number with RANMAR.
C The input value should be in the range 0<=IJKL<=900000000 (9E8).
C If it does not, it is forced into this range.
      LOGICAL INIT
      COMMON /RASET1/U(97),C,CD,CM,I97,J97,INIT
      LJKL=IJKL
      IF(LJKL.LT.0)LJKL=-LJKL
    1 IF(LJKL.GT.900000000)THEN
          LJKL=LJKL/2
          GOTO 1
      ENDIF
      IJ=LJKL/30082
      KL=LJKL-30082*IJ
      I =MOD(IJ/177,177)+2
      J =MOD(IJ,177)+2
      K =MOD(KL/169,178)+1
      L =MOD(KL,169)
      WRITE(6,'(A,I15,4I4)') 'RANMAR initialized:',LJKL,I,J,K,L
      DO 2 II=1,97
      S=0
      T=0.5
      DO 3 JJ=1,24
          M=MOD(MOD(I*J,179)*K,179)
          I=J
          J=K
          K=M
          L=MOD(53*L+1,169)
          IF(MOD(L*M,64).GE.32)S=S+T
    3 T=0.5*T
    2 U(II)=S
      C =  362436.0/16777216.0
      CD= 7654321.0/16777216.0
      CM=16777213.0/16777216.0
      I97=97
      J97=33
      INIT=.TRUE.
      END
