C ~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE ROMBERG(F,A,B,EPS,OPP,PREC,H,KERR)
          SUBROUTINE ROMBERG(F,A,B,EPS,OPP,PREC,H,KERR)
C usage:  CALL ROMBERG(F,A,B,EPS,OPP,PREC,H,KERR)
C
C THIS SUBROUTINE IS DUE TO HANS DE JONG
C
C   PERFORMS A FIRST ORDER ROMBERG  INTEGRATION OF A FUNCTION
C   F OVER THE INTERVAL (A,B). EPS IS THE RELATIVE CONVERGENCE
C   CRITERIUM. F IS TO BE DECLARED EXTERNAL IN THE CALLING
C   PROGRAM UNIT.
C    OPP  = RESULT OF  INTEGRATION
C    PREC = MINIMUM INTERVAL LENGTH ALLOWED (ASSUMED POSITIVE)
C    H    = MINIMUM INTERVAL LENGTH USED
C    KERR = 0   NO ERRORS
C         = 1   ABS(A-B)< PREC AS INPUT VALUE
C         = 2   INTERVAL LENGTH < PREC BEFORE CONVERGENCE
C
      IMPLICIT REAL (A-Z)
      INTEGER KERR
      EXTERNAL F
          KERR=0
          JNEW=0.0
          H=B-A
       IF(ABS(H).LT.PREC)THEN
             KERR=1
             GOTO10
       ENDIF
          IOLD=(F(A)+F(B))*H/2.0
          JOLD=IOLD
  1       SUM=0.0
          X=A+H/2.0
  2       SUM=SUM+F(X)
          X=X+H
       IF(ABS(X-A).LT.ABS(B-A))GOTO2
          H=H/2.0
          INEW=H*SUM+IOLD/2.0
          JNEW=(4.0*INEW-IOLD)/3.0
       IF(ABS(H).LT.PREC)THEN
          KERR=2
             GOTO 10
       ENDIF
       IOLD=INEW
       IF(JOLD.EQ.0.)GOTO10
       SUM=(1.0-JNEW/JOLD)
        JOLD=JNEW
         IF(ABS(SUM).GT.EPS) GOTO 1
  10   OPP=JNEW
       RETURN
       END
