
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE TSPEC(T0,E0,ES,ICRATE)

      SUBROUTINE TSPEC(T0,E0,ES,ICRATE)
C     returns a real energy value T0 with the probability distribution
C     of a given specific energy spectrum of 2048 channels.
C     ICRATE(0:2048) is an array which contains the integral of
C     the energy spectrum (i.e. the sum of the channel contents).
C     E0 and ES are the offset and slope of the energy calibration of
C     the spectrum
C
      REAL T0,E0,ES,R,R1
      INTEGER ICRATE(0:2048)
      CALL RANMAR(R1,1)
      R=ICRATE(2048)*R1
      I1=0
      I2=2048
1     I=(I1+I2)/2
      IF (R .GT. ICRATE(I)) THEN
        I1=I
      ELSE
        I2=I
      ENDIF
      IF (I2 .GT. I1+1) GOTO 1
      T0=(I1 + (R-ICRATE(I1))/(ICRATE(I2)-ICRATE(I1)))*ES + E0
      END
