C Include file COMFIG.COM
C Note: NL and NLAYER defined outside this include file

C NLS(L) is number of atom species as read from file COMBIN.FIG
C NLA(L) is the actual number of atom species in layer L
C     (these may be different e.g. GaAs structure for Si: NLB=2 NLA=1)
C NIND  : number of different sites where collisions occur
C MODX,MODY,MODZ : period of X,Y,Z in units XUNIT,YUNIT,DUNIT
C APC(L): atoms per (3-dimensional) unit cell of kind L.
C NABUR(L): number of surrounding atom rows to take along.
C LATTICE : a flag used in subroutine BBLOOP, to identify the lattice
C XPOS,YPOS : the coordinates of the surrounding atom rows
C DUNIT,XUNIT,YUNIT: units for Z,X,Y (in units of the lattice constant)
C ZPOS(L): spacing between atoms of kind L in the atom rows
C IATOM(J,L): if non-zero an atom of kind L is present at Z=J
C             its x,y coordinates are stored in
C XATOM(k),YATOM(k), where k=IATOM(J,L)
C NLC is number of lattice constants (1 for cubic, 2 for hexagonal)
C UZ(L): z coordinates for MODZ+1 planes from z=0 to z=1
C        (normalized to UD)
      INTEGER NABURMAX, MAXIATOM, MAXIND,MODZMAX
      PARAMETER (NABURMAX=50,MAXIATOM=50,MAXIND=50,MODZMAX=50)

      CHARACTER*10 CONFIGID, CSYMM
      COMMON /CONFIG/ CONFIGID(NLAYER), CSYMM(NLAYER)

      INTEGER NLS, NLC,NLZ
      INTEGER NIND,MODX,MODY,MODZ,NABUR,LATTICE,IATOM,IP
      REAL APC,XPOS,YPOS,DUNIT,XUNIT,YUNIT,ZPOS,XATOM0,YATOM0,UZ
      COMMON /COMFIG/ 
     + NLS(NLAYER),NLC(NLAYER),NLZ(NLAYER),
     + IP(3,2,NLAYER),
     + NIND(NLAYER),MODX(NLAYER),MODY(NLAYER),MODZ(NLAYER),
     + APC(NL,NLAYER),NABUR(NL,NLAYER),LATTICE(NLAYER),
     + XPOS(NABURMAX,NL,NLAYER),YPOS(NABURMAX,NL,NLAYER),
     + XUNIT(3,NLAYER), YUNIT(3,NLAYER),DUNIT(3,NLAYER),
     + ZPOS(NL,NLAYER),
     + IATOM(0:MAXIATOM,1:NL,NLAYER),
     + XATOM0(MAXIND,NLAYER), YATOM0(MAXIND,NLAYER),
     + UZ(0:MODZMAX,NLAYER)
