C Tool for putting several atoms in one plane in comfig files
C see comment in file COMBIN.FIG
C =======================================================
      SUBROUTINE UNPACK(INDX,NIND,LIND,INDIC)

c     INDX and NIND input, LIND and INC(1:LIND) output

      IMPLICIT NONE

      INTEGER MAXLIND
      PARAMETER (MAXLIND=9)
      INTEGER INDX,NIND,LIND,INDIC(1:MAXLIND),L

      INTEGER INDXT

      LIND=0
  726 CONTINUE
      IF( INDX .GT. 0) THEN
        LIND= LIND+1
        IF(LIND .GT. MAXLIND)THEN
          stop   'too big'
        ENDIF
        do 727 L=LIND,2,-1
        INDIC(L)= INDIC(L-1)
  727   continue
        INDXT= (INDX-1)/NIND
        INDIC(1)= INDX - (INDXT*NIND)
        INDX= INDXT
        GOTO 726
      ENDIF
      END
C =======================================================
      SUBROUTINE PACK(INDX,NIND,LIND,INDIC)

c     NIND, LIND and INC(1:LIND) input, INDX output

      IMPLICIT NONE

      INTEGER MAXLIND
      PARAMETER (MAXLIND=9)
      INTEGER INDX,NIND,LIND,INDIC(1:MAXLIND)

      INTEGER L
      DOUBLE PRECISION INDXT

      INDX =0
      INDXT=0.0
      DO 728 L=1,LIND
      IF(INDIC(L).gt.NIND) THEN
        write(*,*)'error:',INDIC(L),' is larger then ',NIND
        return
      ENDIF
      IF(INDIC(L).le.0) THEN
        write(*,*)'error:',INDIC(L),'?? must be > 0'
        return
      ENDIF
      INDXT=INDXT*NIND+INDIC(L)
  728 CONTINUE
      if(INDXT.gt.2147483647.0)then
        write(*,*)'error:', INDXT,' beyond integer capacity'
        return
      endif
      INDX=INDXT
      END
C =======================================================
      PROGRAM COMINDEX
      IMPLICIT NONE

      INTEGER MAXLIND
      PARAMETER (MAXLIND=9)
      INTEGER INDX,NIND,LIND,INDIC(1:MAXLIND)

      INTEGER L
      CHARACTER*1 SWITCH
      CHARACTER*80 LINE
      LOGICAL num
      EXTERNAL PACK, UNPACK

      write(*,*)'Pack/Unpack? P or U:'
      read(*,'(A1)')SWITCH
      
      write(*,*)'max. index NIND:'
      read(*,*)NIND

   1  CONTINUE
      if(switch.eq.'U' .or. switch.eq.'u')then
        write(*,*)'compound index (INDX= 0 to stop):'
        read(*,*)INDX
        if(INDX.eq.0)stop
        call UNPACK(INDX,NIND,LIND,INDIC)
        write(*,*)(INDIC(L),L=1,LIND)
        goto 1
      else if(switch.eq.'P' .or. switch.eq.'p')then
        write(*,*)'indices (empty line to stop):'
        read(*,'(A80)')LINE
        if(LINE.le.' ')stop
C find out how many numbers are on this line
        LIND=0
        num=.false.
        do 4 L=1,80
        if(LINE(L:L).le.' ' .or. LINE(L:L).eq.',')then
          if(num)then
            num=.false.
            LIND=LIND+1
          endif
        else
          if(.not.num)then
            num=.true.
          endif
        endif
   4    continue
        if(LIND.gt.MAXLIND)then
          write(*,*)'too many indices, MAXLIND=',MAXLIND
          goto 1
        endif
        read(LINE,*) (INDIC(L),L=1,LIND)
        write(*,*) (INDIC(L),L=1,LIND)
        call PACK(INDX,NIND,LIND,INDIC)
        write(*,*)INDX
        goto 1
      endif
      end
