      program coordfilter
      implicit none
      integer lu,iopt,ier,ix,iy,i,nargs
      real co(10)
      character*3,xcoord,ycoord,options(10)
      character*70 args(2)
      integer lfopen
      external lfopen
      data options/'x','y','px','py','T','x0','y0','px0','py0','T0'/

c This programs filters 2 parameters from the output of program flux7,
c used with the keyword options STARTCOORD and/or EXITCOORD.
c Specify which 2 coordinates to filter,
c either as commandline arguments
c or by means of a 2-line file called coord.sel.
c The specifications are character strings from the set options,
c see the data statement above.

      call f77start(nargs, args,2)
      if(nargs .ge. 2) then
        xcoord= args(1)
        ycoord= args(2)
      else
        ier= lfopen(1,'coord.sel','OLD',0,0)
        read(1,'(A3)')xcoord
        read(1,'(A3)')ycoord
      endif
      ix=0
      iy=0
      do 66 i=1,10
       if(options(i) .eq. xcoord) ix=i
       if(options(i) .eq. ycoord) iy=i
  66  continue
      if(ix .eq.0) write(6,*) 'bad xcoord specification:', xcoord
      if(iy .eq.0) write(6,*) 'bad ycoord specification:', ycoord
      if(ix*iy .eq. 0) goto 3
      write(6,'(2A10)') xcoord, ycoord

      lu=5
   1  continue
      iopt=4
      call getcoord(lu,iopt,co(1),co(2),co(3),co(4),co(5),ier)
      if (ier.ne.0) then
c ier=0: everything went smoothly
c ier=1: short line
c ier=2: end of record
c ier=3: end of file
c ier=-1: read error
        if(ier .eq. 1) then
          write(6,*) 'short line'
          goto 1
        endif
        if(ier .eq. 2) then
           write(6,*)'end of record' 
           goto 1
        endif
        if(ier .eq. 3)write(6,*)'end of file' 
        if(ier .eq.-1)write(6,*)'end of fun: read error' 
        goto 3
      endif
      if(iopt.eq.4)then
        co(6)=co(1)
        co(7)=co(2)
        co(8)=co(3)
        co(9)=co(4)
        co(10)=co(5)
      else if(iopt.eq.0)then
        call wrt2(6, co(ix), co(iy))
      else
        write(6,*)'error! bad iopt value:', iopt
        stop 'error! bad iopt value:'
      endif
      goto 1
3     continue
      end
C --------------------------------------------------- SUBROUTINE WRT2
      SUBROUTINE WRT2(LU, X1,X2)
      IMPLICIT NONE
      INTEGER LU
      REAL X1,X2
      
      REAL X,Y(2)
      INTEGER N1, N2, K
      CHARACTER*6 FORMX
      CHARACTER*34 FORMXY

      Y(1)=X1
      Y(2)=X2

      FORMXY= '('
      N1=1
      do 999 K=1,2
      X= ABS(Y(K))
      IF(X.LT.9.5) THEN
        FORMX='F10.6'
        N2=5
      ELSE IF(X.LT.99.5) THEN
        FORMX='F10.5'
        N2=5
      ELSE IF(X.LT.9999.5) THEN
        FORMX='F10.3'
        N2=5
      ELSE
        FORMX='F12.1'
        N2=5
      ENDIF
      FORMXY= FORMXY(1:N1)//FORMX(1:N2)
      N1= N1+N2
      IF(K.EQ.2)THEN
        FORMXY= FORMXY(1:N1)//')'
      ELSE
        FORMXY= FORMXY(1:N1)//','
      ENDIF
      N1=N1+1
  999 CONTINUE
      WRITE(LU,FORMXY) X1,X2
      END
