      subroutine getyim(yimpfile, seqnr, th, ph, yimp, m, mm, kerr)
      implicit none
      character*(*) yimpfile
      integer seqnr, m, mm, kerr
      real th(mm), ph(mm), yimp(mm)

C read a .ymp file record, specified by yimpfile and seqnr
C contents returned in th(), ph() and yimp()
C m (output) is number of angles
C mm (input) is size of arrays th and ph

      logical found
      integer ncomp,nk
      character*(5)string1
      character*(75)string2

      kerr=0
      call lfopen(4,yimpfile,'old',0,0)
      rewind 4
      ncomp=1
      found=.false.
      string1=' '
      do while(ncomp.le.seqnr)
        do while(string1.ne.'ANGLE')      
          read(4,6,err=71,end=71)string1 , string2
6         format(a5,a75)
        enddo
        do while(string1.eq.'ANGLE')      
          if(ncomp.eq.seqnr)then
            found=.true.
c read angle number, theta, phi, yield, from lines starting with 'angle'
            read(string2,220)nk,th(nk),ph(nk),yimp(nk)
220         format(i7,3f11.6)
            if(nk.le.0 .or. nk.gt.mm) then
              write(6,240)nk
240           format(' illegal nk value',i10)
              kerr= 3
              return
            endif
          endif
          read(4,6,err=71,end=71)string1 , string2
        enddo
        ncomp=ncomp+1
      enddo
71    continue
      if(found)then
        m=nk
        return
      endif
      ncomp=ncomp-1
      write(6,73)ncomp, seqnr,yimpfile
73    format('ncomp is only',i5,
     + ': requested seqnr', i4,' not found in file ', a44)
      kerr=5
      return
      end

      program test
      implicit none
      character*(80) yimpfile
      character*(60) title
      integer seqnr, m, mm, nk, first, ivar, kerr
      parameter(mm=80)
      real th(mm), ph(mm), yimp(mm) , const

      first=0
      write(6,*)'yimp file:'
      read(5,'(a)')yimpfile
  1   write(6,*)'seq nr:'
      read(5,*)seqnr
      if(seqnr.le.0)goto 1000
      call getyim(yimpfile, seqnr, th, ph, yimp, m, mm, kerr)
      if(kerr .ne. 0)goto 1000
      do 66 nk=1,m
      write (6,220) nk,th(nk),ph(nk),yimp(nk)
  66  continue
220   format(i7,3f11.6)
      if(first.eq.0)call openpgplot
      write(title,77)seqnr,yimpfile
 77   format('getyim    seqnr',I4,'  file: ',A33)
      if(abs(th(2)-th(1)).gt.abs(ph(2)-ph(1)))then
        ivar=1
        const=ph(1)
        call plotyim(th,th,ph,m,yimp,yimp,m,ivar,
     +   const,0.0,title,1+first,1)
      else
        ivar=2
        const=th(1)
        call plotyim(ph,th,ph,m,yimp,yimp,m,ivar,
     +   const,0.0,title,1+first,1)
      endif
      first=1
      goto 1
 1000 call closepgfil
      end
      SUBROUTINE PLOTYIM(VAR,THETA,PHI,NK,YIELDX,YIELDT,IANGX,IVAR,
     +CONST,AA,TITLE,IFLAG,NPLOT)
      COMMON JJJ
      PARAMETER (MM=60)
      DIMENSION VAR(IANGX),YIELDX(IANGX+2),YIELDT(MM,NPLOT)
      CHARACTER*60 TITLE
      DIMENSION THETA(MM),PHI(MM)

C GRAPHIC DISPLAY OR HARD COPY OF THE RESULTS
C VAR(I),YIELDX(I), I=1..IANGX : EXPERIMENTAL ANGLE, YIELD
C THETA(I),PHI(I),YIELDT(I,K), I=1..NK, K=1..NPLOT:
C     ANGLES AND YIELD OF SIMULATED (YMP) CURVES
C IVAR = 1: THETA IS VARIABLE, OR, IVAR = 2: PHI IS VARIABLE
C CONST : VALUE OF THE CONSTANT ANGLE (PHI OR THETA)
C AA    : CONSTANT BACKGROUND TERM (0 IF ABSENT)
C TITLE: TEXT FOR PLOT
C IFLAG = 0: GRAPHICS DISPLAY, ELSE PLOTTER OUTPUT
C IFLAG = 1: OPEN NEW PLOT FRAME, IFLAG = 2: STAY IN SAME PLOT FRAME
C IF NPLOT = 1 ONLY ONE THEORETICAL CURVE IS REQUESTED
C IF NPLOT > 1 INDIVIDUAL COMPONENTS, PRESENT IS YIELDT(I,K) WITH
C              K > 1 ARE ALSO TO BE SHOWN.
C
      CHARACTER*8 ANCA(2)
C
      REAL XARRAY(64),YARRAY(64)
      CHARACTER*80 TEXT

      INTEGER PGFIRST
      SAVE PGFIRST

      INTEGER ISYM
      SAVE ISYM

      DATA ANCA/'THETA   ',' PHI    '/
      DATA PGFIRST /0/

C 2010: to stop compiler warning:
      XX=0

      IF(PGFIRST .EQ. 0)THEN
        PGFIRST = 1
      ELSE IF(IFLAG .NE. 2) THEN
        CALL PGPAGE
      ENDIF

***
      DO 5 J=1,IANGX
      XARRAY(J)=VAR(J)
  5   CONTINUE
      XMIN=VAR(1)
      XMAX=VAR(IANGX)
      IF(XMIN.GT.XMAX)THEN
          XMIN=XMAX
          XMAX=VAR(1)
      ENDIF
      IF(IFLAG.EQ.2) GOTO 85
      YMIN=AA
      YMAX=AA
      DO 547 IA=1,IANGX
      IF(YIELDX(IA).GT.YMAX)YMAX=YIELDX(IA)
      IF(YIELDX(IA).LT.YMIN)YMIN=YIELDX(IA)
547   CONTINUE
      DO 553 IA=1,NK
      DO 552 IB=1,NPLOT
      IF(YIELDT(IA,IB).GT.YMAX)YMAX=YIELDT(IA,IB)
      IF(YIELDT(IA,IB).LT.YMIN)YMIN=YIELDT(IA,IB)
552   CONTINUE
553   CONTINUE
      IF(YMIN.GT.0)YMIN=0
      CALL PGRNGE(XMIN,XMAX,XLEFT,XRIGHT)
      CALL PGRNGE(YMIN,YMAX,YLOW,YHIGH)
      CALL PGSVP(0.15, 0.85, 0.2, 0.8)
      CALL PGSWIN(XLEFT, XRIGHT, YLOW, YHIGH)
      CALL PGBOX('ABCINTS', 0.0, 0, 'BCINTSV', 0.0, 0)
      WRITE(TEXT,53)ANCA(IVAR)
  53  FORMAT(A8)
C some compilers don't like empty strings: put a space between those ''
      CALL PGLAB(TEXT, 'YIELD', ' ')
C PLOT EXPERIMENTAL POINTS
      ISYM=4
* PLOT SYMBOLS AT (X,Y) = (XARRAY(I),YIELDX(I), I=1..IANGX,
  85  CALL PGPT(IANGX,XARRAY,YIELDX,ISYM)
      ISYM= ISYM+1
      IF(IFLAG.EQ.2)GOTO 95
      XARRAY(2)=XARRAY(IANGX)
      XARRAY(3)=AA
      XARRAY(4)=AA
C PLOT CONSTANT BACKGROUND TERM
* PLOT A SOLID LINE FROM (XARRAY(1),XARRAY(2)) TO
* (XARRAY(3),XARRAY(4):
        CALL PGLINE(2,XARRAY,XARRAY(3))
       IKONST=3-IVAR
      WRITE(TEXT,55)ANCA(IKONST),CONST,TITLE
  55  FORMAT(A6,'=',F6.2,1X,A60)
* PLOT THE TEXT (74 CHARACTERS) AT (X,Y)= (0,VERT+15.3) (IN mm)
      CALL PGMTXT('T',1.5, -0.05, 0.0, TEXT)
  95  CONTINUE
      JJ=0
      IF(IFLAG.EQ.2) JJ=JJJ
      DO 77 II=1,NPLOT
          JJ=IAND(JJ,3)+1
          IF(IFLAG.NE.0)JJJ=JJ
          NN=0
          I180=0
 39       DO 40 K=-NK,NK
          IF(K.EQ.0)GOTO 40
          IF(K .LT. 0) THEN
              IF(IVAR.EQ.1.AND.(THETA(1)*THETA(NK)).LT.0)GOTO 40
              IF(IVAR.EQ.2)GOTO 40
          ENDIF
          KA=ABS(K)
          SIGNK=KA/K
          IF(IVAR.EQ.1)XX=THETA(KA)*SIGNK
          IF(IVAR.EQ.2)XX=PHI  (KA)*SIGNK
          IF(I180.NE.0)XX=180.0+XX
          DEL=ABS(VAR(IANGX)-VAR(1))*0.1
          IF(XX.GE.XMIN .AND. XX.LE.XMAX) THEN
              NN=NN+1
              XARRAY(NN)=XX
              YARRAY(NN)=YIELDT(KA,II)
          ENDIF
40        CONTINUE
          IF(IVAR.EQ.2.AND.I180.EQ.0)THEN
              I180=180
              GOTO 39
          ENDIF
C PLOT THEORETICAL CURVES
          CALL PGSLS(JJ)
          CALL PGLINE(NN, XARRAY, YARRAY)
          CALL PGSLS(1)
  77  CONTINUE
      IF(IFLAG.EQ.0)CALL FSLEEP(1)
      END
