C ===-===---===---===---===---===---===---===--- MAIN PROGRAM PLOTFIG
      PROGRAM PLOTFIG
      IMPLICIT NONE
C MAKES A PLOT OF THE UNIT CELL USED IN FLUX AND OF THE
C NEIGHBOURING STRINGS INCLUDED.

      INCLUDE 'FLUX7.COM'

      INTEGER IL,J,K,KK,KL,KLT,L,LIND, LC, NCLARG
      INTEGER INDIC(6)
      LOGICAL FIRST
      REAL CHARHITE,DK,UMINX, UMINY, UMAXX, UMAXY
      REAL XAXLEN,XCUR,XMAX,XMAXA,XMIN,XMINA
      REAL YAXLEN,YCUR,YMAX,YMAXA,YMIN,YMINA
      CHARACTER*28 XTEKST, YTEKST
      CHARACTER*64 XYFORMAT
      CHARACTER*1 cursor
      CHARACTER*(26)ZSCALE
      REAL XC(5),YC(5)
      DATA XCUR,YCUR /0, 0/
C CODE FOR PLOT SYMBOLS
      INTEGER SYM(0:7)
C PARAMETERS IN MILLIMETERS:
      PARAMETER(XAXLEN=140.0,YAXLEN=140.0)
C DATA IN UNITS (XUN,YUN)
      DATA XC /  0, 1, 1,  0, 0/
      DATA YC /  0, 0, 1,  1, 0/
      DATA SYM/2,4,16,5,11,18,6,13/
      DATA KK /-1/
      DATA FIRST/.true./

      VERSION(1:5)='V7.9 '
      WRITE(6,14)VERSION
  14  FORMAT('This is plotfig, version ',A5,/
     + 'graphics output also goes to file plotfig3.ps')
      CALL SETPGFIL('plotfig3.ps')
      NCLARG=0

  20  CONTINUE
C FILL COMMON BLOCK /COMFIG/
      if(IARGC() .gt. NCLARG) then
        NCLARG=1+NCLARG
        call IGETARG(NCLARG,COMFIGNAME(1),80)
      elseif(NCLARG .gt. 0)then
        COMFIGNAME(1)='STOP'
      else
        IF(FIRST)WRITE(6,21)
        WRITE(6,22)
  21    FORMAT(/, 'COMFIG NAME may be of the form <comfigfile>:<name>',
     +  ' or <comfigfile>:LIST')
  22    FORMAT(/,'COMFIG NAME or STOP  or LIST :')
        READ (5,'(A)') COMFIGNAME(1)
      endif
      FIRST=.false.
      IF(COMFIGNAME(1).EQ.'STOP' .or. COMFIGNAME(1).EQ.'stop') THEN
        IF(KK.ge.0)THEN
         WRITE(6,'(''==> Click mouse in PGPLOT Window <=='')')
         CALL PGCURS(XCUR,YCUR,cursor)
         CALL CLOSEPGFIL
         CALL PGEND()
        ENDIF
        STOP
      ENDIF

      write(6,61)COMFIGNAME(1)
  61  format('****************',' ',A24,' ','****************')
      CALL COMBIFIG(1,1)
C case 'LIST':
      if(NLC(1).eq.0) goto 20

C output details of the configuration just read
      UMINX=0
      UMAXX=0
      UMINY=0
      UMAXY=0
  57  FORMAT(A22,8I5)
  58  FORMAT(A,A,3(1X,F7.3))
  59  FORMAT(A40,/,9(1X,F7.3))
      if(CSYMM(1).gt.' ')write(6,'(2a)')'symmetry:',CSYMM(1)
      write(6,57)'nr of rows NIND:', NIND(1)
      write(6,57)'modx, mody, modz:', MODX(1),MODY(1),MODZ(1)
      write(6,57)'zx plane:',(IP(J,1,1),J=1,3)
      write(6,57)'yz plane:',(IP(J,2,1),J=1,3)
      write(6,57)'atoms per cell:',(NINT(APC(IL,1)),IL=1,NLS(1))
      write(6,57)'nr of rows NABUR:',(NABUR(IL,1),IL=1,NLS(1))
      write(6,57)'code for lattice type:',LATTICE(1)
      if(NLZ(1).eq.0)then
        ZSCALE='terms of lattice constant:'
      else
        ZSCALE='angstrom:'
      endif
      if(NLC(1).eq.1)then
        write(6,58)'x,y,z units in ',ZSCALE,
     +  XUNIT(1,1), YUNIT(1,1), DUNIT(1,1)
      else
        write(6,58)'x unit in ',ZSCALE,
     +  (XUNIT(L,1),L=1,NLC(1))
        write(6,58)'y unit in ',ZSCALE,
     +  (YUNIT(L,1),L=1,NLC(1))
        write(6,58)'z unit in ',ZSCALE,
     +  (DUNIT(L,1),L=1,NLC(1))
      endif
      write(6,59)'(average) z spacing in z-units:',
     + (ZPOS(IL,1),IL=1,NLS(1))
      do 66 IL=1,NLS(1)
      write(6,60)IL,(IATOM(K,IL,1),K=0,MODZ(1)-1)
  66  continue
  60  FORMAT('Indices I-atom for species',I2,':',12I4,/,(29X,12I4))
      DO 67 K=0,MODZ(1)-1
      DO 67 L=1,NLS(1)
      DK= 0.0
      CALL GETXYATOM(K, L, 1, LIND, INDIC)
      DO 68 KLT=1,LIND
        KL= INDIC(KLT)
        write(6,69) L,K,XATOM0(KL,1),YATOM0(KL,1)
        if(XATOM0(KL,1).lt.UMINX)UMINX=XATOM0(KL,1)
        if(XATOM0(KL,1).gt.UMAXX)UMAXX=XATOM0(KL,1)
        if(YATOM0(KL,1).lt.UMINY)UMINY=YATOM0(KL,1)
        if(YATOM0(KL,1).gt.UMAXY)UMAXY=YATOM0(KL,1)
  68  CONTINUE
  67  CONTINUE
  69  FORMAT('atom of species',I2,' at iz=',I2,' X,Y=',2F7.3)
      do 65 IL=1,NLS(1)
      do 64 J=1,NABUR(IL,1)
        if(XPOS(J,IL,1).lt.UMINX)UMINX=XPOS(J,IL,1)
        if(XPOS(J,IL,1).gt.UMAXX)UMAXX=XPOS(J,IL,1)
        if(YPOS(J,IL,1).lt.UMINY)UMINY=YPOS(J,IL,1)
        if(YPOS(J,IL,1).gt.UMAXY)UMAXY=YPOS(J,IL,1)
  64  continue
  65  continue
 
      if(NLZ(1).eq.0)then
        if(NLC(1).eq.1)then
          WRITE(6,'(''lattice constant a:'')')
          READ(5,*)UA(1,1)
        else
          WRITE(6,'(''a, c (angstr):'')')
        READ(5,*)  UA(1,1),UA(2,1)
        endif
        XUN(1)= 0
        YUN(1)= 0
        DO 110 LC=1,NLC(1)
        XUN(1)= XUN(1)+ UA(LC,1)*XUNIT(LC,1)
        YUN(1)= YUN(1)+ UA(LC,1)*YUNIT(LC,1)
110     CONTINUE
      else
        UA(1,1)=1
        XUN(1)= XUNIT(1,1)
        YUN(1)= YUNIT(1,1)
      endif
      UMINX= UMINX*XUN(1)
      UMAXX= UMAXX*XUN(1)
      UMINY= UMINY*YUN(1)
      UMAXY= UMAXY*YUN(1)
      write(6,56)UMINX, UMAXX, UMINY, UMAXY
  56  FORMAT('Region bounded by xmin, xmax, ymin, ymax:',4F7.3,
     + ' (angstr)')
      XMINA=UMINX-1.0
      YMINA=UMINY-1.0
      XMAXA=UMAXX+1.0
      YMAXA=UMAXY+1.0
C
      DO 100 KK=2,1,-1
      IF(KK.eq.1)CALL OPENPGDIS
      IF(KK.eq.2)CALL OPENPGPLOT
      CALL PGASK(.FALSE.)
C XMINA ... in Angstrom
C XMIN  ... in 'FLUX' units
      XMIN=XMINA/XUN(1)   
      XMAX=XMAXA/XUN(1)   
      YMIN=YMINA/YUN(1)   
      YMAX=YMAXA/YUN(1)   

C PLOT AXES
      CALL PGPAGE()
      CALL PGSVP(0.25, 0.75, 0.2, 0.7)
      CALL PGSWIN(XMINA,XMAXA,YMINA,YMAXA)
      CALL PGWNAD(XMINA,XMAXA,YMINA,YMAXA)
      CALL PGBOX('CIMTS', 0.0, 0, 'CMTSV', 0.0, 0)
      CALL PGSWIN(XMIN, XMAX, YMIN, YMAX)
      CALL PGBOX('BINTS', 0.0, 0, 'BNTSV', 0.0, 0)

      XYFORMAT= '(''('',3I2,'') plane   '',A1,''-units'')'
      if (CSYMM(1) .eq. 'hexagonal' .or. CSYMM(1) .eq. 'tetragonal')
     + XYFORMAT= '(''('',2I2,'' . '',I2,'') plane   '',A1,''-units'')'
      WRITE(XTEKST,XYFORMAT)IP(1,1,1),IP(2,1,1),IP(3,1,1),'X'
      WRITE(YTEKST,XYFORMAT)IP(1,2,1),IP(2,2,1),IP(3,2,1),'Y'
      CALL PGMTXT('T',6.0,0.0, 0.0,VERSION)
      CALL PGMTXT('B',4.0,1.0, 1.0,XTEKST)
      CALL PGMTXT('L',4.0,1.0, 1.0,YTEKST)
      CALL PGMTXT('T',3.0,0.8, 1.0,'\Angstr')
      CALL PGMTXT('R',4.0,0.8, 1.0,'\Angstr')

C PLOT A SYMBOL AT ALL POINTS (XPOS(I),YPOS(I)), I=1..NABUR(L,1)
      CALL PGQCH(CHARHITE)
      CALL PGSCH(CHARHITE*2.0)
      DO 49 L=1,NLS(1)
      CALL PGPT(NABUR(L,1),XPOS(1,L,1),YPOS(1,L,1),SYM(MOD(L,8)))
  49  CONTINUE

C PLOT A DIFFERENT SYMBOL AT POINT (XATOM0,YATOM0)
      DO 50 L=1,NLS(1)
      DO 50 K=0,MODZ(1)-1
      CALL GETXYATOM(K, L, 1, LIND, INDIC)
      DO 52 KLT=1,LIND
        KL= INDIC(KLT)
        DK= 0.0
        CALL PGPT(1,XATOM0(KL,1)+DK,YATOM0(KL,1)+DK,SYM(MOD(L,8)))
        CALL PGPT(1,XATOM0(KL,1)+DK,YATOM0(KL,1)+DK,SYM(0))
  52  CONTINUE
  50  CONTINUE

C DRAW A SOLID LINE THROUGH THE 5 POINTS (XC(I),YC(I), I=1..5
      CALL PGLINE(5,XC(1),YC(1))

C TERMINATE PLOT
      CALL PGSCH(CHARHITE)
 100  CONTINUE
      GOTO 20
      END
