C ===---===---===---===---===---===---===---===--- MAIN PROGRAM PRAAK
      PROGRAM PRAAK
      IMPLICIT NONE
C THIS PROGRAM MAKES A FILE, SIMILAR TO THE OUTPUT OF YIMP, FOR THE
C CLOSE ENCOUNTER PROBABILITY, I.E. THE YIELD OF THE HOST ATOMS.
      INTEGER NBIN,NL,NLAYER
      REAL PI,TWOPI,DEGREE
      PARAMETER (NBIN = 1024)
      PARAMETER(NL=14)
      PARAMETER(PI=3.14159265,TWOPI=2.0*PI,DEGREE=TWOPI/360.0)
      PARAMETER(NLAYER=2)
C  NL is the maximum number of different atom species in the crystal
C  The actual number is read from the flux file 
      INTEGER NDELZ
      REAL ZMAX,RAAK2,FLUX,DAV,DDAV
      COMMON /PCOMFLUX/ NDELZ,ZMAX, RAAK2(0:NBIN*NL*NLAYER-1),
     + FLUX(1),DAV(0:NBIN-1,NL,2),DDAV(0:NBIN-1,NL,2)
      INTEGER NLA(6), NLAY, NL1
      REAL Z2(NL)
      CHARACTER*160 FLKOP
      CHARACTER*32 VERSION,OLDVERS
      CHARACTER*20 TIME
      CHARACTER*80 YMPFILE, FLXFILE
      CHARACTER*70 ARGS(1)
      CHARACTER*32 TMPTXT
      INTEGER NBIN1,IFIRST,ILAST,NSUM,ILAY,IY,NTRX,LTFLUX,NBINF,NX,NY
      INTEGER LU,NARGS,IANGLE,NV1,IWEIGHT,IOS,LL,LL1,NLAP,KL1,IDEPTH
      INTEGER LLAV(NL),NAV,LINC(NL),KL2,LL2,LASTOLD
      REAL ZFIRST,ZLAST,ZSTEP,T0,TEMP,OLDT0,OLDTEMP
      REAL YSUM,Z0,Z1,ZIMAX,ZIFWHM,UD,XUN,YUN,PHI,ZFOLD,ZLOLD,THETA
      LOGICAL BEGIN
      INTEGER ITXTOSTR

C inline function RAAK
      REAL RAAK
      INTEGER I,L,K
      RAAK(I,L,K) = RAAK2(((K-1)*NL1 + (L-1))*NBIN1 + I)

      DATA BEGIN/ .TRUE. /
      DATA NAV,KL2,LL2,LASTOLD/ 4*0 /
      DATA OLDT0,OLDTEMP/ 2*0.0 /

c get command line argument if any
      CALL F77START(NARGS,ARGS,1)
      if(NARGS.ge.1)THEN
        LL= ITXTOSTR(ARGS(1),FLXFILE)
        WRITE(6,*)'Flux file =',FLXFILE(1:LL)
        CALL LFOPEN (10,FLXFILE(1:LL), 'OLD',    0,0)
      ELSE
c if none found, ask for filename      
        WRITE(6,*) 'SPECIFY FLUX FILE:'
        READ (5,100) FLXFILE
  100   FORMAT(A80)
        CALL LFOPEN (10,FLXFILE, 'OLD',    0,0)
      endif
      WRITE(6,*) 'SPECIFY YIMP FILE:'
      READ (5,100) YMPFILE
      CALL LFOPEN (7, YMPFILE, 'UNKNOWN',1,0)
      DO 42 LU=6,7
  42  WRITE(LU,*) 'PRAAK VERSION V7.9'
      REWIND 10
      IANGLE=0
C first go read a flux record to find out specifications
      GOTO 1
C then come back to label 43
  43  BEGIN= .FALSE.
      WRITE(6,111) VERSION,TEMP,T0,ZSTEP
 111  FORMAT(1X,A32,' T=',F6.1,' E=',F6.3,' ZSTEP=',F6.1)
c come back here to restart 
  44  CONTINUE
      WRITE(6,*)'DEPTH INTERVAL (ANGSTROM). ZFIRST,ZLAST: (0 0 to quit)'
      READ (5,*)  ZFIRST,ZLAST
      IF (ZLAST.EQ.0 .OR. ZLAST.LT.ZFIRST) STOP
      WRITE(6,*)
     + 'IS THIS DEPTH ALONG AXIS (0) OR ALONG BEAM DIRECTION (1)?'
      READ(5,*) IDEPTH
C
      IF(NLAY.gt.1)THEN
         WRITE(6,*) 'WHICH LAYER 1/2/3=BOTH'
         READ (5,*) KL1
      ELSE
          KL1=1
      ENDIF
      IF(KL1.EQ.1 .OR. KL1.EQ.2)THEN
          KL2=KL1
      ELSE
          KL1=1
          KL2=2
      ENDIF
C
      NLAP=NLA(KL1)
      IF(NLA(KL2).gt.NLAP)NLAP=NLA(KL2)
      IF( NLAP.GT.1 )THEN
        WRITE(TMPTXT,224)NLAP,NLAP+1
  224   FORMAT('ATOM SPECIES [1..',I1,',(',I1,'=average)]')
        WRITE(6,*) TMPTXT
        READ (5,*) LL1
        IF(LL1.GT.NLAP .AND. NLAP.GT.2)THEN
          WRITE(6,225)NLAP
  225     FORMAT('For every atom species: 1 if it is to be included,',
     +    '0 if it should be omitted.',/,'GIVE',I2,' NUMBERS 0 or 1:')
          READ(5,*)(LLAV(LL),LL=1,NLAP)
        ELSE IF(LL1.GT.NLAP) THEN
          DO 227,LL=1,NLAP
          LLAV(LL)=1
  227     CONTINUE
        ELSE
          DO 226,LL=1,NLAP
          LLAV(LL)=0
  226     CONTINUE
          LLAV(LL1)=1
        ENDIF
      ELSE
        LL1=1
        LLAV(LL1)=1
      ENDIF
      LL2=LL1
      IF(LL1.gt.NLAP)THEN
        LL1=1
        LL2=NLAP
      ENDIF 
      NAV=0
      DO 232 LL=LL1,LL2
      IF(LLAV(LL).eq.0)goto 232
      NAV=NAV+1
      LINC(NAV)=LL
  232 CONTINUE
c
c     for maintenance:
      write(6,'("which layer:",2I4)')KL1,KL2
      write(6,'("Nr of atoms:",I4)')NLAP
      write(6,'("which atoms:",8I4)')(LLAV(LL),LL=1,NLAP)
      write(6,'("LL range:   ",2I4)')LL1,LL2
      write(6,'("to be incl. ",8I4)')(LINC(LL),LL=1,NAV)
C
      IANGLE=0
      REWIND 10
      ZFOLD=0
      ZLOLD=0
      LASTOLD=0
  1   CONTINUE
C READ RECORD OF LU=10; IF END OF FILE GOTO 99
      CALL FINDFLX(10,NBIN1,NBINF,NX,NY,NV1,NL1,NLA,NLAY,IWEIGHT,IOS)
      IF(IOS.NE.0)GOTO 99
      IF(NL1.GT.NL) THEN
          WRITE(6,*)'NL1 too large:', NL1
          IOS=255
          GOTO 99
      ENDIF
      IF(NBIN1.GT.NBIN) THEN
          WRITE(6,*)'NBIN1 too large:', NBIN1
          IOS=255
          GOTO 99
      ENDIF
      CALL GETFLX(10,NBIN1,0,0,0,NL1,NLA,NLAY,IWEIGHT,
     6            FLKOP,RAAK2,DAV,DDAV,FLUX,FLUX)
C RAAK(I,L,K) = RAAK2(((K-1)*NL1 + (L-1))*NBIN1 + I-1)
C UNPACK FLKOP
      READ(FLKOP,2)VERSION,TIME,THETA,PHI,
     2 T0,Z1,Z2(1),ZIMAX,ZIFWHM,NDELZ,UD,XUN,YUN,TEMP,NTRX,LTFLUX
  2   FORMAT(A32,A20,3F8.3,4F8.1,I6,F8.4,2F8.5,F8.2,I6,I4)
      ZSTEP=UD * NDELZ
      IF(IDEPTH.EQ.1)THEN
          ZSTEP = ZSTEP/COS(THETA*DEGREE)
      ENDIF
      IF (BEGIN) GOTO 43
CALCULATE AVERAGE YIELD, FROM ZFIRST TO ZLAST
      IFIRST=NINT(ZFIRST/ZSTEP)
      ILAST =NINT( ZLAST/ZSTEP)-1
      IF(IFIRST.LE.0)IFIRST=0
      IF(ILAST.GE.NBINF)ILAST=NBINF-1
      IF(IFIRST.GT.ILAST)STOP'IMPOSSIBLE DEPTH INTERVAL'
      YSUM=0.0
      NSUM=0
      DO 10 IY=IFIRST,ILAST
      DO 102 LL=LL1,LL2
      IF(LLAV(LL).eq.0)goto 102
      DO 101 ILAY=KL1,KL2
      YSUM=YSUM+RAAK(IY,LL,ILAY)
  101 CONTINUE
      NSUM=NSUM+1
  102 CONTINUE
  10  CONTINUE
      if(NSUM .le. 0)then
        write(6,*)'all data zero, or, did not find the right data'
        stop 'wrong flx file or program error'
      endif
      YSUM=YSUM/NSUM
      Z0=IFIRST*ZSTEP
      Z1=(ILAST+1)*ZSTEP
c     IF(VERSION.NE.OLDVERS.OR.T0.NE.OLDT0.OR.TEMP.NE.OLDTEMP)THEN
      IF(VERSION.NE.OLDVERS.OR.TEMP.NE.OLDTEMP)THEN
          IANGLE=0
          OLDVERS=VERSION
          OLDT0=T0
          OLDTEMP=TEMP
          ZFOLD=Z0
          ZLOLD=Z1
      ENDIF
      IF(IANGLE.EQ.0)THEN
          DO 12 LU=6,7
          WRITE(LU,*)VERSION,TIME
          WRITE(LU,11) TEMP,T0, Z0,Z1, IFIRST,ILAST ,
     +     (LINC(LL),LL=1,NAV)
  11      FORMAT(' TEMP:',F6.1,' ENERGY:',F6.3,
     +     '  DEPTH:',F8.1,'..',F8.1,' ANGSTROM.  I1,I2:',2I4/
     +     '  ATOM SPECIES:',7I2)
  12      CONTINUE
      ENDIF
      IF(LASTOLD.NE.ILAST)THEN
          WRITE(6,80)THETA,IFIRST,ILAST
          LASTOLD=ILAST
  80      FORMAT(' Theta=',F7.2,'  IFIRST,ILAST=',2I4)
      ENDIF
      IANGLE = IANGLE + 1
      WRITE(7,9) IANGLE,THETA,PHI,YSUM
   9  FORMAT(5HANGLE,I7,3F11.6)
      GOTO 1
  99  CONTINUE    
C   COME HERE ON ERROR ON LU 7 (INCLUDING EOF/EOM)
      IF(IOS.NE.-1)THEN
        WRITE (6,1996) IOS
      ELSE
        IF(IANGLE.eq.0)THEN
          WRITE(6,'(A)')'end of flux file before any data!?'
        ELSE  
          IOS=0
          WRITE(7,999)
          WRITE(6,999)
          GOTO 44
        ENDIF
      ENDIF
 1996 FORMAT(' IMPROPER FLUX FILE !  IOS=',I4)
      WRITE(7,999)
  999 FORMAT('****************************************')
      END
