      PROGRAM MAIN
      CALL SHOW(0)
      END

      SUBROUTINE CIORESET
      CALL SHOW(1)
      END

      SUBROUTINE SHOW(INIT)
      IMPLICIT NONE
      INTEGER INIT

C THIS PROGRAM TAKES AS INPUT A .FLX FILE MADE BY PROGRAM FLUX
C AND PLOTS THE CLOSE ENCOUNTER PROBABILITY AS A FUNCTION OF
C THE DEPTH Z, INTEGRATED OVER X AND Y, I.E. THE ARRAY RAAK OF
C PROGRAM FLUKS.
C IN ADDITION ARRAYS DAV AND DDAV ARE READ AND INSPECTED.

C All stdin input is done by cio routines. No Fortran READ !
C Therefore use CPCHOOSE() rather then IPCHOOSE

      INTEGER NL
      PARAMETER(NL=7)
C NL is maximum number of different atom species
      INTEGER NLAYMAX
      PARAMETER(NLAYMAX=3)
C NLAYMAX is maximum number of different layers

      INTEGER I,IAN,IL,IL2,KLAY,IOS,IWEIGHT,KEUS,KODE,KZ,NBIN,NBINA
      INTEGER NLAP
      INTEGER NF,NFILE
      INTEGER NFILNAM,NL1,NLAY,NLA(NLAYMAX),NNAME,NRK,NV,NX,NY
      INTEGER KIES,KOOS,N1,NDELZ,NRKHLF,NSMOOTH,NTRX
      INTEGER LINTYP, NPL
      INTEGER IPLOTV, KK, QDEV(2)
      REAL ATPV,ATVOL,D1,D2,S1,S2,TEMP,UD,XUN,Y1,Y2,YUN,Z2
      REAL ZIFWHM,ZIMAX,ZZMAX,ZZSTEP
      REAL DX,DY,PHI,T0,THETA,VERT,XMAX,XMIN,YMAX,YMIN,Z1
      REAL XCUR,YCUR
      DATA XCUR, YCUR /0.0, 0.0/
      REAL BOHR
      EXTERNAL BOHR
      INTEGER IARGC,IGETARG, IPLOTVERSIO, CPCHOOSE
      INTEGER ILAVERAGE

      PARAMETER(NBIN=1000)
      REAL RAAK(0:NBIN-1),DAV(0:NBIN-1),DDAV(0:NBIN-1),XX(0:NBIN-1)
      COMMON /PLOTCOM/ XMIN,XMAX,DX, YMIN,YMAX,DY, KODE,VERT
      CHARACTER*160 FLKOP
      CHARACTER*32 VERSION
      CHARACTER*20 TIME
      CHARACTER*70 FILNAM
      CHARACTER*9 YTEXT
      CHARACTER*32 TMPTXT
      character*1 cursor
      LOGICAL QPLOT
      LOGICAL QCURSOR
      DATA QCURSOR /.FALSE./
      EXTERNAL CIORESET
      EXTERNAL ININT

      CHARACTER*5 OPTIONS(-1:7),OPTI
*
C Better save then sorry:
      SAVE ATPV
      SAVE D1
      SAVE D2
      SAVE DAV
      SAVE DDAV
      SAVE FILNAM
      SAVE FLKOP
      SAVE I
      SAVE IAN
      SAVE IL
      SAVE ILAVERAGE
      SAVE IPLOTV
      SAVE IOS
      SAVE KEUS
      SAVE KIES
      SAVE KOOS
      SAVE KZ
      SAVE LINTYP
      SAVE N1
      SAVE NBINA
      SAVE NDELZ
      SAVE NF
      SAVE NFILE
      SAVE NFILNAM
      SAVE NL1
      SAVE NNAME
      SAVE NPL
      SAVE NRK
      SAVE NRKHLF
      SAVE NSMOOTH
      SAVE NTRX
      SAVE NX
      SAVE NY
      SAVE OPTI
      SAVE OPTIONS
      SAVE PHI
      SAVE QDEV
      SAVE QPLOT
      SAVE RAAK
      SAVE S1
      SAVE S2
      SAVE T0
      SAVE TEMP
      SAVE THETA
      SAVE TIME
      SAVE UD
      SAVE VERSION
      SAVE XUN
      SAVE XX
      SAVE Y1
      SAVE Y2
      SAVE YTEXT
      SAVE YUN
      SAVE Z1
      SAVE Z2
      SAVE ZIFWHM
      SAVE ZIMAX
      SAVE ZZMAX
      SAVE ZZSTEP

      DATA OPTIONS /'end','list',
     1 'yield',
     2 'dE',
     3 'dE/x',
     4 'dE/dx',
     5 'strag',
     6 'Bohr',
     7 'newf'/
      DATA QDEV /0, 0/
      DATA QPLOT /.false./

      IF(INIT.GT.0)GOTO 66
      CALL CIOBEG(CIORESET)

      NFILNAM=IARGC()
      IF (NFILNAM.EQ.0) THEN
          STOP 'no input file given'
      ENDIF

      IPLOTV = IPLOTVERSIO()
* IPLOTV not used anymore (PJMS 2012)
      KK=3
      KK=CPCHOOSE(3)
      if(KK.ge.2)then
        QDEV(2)=1
        KK= KK-2
      endif
      if(KK.ge.1)QDEV(1)=1

      NFILE=1
  20  CONTINUE

C Get commandline argument if any
      NNAME=IGETARG(NFILE,FILNAM,70)

      IF (NNAME .LE. 0) THEN
          CALL INSTRING(FILNAM,"input file:")
      ENDIF
      WRITE(6,27)FILNAM
  27  FORMAT('input file:',A64)
      CALL LFOPEN(7,FILNAM,'OLD',0,0)
C
C return here after option "restart"
   66 CONTINUE
      WRITE(6,67)OPTIONS
  67  FORMAT(' OPTIONS:',9('| ',A5))
      CALL INCMND(OPTI,':')
      DO 671 I=-1,7
      IF(OPTI.EQ.OPTIONS(I))GOTO 672
  671  CONTINUE
      IF(OPTI.EQ.'Curso')QCURSOR= .TRUE.
      IF(OPTI.NE.'    ')GOTO 66
      GOTO 673
  672 KEUS=I
  673 CONTINUE
      IF (KEUS.LT.0)GOTO 1000
      IF (KEUS.EQ.7)THEN
          CALL ININT(NF,1,'file number [0=next]:')
          IF(NF.EQ.0)THEN
              NFILE=NFILE+1
              IF(NFILE.GT.NFILNAM)THEN
                NFILE=1
              ENDIF
          ELSE
              NFILE=NF
          ENDIF
          CLOSE(7)
          GOTO 20
      ENDIF
      IF(KEUS.EQ.0)GOTO 69
      WRITE(6,68)
   68 FORMAT(' VERTICAL AXIS: ')
      CALL INREAL(YMIN,2,'YMIN,YMAX(0,0=auto)')
   69 CALL ININT(KZ,1,'SPECTRUM NR [0=ALL,-1=STOP, -2=restart]')
      IF(KZ.EQ.-1)GOTO 1000
      IF(KZ.EQ.-2)GOTO 66
      KLAY=0
      IL=0
c rewind flux file      
 100  IAN=0
      REWIND(7)
      ILAVERAGE=0
c next angle
  1   IAN=IAN+1
C READ RECORD OF LU=7; IF END OF FILE GOTO 99
      CALL FINDFLX(7,NBINA,NRK,NX,NY,NV,NL1,NLA,NLAY,IWEIGHT,IOS)
      IF(IOS.NE.0)GOTO 99
c loop until the desired record (KZ) is found      
      IF( (KZ.NE.0) .AND. (KZ.NE.IAN) ) GOTO 1
c NBIN is the size of arrays RAAK etc as dimensioned in this program
c NBINA is the size as dimensioned in program Flux
c NRK is the number of bins actually used.
      IF(NBINA.GT.NBIN)THEN
          IOS=255
          GOTO 99
      ENDIF
c ask which layer, answer in KLAY
      IF(NLAY.GT.1)THEN
        IF(KLAY.EQ.0 .OR. KZ.NE.0)THEN
          CALL ININT(KLAY,1,'LAYER[1/2/3(=both)]:')
          IF(KLAY.le.0)THEN
            write(6,*)'illegal value for layer number'
            goto 66
          ENDIF
        ENDIF
      ELSE
        KLAY=1
      ENDIF
      IF(KLAY.LE.NLAY)THEN
        NLAP=NLA(KLAY)
      ELSE
        NLAP=NLA(1)
        IF(NLA(2).gt.NLAP)NLAP=NLA(2)
      ENDIF
c ask which atom species, answer in IL
      WRITE(TMPTXT,224)NLAP,NLAP+1
  224 FORMAT('ATOM SPECIES [1..',I1,',(',I1,'=average)]')
      IF(NLAP.gt.1)THEN
          IF(KEUS.GT.1 .AND. KEUS.LE.5 .AND. IWEIGHT.EQ.-1)IL=1
          IF(IL.EQ.0 .OR. KZ.NE.0)THEN
              CALL ININT(IL,1,TMPTXT)
              ILAVERAGE=0
              IF(IL.GT.NLAP)ILAVERAGE=IL
          ENDIF
      ELSE
          IL=1
      ENDIF
      IF(IL.le.0)THEN
        write(6,*) 'atom species',IL,' out of range'
        goto 66
      ENDIF 
      IF(ILAVERAGE.gt.NLAP)THEN
        IL2=NLAP
        IL=1
      ELSE
        IL2=IL
      ENDIF
c get NEP for this KLAY and IL      
      CALL GETNEP(7,NBINA,NLA,IWEIGHT,KLAY,IL,IL2,NLAY,NL1,
     + FLKOP,RAAK,DAV,DDAV)
C UNPACK FLKOP
      READ(FLKOP,2)VERSION,TIME,THETA,PHI,
     2 T0,Z1,Z2,ZIMAX,ZIFWHM,NDELZ,UD,XUN,YUN,TEMP,NTRX
  2   FORMAT(A32,A20,3F8.3,4F8.1,I6,F8.4,2F8.5,F8.2,I6)
      ZZSTEP = UD*NDELZ
      ZZMAX  = NRK*ZZSTEP
      WRITE(6,4)IAN,VERSION,TIME(1:14),T0,NTRX,THETA,PHI,ZZMAX
   4  FORMAT(/I3,':',A32,A15,'  E=',F5.1,'MeV',I9,' TRACKS'/
     +' TH,PH=',2F7.2,'   MAX.DEPTH=',F7.0,' ANGSTR')
      WRITE(6,5)Z1,Z2,NDELZ,UD,XUN,YUN,TEMP
   5  FORMAT(' Z1:',F3.0,' Z2:',F3.0,' NDELZ:',I4,' UD:',F8.3,
     +' XUN,YUN:',2F8.3,' TEMP:',F4.0)
      write(6,55)IL, IL2, NRK-1, DAV(NRK-1)
   55 FORMAT(' atom species ',I1,'..',I1,',  DAV(',I4,')=',F9.4)
C
C BIN I, (I=0..NRK-1)
C EFFECTIVE DEPTH OF FIRST BIN:
          XX(0)=0.5*(NDELZ-1)*UD
          DO 62 I=1,NRK-1
  62      XX(I) = ZZSTEP + XX(I-1)
          N1=0
          IF(NDELZ.EQ.1) N1=1
          NRKHLF=NRK/2
          Y1=0
          Y2=0
          DO 38 I=0,NRKHLF-1
          Y1=Y1+RAAK(I)
  38      CONTINUE
          DO 39 I=NRKHLF,NRK-1
          Y2=Y2+RAAK(I)
  39      CONTINUE
          Y1=Y1/NRKHLF
          Y2=Y2/(NRK-NRKHLF)
          D1=1E3*DAV(NRKHLF-1)/XX(NRKHLF-1)
          D2=1E3*(DAV(NRK-1)-DAV(NRKHLF))/(XX(NRK-1)-XX(NRKHLF))
          S1=DDAV(NRKHLF-1)
          S2=DDAV(NRK-1)
          WRITE(6,53) XX(NRKHLF-1),Y1,D1,S1,XX(NRK-1),Y2,D2,S2
  53      FORMAT(' DEPTH:',F7.0,'  AV. YIELD:',F7.3,
     +    '  AV. dE/dX:',F7.3,'   STRAGGLING:',F9.3)
                  IF         ( KEUS .EQ. 0 )              GOTO  1
      CALL ININT(KIES,1,
     +'0=skip, 1=same frame, 2=new frame, 3=xport, -1= stop ,-2=restart'
     + )
C if this is the first plot, change 'same frame' to 'new frame'
      KOOS=KIES
      IF(KIES.EQ.1 .AND. .NOT. QPLOT)  KOOS=2
        IF(KIES.GT.0) THEN
          YTEXT='YIELD'
          IF(KEUS.EQ.2)THEN
            YTEXT='dE(keV)'
            DO 632 I=0,NRK-1
  632       RAAK(I)=DAV(I)
          ELSE IF (KEUS.EQ.3)THEN
C dE/x
            YTEXT='eV/\Angst'
            DO 633 I=N1,NRK-1
  633       RAAK(I)=1E3*DAV(I)/XX(I)
            IF(N1.EQ.1)RAAK(0)=RAAK(1)
            ELSE IF (KEUS.EQ.4)THEN
C dE/dx
              YTEXT='eV/\Angst'
              RAAK(0)=1E3*(DAV(1)-DAV(0))/ZZSTEP
              RAAK(NRK-1)=1E3*(DAV(NRK-1)-DAV(NRK-2))/ZZSTEP
              DO 634 I=1,NRK-2
  634         RAAK(I)=0.5E3*(DAV(I+1)-DAV(I-1))/ZZSTEP
            ELSE IF (KEUS.GE.5)THEN
              YTEXT='SIG(keV)'
              DO 635 I=0,NRK-1
  635         RAAK(I)=DDAV(I)
              IF(KEUS.EQ.6)THEN
                IF(NL1.NE.1)THEN
                  CALL INREAL(Z2,1,'Z2(average)')
                ENDIF
                  CALL INREAL(ATVOL,1,'Atomic volume (angstr^3)')
                  ATPV=100.0/ATVOL
                  DO 636 I=0,NRK-1
  636             RAAK(I)=SQRT(BOHR(Z1,Z2,ATPV,XX(I)*0.1))*1E3
              ENDIF
            ENDIF
            CALL ININT(NSMOOTH,1,'NSMOOTH')
            DO 641 I=1,NSMOOTH
  641       CALL SMOOTH(RAAK,NRK)
            IF (KIES .LT. 3) THEN
              CALL ININT(LINTYP,1,
     +         '-1=symbols, 0=line, +n=symbols+line:')
              NPL=NRK
              IF (LINTYP.EQ.-1000) THEN
                CALL ININT(NPL,1,'NR OF POINTS TO PLOT:')
                CALL ININT(LINTYP,1,
     +           '-1=symbols, 0=line, +n=symbols+line:')
              ENDIF
              DO 647 KK=1,2
                IF (QDEV(KK).NE.0) THEN
                  IF(KK.eq.1)call OPENPGDIS
                  IF(KK.eq.2)call OPENPGPLOT
                  CALL PGASK(.FALSE.)
                  CALL PLOTJE(XX,RAAK,NPL,IAN,KOOS-1,VERSION,THETA,PHI
     +              , IL, LINTYP, YTEXT, FILNAM)
                  if(KK.eq.1 .and. QCURSOR)then
                  WRITE(6,'(''==> Click mouse in PGPLOT Window <=='')')
                    CALL PGCURS(XCUR,YCUR,cursor)
                  endif
                ENDIF
                QPLOT=.TRUE.
  647         CONTINUE
            ELSE
C OPTION EXPORTS THE DATA IN ASCII FORM.
              WRITE(8,654)VERSION,IAN,THETA,PHI,NSMOOTH,YTEXT,UD*NDELZ
  654         FORMAT(A32,' nr:',I3,' th,phi:',2F7.1,' Nsmo:',I3,1X,A8,
     +         F7.2,' A/c')
              do 655 I=0,NRK-1
  655          write(8,656) XX(I), RAAK(I)
  656          FORMAT(1X,F9.2,1X,F9.4)
C END OF OPTION export
            ENDIF
          ELSE IF (KIES.EQ.-1) THEN
            GOTO 1000
          ELSE IF (KIES.LT.0) THEN
C option "restart"
            GOTO 66
          ENDIF
          CALL SKIPPER
          IF(KZ.NE.0)   THEN
            CALL ININT(KZ,1,'SPECTRUM NR [0=ALL,-1=STOP, -2=restart]')
            IF(KZ.EQ.-1)GOTO 1000
            IF(KZ.EQ.-2)GOTO 66
            IF(KZ.LE.IAN .AND. KZ.NE.0) GOTO 100
          ENDIF
                        GOTO 1
  99  CONTINUE
      IF(IOS.NE.-1)THEN
          WRITE (6,1996)
      ELSE
          WRITE(6,998)
          GOTO 66
      ENDIF
 1996 FORMAT('  wrong sort of file?!')
  998 FORMAT(' ********* END OF FILE ******************')
  999 FORMAT(' ****************************************')
 1000 CONTINUE
      WRITE(6,999)
      IF(QDEV(2).ne.0)CALL CLOSEPGFIL
      CALL FSLEEP(2)
      CALL PGEND
      END
* ------------------------------------------------- subroutine GETNEP
      SUBROUTINE GETNEP(LU,NBIN1,NLA,IWEIGHT,KLAY,IL,IL2,NLAY,NL,
     + FLKOP,RAAK,DAV,DDAV)
      IMPLICIT NONE
      INTEGER LU,NBIN1,IWEIGHT,KLAY,IL,IL2,NLAY,NL
      INTEGER NLA(NLAY)
      CHARACTER*160 FLKOP
      REAL RAAK(0:NBIN1-1),DAV(0:NBIN1-1),DDAV(0:NBIN1-1)

      INTEGER NBIN
      PARAMETER ( NBIN = 1000 )
      REAL RAAK2(0:NBIN-1,NL,NLAY),
     +  DAV2(0:NBIN-1,NL),
     + DDAV2(0:NBIN-1,NL)
      CALL GETNEP2(LU,NBIN1,NLA,IWEIGHT,KLAY,IL,IL2,NLAY,NL,
     + FLKOP,RAAK,DAV,DDAV,RAAK2,DAV2,DDAV2)
      END

      SUBROUTINE GETNEP2(LU,NBIN1,NLA,IWEIGHT,KLAY,IL,IL2,NLAY,NL,
     + FLKOP,RAAK,DAV,DDAV,RAAK2,DAV2,DDAV2)
      IMPLICIT NONE
      INTEGER LU,NBIN1,IWEIGHT,KLAY,IL,IL2,NLAY,NL
      INTEGER NLA(NLAY)
      CHARACTER*160 FLKOP
      REAL RAAK(0:NBIN1-1),DAV(0:NBIN1-1),DDAV(0:NBIN1-1)
      REAL RAAK2(0:NBIN1-1,NL,NLAY),DAV2(0:NBIN1-1,NL),
     + DDAV2(0:NBIN1-1,NL)

* debugging output:
*     integer j,at,layer

* INPUT RESULTS FROM PROGRAM FLUX.
      INTEGER KL,K,LS,L,LE,IL1
      REAL DUMMY
      REAL SUMRAAK,SUMDAV,SUMDDAV,RSUM
      CALL GETFLX(LU,NBIN1,0,0,0,NL,NLA,NLAY,IWEIGHT,
     6           FLKOP,RAAK2,DAV2,DDAV2,DUMMY,DUMMY)

**
* debugging output:
*     write(6,'(//''GETNEP:'')')
*     write (6,*)' NBIN1=',NBIN1,' NL=',NL,
*    + ' NLAY=',NLAY,' NLA=',NLA(1),NLA(2)
*     do 983 layer=1,NLAY
*     do 980 at=1,NLA(1)
*     write(6,*) 'LAYER =',layer,' atom=',at
*     write(6,'(/5X,3A9)')'raak2', 'dav2', 'ddav2'
*     do 981 j=0,nbin1-1
*     write(6,'(I4,1X,3f9.3)')
*    + j,raak2(j,at,layer),dav2(j,at),ddav2(j,at)
*981  continue
*980  continue
*983  continue
**

      IF(KLAY.GT.NLAY)THEN
        KL=1
        DO 51 K=2,NLAY
        DO 50 LS=1,NLA(K)
        DO 52 L=0,NBIN1-1
        RAAK2(L,LS,1)=RAAK2(L,LS,1)+RAAK2(L,LS,K)
  52    CONTINUE
  50    CONTINUE
  51    CONTINUE
      ELSE
        KL=KLAY
      ENDIF

      IF(IL.eq.IL2)THEN
        LE=IL
        IF(IWEIGHT.LT.0)LE=1
        DO 10 L=0,NBIN1-1
         RAAK(L)=RAAK2(L,IL,KL)
          DAV(L)= DAV2(L,LE)
         DDAV(L)=DDAV2(L,LE)
  10    CONTINUE
      ELSE
        RSUM= IL2-IL+1
        DO 12 L=0,NBIN1-1
        LE=IL
        IF(IWEIGHT.LT.0)LE=1
        SUMRAAK=0
        SUMDAV =0
        SUMDDAV=0
        DO 11 IL1=IL,IL2
          SUMRAAK= SUMRAAK + RAAK2(L,IL1,KL)
          SUMDAV =  SUMDAV +  DAV2(L,LE)
          SUMDDAV= SUMDDAV + DDAV2(L,LE)
          IF(IWEIGHT.GE.0)LE=LE+1
  11    CONTINUE
        RAAK(L)= SUMRAAK/RSUM
         DAV(L)= SUMDAV /RSUM
        DDAV(L)= SUMDDAV/RSUM
  12    CONTINUE
      ENDIF
      END
* ------------------------------------------------- subroutine PLOTJE
      SUBROUTINE PLOTJE(XAS,RAAK,NRK,IAN,KIES1,VERSION,THETA,PHI
     +     , IL, LINTYP, YTEXT, FILNAM)
C USES PGPLOT
      CHARACTER*32 VERSION, FILNAM
      DIMENSION RAAK(1000),XAS(1000)
      CHARACTER*9 XTEXT,YTEXT
      COMMON /PLOTCOM/ XMIN,XMAX,DX, YMIN,YMAX,DY, KODE,VERT
      CHARACTER*64 TITLE
      INTEGER PGFIRST
      SAVE PGFIRST
      DATA PGFIRST /0/
      DATA XTEXT/'\Angstrom'/

      NX=NRK
      IF(KIES1 .GT. 0)THEN
          KODE=0
          VERT=0.0
      ELSE
          KODE=KODE+1
          IF(KODE.EQ.7)KODE=9
          IF(KODE.GT.10)KODE=0
          VERT=VERT+0.06
      ENDIF

      IF(PGFIRST .EQ. 0)THEN
        PGFIRST = 1
      ENDIF
      IF(KIES1 .GT. 0)THEN
        CALL PGPAGE
          CALL PGRNGE(XAS(1), XAS(NX), XMIN, XMAX)
          IF(YMAX.EQ.0.0)THEN
            DO 77 IX=1,NX
            IF(RAAK(IX).GT.YMAX)YMAX=RAAK(IX)
   77       CONTINUE
            YMAX=YMAX*1.2
          ENDIF
          CALL PGSVP(0.1, 0.75, 0.2, 0.8)
          CALL PGSWIN(XMIN, XMAX, YMIN, YMAX)
          CALL PGBOX('ABCINTS', 0.0, 0, 'BCINTSV', 0.0, 0)
          WRITE(TITLE,72)FILNAM,VERSION
          CALL PGLAB(XTEXT, YTEXT,TITLE)
      ENDIF
      IF(LINTYP.LT.-10)THEN
        CALL PGSLS(MOD(KODE,4)+2)
      ENDIF
      IF(LINTYP.GE.0 .OR. LINTYP.LT.-10)THEN
        CALL PGLINE(NX, XAS,RAAK)
      ENDIF
      IF(LINTYP.GE.-10 .AND. LINTYP.NE.0)THEN
        CALL PGQCH(SAVESIZE)
        CALL PGSCH(0.6)
        NSKIP= IABS(LINTYP)
        CALL PGPTN(NX, XAS, RAAK, KODE+3, NSKIP)
        CALL PGSCH(SAVESIZE)
      ENDIF
      CALL PGSLS(1)
      WRITE(TITLE,71) IAN,IL,THETA,PHI
      CALL PGMTXT('RV', 1.0, VERT, 0.0, TITLE)
   71 FORMAT(I3,1H,,I1,1H(,F6.1,1H,,F6.1,2H) )
   72 FORMAT(2A32)
      END
      SUBROUTINE SMOOTH(A,NX)
      DIMENSION A(NX)
      DO 1 K=1,2
      DO 1 I=K,NX,2
      IM=I-1
      IP=I+1
      IF(IM.LT.1)IM=1
      IF(IP.GT.NX)IP=NX
      S=(A(IM)+A(IP))*0.25
     +  + A(I)*0.50
      A(I)=S
1     CONTINUE
      END
