C ===---===---===---===---===---===---===---===---= MAIN PROGRAM YIMP
      PROGRAM YIMP
      IMPLICIT NONE
C PROGRAM TO CALCULATE IMPURITY YIELD
C TAKES OUTPUT FROM FLUX  AS INPUT (LU=10)
      INCLUDE 'FLUX7.COM'

      REAL AIMP,THIMP,DATAIMP(2)
      INTEGER NSITES,NFAC,ISPEC,NSF(2)
      REAL WJ, STEP,XYW,XY0,XYOFF,VAL
      COMMON /COMYIMP/AIMP,THIMP,NSITES,NFAC,ISPEC(NL),
     + WJ,STEP(2),XYW(3,100),XY0(2,100),XYOFF(2,100),VAL(8)
      EQUIVALENCE (AIMP,DATAIMP)
      EQUIVALENCE (NSITES,NSF)

      CHARACTER*80 fluxfile, yimpfile
      EXTERNAL ININT
      CHARACTER*5 YIMPID
      INTEGER LU,K,L,J,I,KASE,JANG,IFAC,VLEN
      REAL OFAC
      INTEGER INDX,JIND,LIND,INDIC(6)
      DATA YIMPID/'YIMP '/
C
      NLAY = 1
      VERSION(1:5)='V7.8'
      WRITE(6,*) 'specify flux file:'
      READ(5,fmt='(A)') fluxfile
      WRITE(6,*) 'specify output file:'
      READ(5,fmt='(A)') yimpfile
      CALL LFOPEN (10, fluxfile, 'OLD',    0,0) 
      CALL LFOPEN ( 7, yimpfile, 'UNKNOWN',1,0)
      WRITE(6,1172)
 1172 FORMAT(' COMFIG NAME (e.g. GAAS100):')
      READ(5,1174) COMFIGNAME(NLAY)
 1174 FORMAT(A)
      CALL COMBIFIG(NLAY,0)
C
      VLEN=0
  160 VLEN= VLEN+1
      if(VLEN.le.28) then
        if(VERSION(VLEN:VLEN).ge.' ')goto 160
      endif
      VLEN=VLEN-1
      DO 162 LU=6,7
      WRITE(LU,161) YIMPID,VERSION(1:VLEN)
  161 FORMAT('   PROGRAM : ',A5,A/
     + ' projected atom positions in units XUN,YUN and occupations')
      DO 162 K=1,NIND(NLAY)
      DO 163 L=1,NLS(NLAY)
      ISPEC(L)=0
      DO 163 J=0,MODZ(NLAY)-1
      call getxyatom(J,L,NLAY,LIND,INDIC)
      DO 599 JIND=1, LIND
      INDX= INDIC(JIND)
      IF(INDX.EQ.K)ISPEC(L)=ISPEC(L)+1
  599 CONTINUE
  163 CONTINUE
      WRITE(LU,164)XATOM0(K,NLAY),YATOM0(K,NLAY),ISPEC(1),ISPEC(2)
  164 FORMAT(' X=',F7.4,' Y=',F7.4,'   N(1)=',I2,'  N(2)=',I2)
  162 CONTINUE
   1  CONTINUE
C READ A,DEBYETEMP OF IMPURITY
      CALL INREAL(DATAIMP,2,'A(impurity),DEBYE [or -U1]')
C READ NSITES ; IF NSITES =0 EXIT
      CALL ININT(NSF,2,'NSITES,NFAC')
      IF (NSITES .EQ. 0) STOP
      CALL ININT(JANG,1,'ANGSTR=0,XYUN=1,(R,PHI)=2:')
C THE X- AND Y-IMPURITY ARE INCREMENTED BY XYOFF(1..2)
C THE XYOFF VALUES ARE NOT MULTIPLIED BY 'FACTOR'
C THEY ARE IN ANGSTROM FOR JANG=0 OR 2, IN XUN,YUN FOR JANG=1
C READ (XI,YI,WEIGHT) FOR I=1,NSITES
      DO 3 I=1,NSITES
      IF(JANG.NE.2)THEN
          CALL INREAL(VAL,5,'X0,Y0,DX,DY,WEIGHT')
      ELSE
          CALL INREAL(VAL,5,'X0,Y0,R,PHI,WEIGHT')
      ENDIF
      XYOFF(1,I)=VAL(1)
      XYOFF(2,I)=VAL(2)
      XY0  (1,I)=VAL(3)
      XY0  (2,I)=VAL(4)
      XYW  (3,I)=VAL(5)
  3   CONTINUE
C READ OVERALL FACTORS
      KASE=0
      DO 900 IFAC=1,NFAC
      CALL INREAL(OFAC,1,'FACTOR')
      CALL YIMPA(OFAC,JANG,KASE)
      KASE=1
 900  CONTINUE
      GOTO 1
      END

C ===---===---===---===---===---===---===---===---=== SUBROUTINE YIMPA
      SUBROUTINE YIMPA(OFAC,JANG,KASE)
C Loop through the whole FLUX file
      IMPLICIT NONE
      REAL OFAC
      INTEGER JANG,KASE

      INCLUDE 'FLUX7.COM'

      INTEGER NSITES,NFAC,ISPEC
      REAL AIMP,THIMP, WJ, STEP,XYW,XY0,XYOFF,VAL
      COMMON /COMYIMP/AIMP,THIMP,NSITES,NFAC,ISPEC(NL),
     + WJ,STEP(2),XYW(3,100),XY0(2,100),XYOFF(2,100),VAL(8)

      REAL AVXSQ
      EXTERNAL AVXSQ

C local variables

      CHARACTER*160 FLKOP
      CHARACTER*5 FLUXID
      CHARACTER*20 TIME
      CHARACTER*28 OLDVERS, VERSY

      INTEGER I, IANGLE, LU
      INTEGER NBIN1,NX,NY,NV1,NL1,ILAY,IWEIGHT,IOS,LTFLUX
      REAL VELO(1), THETA, PHI, YIELD
      REAL OLDT0, OLDTEMP
      REAL YI,XI
      REAL UI1,UI2,UI1SQ,UI2SQ
      INTEGER M,N

      SAVE OLDT0, OLDTEMP, OLDVERS

C REWIND LU=10
      REWIND 10
      IANGLE = 0
C READ RECORD OF UNIT 10; IF END OF FILE GOTO LABEL 800
  5   CONTINUE
      CALL FINDFLX(10,NBIN1,NBINF,NX,NY,NV1,NL1,NLA,ILAY,IWEIGHT,IOS)
      IF(IOS.NE.0)GOTO 800
      IF ( NL1.gt.ML
     + .or.NX*NY.gt.NF*NF
     + .or.NBIN1.gt.NBIN
     + .or.ILAY.gt.NLAYER)THEN
      write(6,*)'NL1',NL1,' NL',NL,' NX,NY',NX,NY,' NF',NF
      write(6,*)'NBIN1',NBIN1,' NBIN',NBIN,' ILAY',ILAY,' NLAYER',NLAYER
      if(NL1.gt.ML)write(6,*)'NL1 too large'
      if(NX*NY.gt.NF*NF)write(6,*)'NX*NY too large'
      if (NBIN1.gt.NBIN)write(6,*)'NBIN1 too large'
      if(ILAY.gt.NLAYER)write(6,*)'ILAY too large'
      write(6,*)'array sizes beyond capacity of this program'
        IOS=255
        GOTO 800
      ENDIF
      CALL GETFLX(10,NBIN1,NX,NY,0,NL1,NLA,ILAY,IWEIGHT,
     6            FLKOP,RAAK,DAV,DDAV,FLUX,VELO)
C UNPACK FLKOP
      READ(FLKOP,6)FLUXID,VERSY,TIME,THETA,PHI,
     6 T0,Z1,Z2(1,NLAY),ZIMAX,ZIFWHM,NDELZ,UD(NLAY),
     7 XUN(NLAY),YUN(NLAY),TEMP, NTRX,LTFLUX
  6   FORMAT(A5,A27,A20,3F8.3,4F8.1,I6,F8.4,2F8.5,F8.2,I6,I4)
C DETERMINE THERMAL VIBRATION AMPLITUDE OF IMPURITY
      IF(THIMP.GT.0)THEN
          UI1SQ = AVXSQ(AIMP,THIMP,TEMP)
      ELSE
          UI1SQ = THIMP*THIMP
      ENDIF
      UI2SQ = 2.0 * UI1SQ
      UI2 = SQRT(UI2SQ)
      UI1 = SQRT(UI1SQ)
C MULTIPLY X,Y BY FACTOR
      DO 66 I=1,NSITES
      IF(JANG.NE.2)THEN
          XI = OFAC * XY0(1,I)
          YI = OFAC * XY0(2,I)
      ELSE
          XI = OFAC * XY0(1,I) * COS ( XY0(2,I) * DEGREE )
          YI = OFAC * XY0(1,I) * SIN ( XY0(2,I) * DEGREE )
      ENDIF
      XI=XI+XYOFF(1,I)
      YI=YI+XYOFF(2,I)
      IF ( JANG .EQ. 1 ) THEN
          XI = XI * XUN(NLAY)
          YI = YI * YUN(NLAY)
      ENDIF
      XYW(1,I)=XI
      XYW(2,I)=YI
   66 CONTINUE

C DO SOME OUTPUT IN FIRST ROUND

      IF(KASE.EQ.0 .OR. LATTICE(NLAY).NE.LTFLUX  .OR.
     +   VERSY.NE.OLDVERS.OR.T0.NE.OLDT0.OR.TEMP.NE.OLDTEMP)THEN
       DO 625 LU=6,7
       WRITE(LU,61)FLUXID,VERSY,TIME,T0,Z1,Z2(1,1),XUN(NLAY),YUN(NLAY)
   61     FORMAT(' INPUT FROM: ',A5,A27,A20/
     +   ' PROJECTILE: E=',F8.3,' Z=',F8.3/
     +   ' LATTICE   : Z=',F8.3,' XUN=',F8.5,' YUN=',F8.5,' ANGSTR.')
          WRITE(LU,62)AIMP,THIMP,ZIMAX,ZIFWHM,TEMP,UI1
   62     FORMAT(' IMPURITY  : A=',F5.1,' DEBYETEMP=',F8.3/
     +           '           DEPTH (ANGSTR)=',F8.1,' FWHM=',F8.1/
     +           '           TEMPERATURE   =',F8.2,' U1  =',F8.5)
  625   CONTINUE
        KASE=1
        IANGLE=0
        OLDT0=T0
        OLDTEMP=TEMP
      ENDIF
C TEST IF THE SAME COMMON BLOCK COMFIG WAS USED IN FLUX AND YIMP
C IF THE LATTICE TYPE DIFFERS A FATAL ERROR OCCURS

      IF ( LATTICE(NLAY) .NE. LTFLUX)
     + STOP 'Non matching lattice types'

      IF (IANGLE .EQ. 0) THEN
          DO 65 LU=6,7
C WARN IF THE VERSION IDENTIFIER DIFFERS
          IF(VERSION(1:3).NE.VERSY(1:3).and. OLDVERS.NE.VERSY)
     +     WRITE(LU,630) VERSY(1:15),VERSION(1:15)
 630     FORMAT(5(1H>),' WARNING: NON-MATCHING FLUX:',A15,
     +    '| YIMP:',A15,5(1H<))
          WRITE(LU,635) OFAC
          WRITE(LU,633)
          WRITE(LU,64)((XYW(M,N),M=1,3),N=1,NSITES)
  633     FORMAT(' SITE(S)   : X(ANGSTR.) Y(ANGSTR.)     WEIGHT')
  635     FORMAT(20('*'),' FACTOR = ',F7.3,2X,20('*'))
   64     FORMAT( 100(12X,3F11.5/) )
   65     CONTINUE
          WRITE(6,68)
   68     FORMAT(' TEMP  TRACKS    THETA       PHI     YIELD ')
      ENDIF
      OLDVERS=VERSY

      CALL YIMP1(YIELD, FLUX,NX, NY, NSITES,
     + LATTICE(NLAY), MODX(NLAY), MODY(NLAY), XUN(NLAY), YUN(NLAY),
     + XYW, UI2SQ)

      WRITE (6,8) TEMP,NTRX, THETA,PHI,YIELD
  8   FORMAT(F6.0,I6,2F10.3,2F10.5)
      IANGLE = IANGLE + 1
      WRITE(7,9) IANGLE,THETA,PHI,YIELD
  9   FORMAT(5HANGLE,I7,3F11.6)
      GOTO 5

  800 CONTINUE
C     IOS=-1: END OF FILE: No more angles in this Flux file.
      IF(IOS.NE.-1 )THEN
          WRITE (6,1996) IOS
 1996     FORMAT(' ERROR NO',I4)
          STOP '"ERROR IN FLX FILE"'
      ENDIF
      WRITE(7,92)
  92  FORMAT(1X)
      END
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE INREAL (ARG,N,PROMPT)
      SUBROUTINE INREAL(ARG,N,PROMPT)
C usage:  CALL INREAL(ARG,N,PROMPT)
      REAL ARG(N)
      CHARACTER*(*) PROMPT
  1   FORMAT(1X,A,A1,6G12.5)
  2   FORMAT(1X,A,':',$)
      WRITE(6,2)PROMPT
      READ (5,*)ARG
      WRITE(6,1) PROMPT,':',ARG
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE ININT (ARG,N,PROMPT)
      SUBROUTINE ININT(ARG,N,PROMPT)
C usage:  CALL ININT(ARG,N,PROMPT)
      INTEGER ARG(N)
      CHARACTER*(*) PROMPT
  1   FORMAT(1X,A,A1,6I9)
  2   FORMAT(1X,A,':',$)
      WRITE(6,2)PROMPT
      READ (5,*)ARG
      WRITE(6,1) PROMPT,':',ARG
      END

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SUBROUTINE INSTRING(STRING,PROMPT)
      SUBROUTINE INSTRING(STRING,PROMPT)
      CHARACTER*(*) STRING,PROMPT
C usage: CALL INSTRING(STRING,PROMPT)
C INPUT A STRING
      WRITE(6,*)PROMPT
      READ (5,8)STRING
    8 FORMAT(A)
      END

