      program ztrack
c     plot tracks calculated with flux
c all stdin input is done by Fortran READ()
      INCLUDE 'FLUX7.COM'
      logical newstyle
      character*80 text
      character*80 fluxinp
      character*80 fluxtext
      character*3 yes, cursor
      real xn, yn, zn
      DIMENSION zz(100000),YY(100000)
      real ymin0, ymax0
      real XCUR,YCUR
      DATA XCUR,YCUR /0.0, 0.0/
      DATA ZMIN /0/
      DATA fluxinp /'flux input file'/
C
c  The coordinates x,y,z are taken from the 'flux text' file. 
c  Relevant parameters for the scaling are taken from the input
c  file used in the flux simulation. If this file can not be found
c  the parameters are asked from the keyboard.
C
      IPCHOICE= IPCHOOSE(2)
  20  CONTINUE
C
      WRITE(6,21)
  21  FORMAT('FLUX text file:')
      READ(5,24) fluxtext
  24  FORMAT(A80)
      if(LFOPEN(8,fluxtext,'old',0,1).ne.0)goto 20
c extract the name of the original input file from the log file (LU 8)      
      CALL getinp(fluxinp,ier)
      if(ier .eq. 0)goto 26

   34 CONTINUE
C come here when flux input file can not be found
      rewind 8
      write(6,*)'cannot find ',fluxinp
      write(6,*)'give full path name of input file:'
      read(5,24)fluxinp
  26  if(LFOPEN(7,fluxinp,'old',0,1).ne.0)goto 34
      CALL INP(7,ier)
      close(7)
      if(ier.ne.0)STOP 'error in INP'
      AA = UA(1,1)
      zzmax= ZIMAX
      factor= IXYOUT
      AZIMUTH=ANG(2,1)*DEGREE
      SINAZ= SIN(AZIMUTH)
      COSAZ= COS(AZIMUTH)
  
      XUN(1)= 0
      YUN(1)= 0
      ZUNIT = 0
      DO 110 LC=1,NLC(1)
      XUN(1)= XUN(1)+ UA(LC,1)*XUNIT(LC,1)
      YUN(1)= YUN(1)+ UA(LC,1)*YUNIT(LC,1)
      ZUNIT=  UD(1) + UA(LC,1)*DUNIT(LC,1)
110   CONTINUE
      YMIN= -1.2* YUN(1)
      YMAX= +1.2* YUN(1)
C
  35  CONTINUE
      write(6,*) 'change default scale?'
      read(5,'(1A)') yes
      if(yes(1:1).eq.'y' .or. yes(1:1).eq.'Y')then
        write(6,'(A,2F9.1,F8.0,A)')
     +  'ymin, ymax, zmax: [current:', YMIN,YMAX,zzmax, ']'
        read(5,*)  YMIN,YMAX,zzmax
      endif

      ymin0 = ymin
      ymax0 = ymax

      call PGPAGE()
C PLOT AXES
      CALL PGSVP(0.1, 0.75, 0.2, 0.8)
      CALL PGSWIN(ZMIN, zzmax, YMIN, YMAX)
      CALL PGBOX('BCINTS', 0.0, 0, 'BCINTSV', 0.0, 0)
      CALL PGLAB('Z', 'Y',CONFIGID(1)//' '//fluxtext)
C PLOT A HORIZONTAL LINE AT YPOS(I), I=1..NABUR
       NWIDTH=8
       IF(YMAX-YMIN .GT. 8.0) NWIDTH= 64.0/(YMAX-YMIN)
       IF(NWIDTH.LE.0) NWIDTH=1
       CALL PGQLW(LWIDTH)
       CALL PGSLW(NWIDTH)
       DO 50 L=1,NLS(1)
       DO 49 I=1,NABUR(L,1)
       CALL PGMOVE(0.0,
     +  YPOS(I,L,1)*YUN(1)*COSAZ - XPOS(I,L,1)*XUN(1)*SINAZ)
       CALL PGDRAW(zzmax,
     +  YPOS(I,L,1)*YUN(1)*COSAZ - XPOS(I,L,1)*XUN(1)*SINAZ)
   49  CONTINUE
   50  CONTINUE
c same for the YATOM0 coordinates
       DO 51 K=1,Nind(1)
       CALL PGMOVE(0.0,
     +  YATOM(K,1)*YUN(1)*COSAZ - XATOM(K,1)*XUN(1)*SINAZ)
       CALL PGDRAW(zzmax,
     +  YATOM(K,1)*YUN(1)*COSAZ - XATOM(K,1)*XUN(1)*SINAZ)
   51  CONTINUE
C plot vertical line at interface
       Z=0.0
       KL=1
   55  CONTINUE
       Z=Z+ZINTERF(KL)
       IF(Z.LT.zzmax)THEN
         CALL PGMOVE(Z,YMIN)
         CALL PGDRAW(Z,YMAX)
         KL=KL+1
         IF(KL.GT.NLAY)KL=1
         GOTO 55
       ENDIF

       CALL PGSLW(LWIDTH)
CCCCCCCCCCCCCCCCCCCCCCCCCCC here we go 
      ntracks=0
      endoffile=0
  60  CONTINUE
      nn=0
  70  CONTINUE
      read(8,73, err=1000, end= 78) text
      if(text(1:2) .ne. '*x') write(6,73) text
      if(text(1:2) .eq. '*n' .and. ntracks .gt. 0) then
        if(IPCHOICE .lt. 2)then
          WRITE(6,'(''==> Click mouse in PGPLOT Window <=='')')
          CALL PGCURS(XCUR,YCUR,cursor)
        endif
        goto 35
      endif
      if(text(1:2) .ne. '*x')goto 70
      if(text(3:4) .eq. 'yz')then
        ipt=4
        newstyle = .true.
      else
        ipt=2
        newstyle = .false.
      endif
      call getnum(xn,idummy,text,80,ipt,iterm,istat)
      if(istat .lt. 0)goto 1000
      call getnum(yn,idummy,text,80,ipt,iterm,istat)
      if(istat .lt. 0)goto 1000
      call getnum(zn,idummy,text,80,ipt,iterm,istat)
      if(istat .lt. 0)goto 1000
      if( .not. newstyle) zn= zn*ZUNIT
  73  format(A80)
      if(xn.ne.0.0 .or. yn.ne.0.0)then
        nn= nn+1
        zz(nn)= zn
        yy(nn)=yn*COSAZ - xn*SINAZ
        goto 70
      endif
      goto 79
  78  endoffile=1
  79  continue
      if (nn .gt. 0) then
        nc=1
        nnn=nn
c (?)   if(ABS(YY(nn)-YY(nn*2/3)) .GT. 0.2) nnn=1
        if(nnn.gt.1 .and. yy(1).ge.ymin0 .and. yy(1).le.ymax0)then
c C DRAW A SOLID LINE 
          CALL PGLINE(nnn,zz(1),YY(1))
          ntracks= ntracks+1
        endif
      endif
      if(endoffile .eq. 0) GOTO 60
      goto 1999
 1000 continue
      write(6,*)'** read error **'
 1999 continue
      if(IPCHOICE .ge. 2)then
        CALL CLOSEPGFIL
      else
        WRITE(6,'(''==> Click mouse in PGPLOT Window <=='')')
        CALL PGCURS(XCUR,YCUR,cursor)
      endif
      CALL PGEND()
      END
