      PROGRAM PGDEM2
C-----------------------------------------------------------------------
C Demonstration program for PGPLOT. The main program opens the output
C device and calls a series of subroutines, one for each sample plot.
C-----------------------------------------------------------------------
      INTEGER PGOPEN
C
C Call PGOPEN to initiate PGPLOT and open the output device; PGOPEN
C will prompt the user to supply the device name and type.
C
      IF (PGOPEN('?') .LE. 0) STOP
C
C Call the demonstration subroutines.
C
      CALL PGEX23
      CALL PGDEM3
C
C Finally, call PGCLOS to terminate things properly.
C
      CALL PGCLOS
C-----------------------------------------------------------------------
      END


      SUBROUTINE PGEX23
C-----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package.
C-----------------------------------------------------------------------
      INTEGER N
      PARAMETER (N=15)
      REAL X1, Y1
      CHARACTER*80 SAMPLE(N)
      character*1 chars(0:15,2:15)
      character*6 str
      integer i,j

      DATA SAMPLE/
     1 '\frRoman:      ABCDQ efgh 1234 \ga\gb\gg\gd \gL\gH\gD\gW',
     2 '\fiItalic:     ABCDQ efgh 1234 \ga\gb\gg\gd \gL\gH\gD\gW',
     3 '\fRBold:       ABCDQ efgh 1234 \ga\gb\gg\gd \gL\gH\gD\gW',
     4 '\fIBoldItalic: ABCDQ efgh 1234 \ga\gb\gg\gd \gL\gH\gD\gW',
     5 '\fsScript:     ABCDQ efgh 1234 \ga\gb\gg\gd \gL\gH\gD\gW',
     6 '\fif\fr(\fix\fr) = \fix\fr\u2\dcos(2\gp\fix\fr)e\u\fix\fr\u2',
     7 '\fiH\d0\u \fr= 75 \(2233) 25 km s\u-1\d Mpc\u-1\d, at 100 ^C',
     8 '\fiH\d0\u \fr= 75  25 km s\u-1\d Mpc\u-1\d, at 100 ^C',
     9 '\fsL/L\d\(2281)\u\fr = 5\.6 \x 10\u6\d (\gl1216\A)',
     a 'Markers: 3=\m3, 8=\m8, 12=\m12, 28=\m28.',
     b 'Cyrillic: \(2830)\(2912)\(2906)\(2911)\(2919)\(2917)\(2915).',
     c '\f6Cyrillic: _lektronika; The Russians are coming',
     c '\fr         |         |         |         |         |',
     d '\frdot: \.  multiply: \x  \Angstr\370m: \A  backslash: \\',
     e '\fCCourier \fM NewC \fZ ZapfCh \fH Helvetica \fT\fi Times-Italic
     +'/
C
C Call PGENV to initialize the viewport and window.
C Call PGLAB to label the graph.
C
      CALL PGENV(0.,20.,REAL(N),0.,0,-2)
C
      CALL PGSCH(1.35)
      DO 10 I=1,N-1
        X1 = 0.0
        Y1 = REAL(I)-0.5
        CALL PGTEXT(X1, Y1, SAMPLE(I))
        CALL PGQPOS(X1,Y1)
        CALL PGTEXT(X1, Y1, '|')
 10   CONTINUE
      CALL PGPTXT(-1.0,14.0,90.0, 0.0, SAMPLE(N))

      CALL PGLAB(' ',' ', '\fT\fRPGPLOT \fIPostScript \fr fonts')

      do 8 j=2,15
      do 7 i=0,15
      chars(i,j)= char(j*16+i)
   7  continue
   8  continue


      CALL PGENV(0.,20.,15.0,0.,0,-2)
      CALL PGSCH(1.5)
      CALL PGTEXT(0.0, 0.0, '\frThe Symbol font')
      do 11 j=2,15
      if(j.eq.8 .or. j.eq.9)goto 11
      y1= real(J)-0.5
      X1= 0.0
      write(str,12)j*16,':'
 12   format(O3,A2)
      CALL PGTEXT(X1, Y1, str)
      do 13 i=0,15
      x1= REAL(i)+3.0
      CALL PGTEXT(X1,Y1, '\g'//chars(i,j))
 13   CONTINUE
 11   CONTINUE

      CALL PGENV(0.,20.,15.0,0.,0,-2)
      CALL GRGENV('PS_FONT',SAMPLE(1),j)
      IF(J.LE.0) CALL PGTEXT(0.0, 0.0, '\frTimes Roman font')
      IF(J.GT.2) CALL PGTEXT(0.0, 0.0, '\fr'//SAMPLE(1)(1:j)//' font')
      CALL PGSCH(1.5)
      do 31 j=2,15
      if(j.eq.8 .or. j.eq.9)goto 31
      x1=0
      y1= real(J)-0.5
      write(str,32)j*16,':'
 32   format(O3,A2)
      CALL PGTEXT(X1, Y1, str)
      do 33 i=0,15
      x1= REAL(i)+3.0
      CALL PGTEXT(X1,Y1, chars(i,j))
 33   CONTINUE
 31   CONTINUE

      CALL PGSCH(1.0)
C-----------------------------------------------------------------------
      END

      SUBROUTINE PGDEM3
C-----------------------------------------------------------------------
C Demonstration program for the PGPLOT plotting package.
C-----------------------------------------------------------------------
      INTEGER N
      PARAMETER (N=23)
      REAL X1, Y1
      CHARACTER*132 SAMPLE
      integer i

C Call PGENV to initialize the viewport and window.
C Call PGLAB to label the graph.
C
      CALL PGENV(0.,20.,REAL(N),0.,0,-2)
C
      CALL PGSCH(1.0)
      SAMPLE=
     1 '\fxIn a hole in the ground there lived a hobbit.0123456789'
      DO 10 I=1,N
         X1 = 0.0
         Y1 = REAL(I)-0.5
         SAMPLE(3:3)=CHAR(I+ICHAR(' '))
         CALL PGTEXT(X1, Y1, SAMPLE)
 10    CONTINUE
       SAMPLE(1:3)= '\fs'
       CALL PGPTXT(-1.0,REAL(N),90.0, 0.0, SAMPLE)

      CALL PGLAB(' ',' ', '\fT\fRPostScript\fr fonts .  \fiPART 1')

      CALL PGENV(0.,20.,REAL(N),0.,0,-2)
C
      CALL PGSCH(1.0)
      SAMPLE=
     2 '\fxTHE QUICK BROWN FOX JUMPS OVER THE LAZY DOG !?><*+=&^'
      DO 20 I=1,N
         X1 = 0.0
         Y1 = REAL(I)-0.5
         SAMPLE(3:3)=CHAR(I+ICHAR(' '))
         CALL PGTEXT(X1, Y1, SAMPLE)
 20    CONTINUE
       SAMPLE(1:3)= '\fs'
       CALL PGPTXT(-1.0,REAL(N),90.0, 0.0, SAMPLE)

      CALL PGLAB(' ',' ', '\fT\fRPostScript\fr fonts .  \fiPART 2')
      CALL PGSCH(1.0)
C-----------------------------------------------------------------------
      END
