      INTEGER FUNCTION CPCHOOSE(imax)
C ask user to select graphics output device.
C if imax=2, choice between 'screen', and 'file'
C if imax=3, choice between 'screen', 'file', and 'both'
C if 'file' or 'both' is answered, also ask and open plotfile.
C The file name may be given on the same line, or on a separate line.
C In the first case it should start in column 8 or beyond
C if 'screen' is answered open the screen device
C return 1, 2, or 3 for 'screen', 'file', or 'both'
C
C Similar to IPCHOOSE. 
C Use CPCHOOSE when input is done using cio routines
C Use IPCHOOSE when input is done using Fortran READ statements
C
      IMPLICIT NONE
      INTEGER imax, i, KK, idefault, inputlen
      INTEGER LENGTH
      EXTERNAL LENGTH
      PARAMETER(idefault=1)
      CHARACTER*6 GROPT(3)
      CHARACTER*7 GRCHOICE
      CHARACTER*72 GRFILE
      DATA GROPT/'screen','file','both'/

      CALL INSTRING(GRCHOICE,'Graphics output: [screen | file | both]:')
      inputlen=LENGTH(GRCHOICE)
      KK=idefault
      if(inputlen.eq.0)goto 173
      DO 171 I=1,imax
      IF(GRCHOICE(1:inputlen).EQ.GROPT(I)(1:inputlen))GOTO 172
  171 CONTINUE
      write(6,*)'Unrecognized graphics option:',GRCHOICE(1:inputlen)
      stop 'illegal graphics option'
  172 KK=I
  173 CONTINUE
      IF(KK.GE.2)THEN
        CALL INSTRING(GRFILE,'PostScript file:')
        inputlen=LENGTH(GRFILE)
        if(inputlen.eq.0) then
          CALL ASKPGFIL()
        else
          CALL SETPGFIL(GRFILE(1:inputlen))
        endif
        CALL OPENPGPLOT()
      ELSE
        CALL OPENPGDIS()
      ENDIF
      CALL PGASK(.FALSE.)
      CPCHOOSE=KK
      END
***************************************************************
      INTEGER FUNCTION LENGTH(STRING)
      CHARACTER*(*) STRING
      K=LEN(STRING)
      do 55 i=1,K
        if(STRING(i:i) .le. ' ')goto 56
  55  CONTINUE
  56  LENGTH=i-1
      END
***************************************************************
      SUBROUTINE SETPGFIL(PLOTNAME)
      CHARACTER*(*) PLOTNAME
      INCLUDE 'PG.COM'

      PLOTFILE=PLOTNAME
      CALL FEXPANDFN(PLOTFILE)
      NKAR=ITXTOSTR(PLOTFILE,PLOTFILE)
      END
***************************************************************
      SUBROUTINE ASKPGFIL()
      INCLUDE 'PG.COM'

      CHARACTER*72 PLOTNAME
      WRITE(6,*)'PostScript file:'
      READ(5,'(A)')PLOTNAME
      CALL SETPGFIL(PLOTNAME)
      END
