      PROGRAM PLOTXY
C PLOT A FUNCTION OF TWO VARIABLES, F(X,Y).
C OPTIONS INCLUDE CONTOURPLOT, GRADIENT PLOT AND 3-D PLOT
C THE INPUT FILE, CONTAINING THE TWO-DIMENSIONAL ARRAY(S) TO
C BE PLOTTED MAY BE ASCII OR BINARY. IN THE LAST CASE IT SHOULD
C HAVE BEEN MADE WITH THE FORTRAN BINARY WRITE COMMAND,
C e.g. WRITE(7)HEADER,ARRAY
C WHERE THE CONTENTS OF 'HEADER' SHOULD BE AN ASCII TEXT.
C THIS OPTION IS SPECIALLY MADE FOR .FLX FILES OF PROGRAM FLUKS
C
C
      PARAMETER(MAXSIZE=16384)
      PARAMETER(NLEVEL=40)
      COMMON WORK(400),A(MAXSIZE),HITE(5)
      CHARACTER*160 FLKOP
      CHARACTER*1 STRING(128)
      CHARACTER*1 CURCH
      REAL CURX, CURY
      CHARACTER*128 STRING1
      EQUIVALENCE(STRING,STRING1)
      CHARACTER*1 CABF, CLOG
      CHARACTER*80 XYLAB(2),TOPLAB
      COMMON /CAX3D/QAX3D,QSCERR,ZMIN,ZMAX,TIX,TIY,TIZ
      LOGICAL QAX3D,QSCERR
      LOGICAL QNUMTXT
      LOGICAL QDISPLA
      CHARACTER*70 ARGS(3), CURFILNAM
      REAL CONTOURS(NLEVEL)
      REAL TR(6)
      CHARACTER*3 CHARLEV
      CHARACTER*8 searchst
      INTEGER JUST
      INTEGER NLA(6)
      INTEGER NFILNAM
      INTEGER NPALETT
      INTEGER KAPPA
      REAL SMAX
      DATA XYLAB, TOPLAB /'X', 'Y', 'PLOTXY'/
      DATA QNUMTXT/.false./
      DATA QDISPLA/.false./
      DATA CONTOURS/0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1.0,30*1.0/
      DATA TR/0,1,0,0,0,1/
      DATA JUST/0/
      DATA SMAX/0.0/
      DATA NPALETT/1/

      CALL F77START(NARGS,ARGS,3)
      NFIRST=1
      CURX=0
      CURY=0
      IF (NARGS.eq.0) THEN
        write(6,*) 'no input file given, stream mode assumed'
        NFIRST=0
      ENDIF

      ISPGOPEN=0

c 2010, added to stop compiler warnings:
      NFILNAM=0
      lsearch=0
      IAX=0

      DO 99999 NFILE=NFIRST,NARGS
      IF(NFILE.gt.0)THEN
        LU=7
  27    FORMAT('input file: ',A)
        NFILNAM= ITXTOSTR(ARGS(NFILE), CURFILNAM)
        WRITE(6,27) CURFILNAM(1:NFILNAM)
        OPEN(UNIT=LU,FILE=CURFILNAM(1:NFILNAM),STATUS='OLD',ERR=28)
        GOTO 29
  28    STOP 'input file not found'
  29    CONTINUE
      ELSE
        LU=5
      ENDIF
      NINP=0

      IF(ISPGOPEN.EQ.0)THEN
        CALL ASKPGFIL()
        ISPGOPEN=1
      ENDIF

      ISWITCH=9
      CALL FXYMSC('ASCII/FLX/VFINAL/COORD/XCOORD:')
      READ(5,1)CABF
      IF(ICHAR(CABF).gt.ICHAR('Z')) CABF = CHAR ( ICHAR(CABF) - 32)
      CALL FXYMSC('NORMAL/LOG:')
      READ(5,1) CLOG
      IF(ICHAR(CLOG).gt.ICHAR('Z')) CLOG = CHAR ( ICHAR(CLOG) - 32)
  1   FORMAT(A1)
      IEOR = 0
      NSIZE = 0
      IF(CABF.EQ.'F' .OR. CABF.EQ.'V')GOTO 2
      CALL FXYMSC('NX,NY:')
      READ(5,*) NX,NY
      NDX=NX
      NSIZE=NX*NY
      IF(NSIZE.GT.MAXSIZE) THEN
        CALL FXYMSC('too much for this program')
        GOTO 99998
      ENDIF

COME HERE TO READ THE NEXT TWO-DIMENSIONAL ARRAY
  2   CONTINUE
      DO 79 NN=9,ISWITCH
      IF(CABF.EQ.'A')THEN
C ASCII READ:
        IER=3
        DO 218 I=1,NSIZE
  211   IF(IER.GT.0)THEN
  212     READ(LU,'(A)',ERR=9999)STRING1
          IF(STRING1(1:1).EQ.'#') GOTO 212
          IPT=0
        ENDIF
        CALL GETNUM(A(I),IDUM,STRING1,128,IPT,ITERM,IER)
        IF(IER.GT.0)GOTO 211
  218   CONTINUE
      ELSE IF(CABF.EQ.'C' .or. CABF.eq.'X') THEN
C
C READ COORDINATES:
C The input file consists of numbers arranged in columns per line
C two of these columns represent the x- and y-coordinates respectively.
C The data are sorted as N(x,y), where the width and the values
C associated with x- and y-bins depend on input parameters NX,NY,
C x-min, x-max, y-min, y-max.
C Lines beginning with # are skipped
C option 'X' is specifically for FLUX option EXITCOORD
        IF(IEOR.LT.0)GOTO 99998
        DO 73 I=1,NSIZE
  73    A(I)=0
        IF(CABF.eq.'X') THEN
  733     call getcoord(LU,1,WORK(2),WORK(3),WORK(4),WORK(5),offT,ier)
          if(ier.eq.2) goto 733
          if(ier.eq.3) goto 99998
          if(ier.ne.0) goto 9999
          write(6,*)'offsets:',(WORK(I),I=2,5)
        ENDIF
        if(IEOR .le. 0) then
          IF(CABF.EQ.'C') THEN
            CALL FXYMSC('search string:')
            READ(5,'(A7)')searchst
            lsearch= ITXTOSTR(searchst, searchst)
            IF(lsearch .gt. 0) write(6,731) searchst(1:lsearch)
  731       FORMAT('selecting lines beginning with ''',A,'''')
          ELSE IF(CABF.eq.'X') THEN
            CALL FXYMSC('col 2=x, 3=y, 4=th_x, 5=th_y, 6=dE')
          ENDIF
          CALL FXYMSC('x-column, y-column')
          READ(5,*) JX, JY
          CALL FXYMSC('x-min, x-max, y-min, y-max')
          READ(5,*) XMIN,XMAX,YMIN,YMAX 
          XLEFT=XMIN
          XRIGHT=XMAX
          YLOW=YMIN
          YHIGH=YMAX
          QNUMTXT= .TRUE.
        else
          CALL FXYMSC('READ NEXT RECORD')
        endif
        NLINE=0
  74    CONTINUE
        IF(CABF.EQ.'C') THEN
          READ(LU,'(A)',ERR=9999, END=747) STRING1
          IF(STRING1(1:4) .eq. '*new') then
            IEOR=1
            goto 748
          endif
          IF(STRING(1).EQ. '#') goto 74
          IF(lsearch .gt. 0)THEN
            IF(STRING1(1:lsearch) .ne. searchst(1:lsearch)) goto 74
            IPT= lsearch
          ELSE
            IPT=0
          ENDIF
          I=0
  742     CONTINUE
          I= I+1
          CALL GETNUM(WORK(I),IDUM,STRING1,80,IPT,ITERM,IER)
          IF(IER.eq.0)goto 742
          if(I.le.JX .or. I.le.JY)then
            CALL FXYMSC('SHORT LINE:'//STRING1) 
            goto 74
          endif
        ELSE IF(CABF.eq.'X') THEN
c get coordinates, written by FLUX option EXITCO
         call getcoord(LU,0,WORK(2),WORK(3),WORK(4),WORK(5),WORK(6),ier)
         if(ier.eq.2) then
           IEOR=1
           goto 748
         endif
         if(ier.eq.3) goto 747
         if(ier.ne.0) goto 9999
         WORK(4)=ASIN(WORK(4))*57.2958
         WORK(5)=ASIN(WORK(5))*57.2958
         WORK(6)=(offT-WORK(6))*1000.0
        ENDIF
        I=NINT((WORK(JX)-XMIN)*(NX-1)/(XMAX-XMIN))
        J=NINT((WORK(JY)-YMIN)*(NY-1)/(YMAX-YMIN))
C events that are off-limits are put at the edges:
        IF(I.lt.0)I=0
        IF(I.ge.NX)I=NX-1
        IF(J.lt.0)J=0
        IF(J.ge.NY)J=NY-1
        II=J*NX+I+1
        IF(II.gt.0 .and. II.LE.NX*NY)A(II)=A(II)+1
        NLINE=NLINE+1
        GOTO 74
C come here at end-of-file
  747   CONTINUE
        IEOR= -1
  748   CONTINUE
        WRITE(6,*) NLINE, ' data points processed'
      ELSE IF(CABF.EQ.'F' .OR. CABF.EQ.'V') THEN
C FLUX READ. FIRST THE HEADER, THEN THE ARRAY ITSELF:
        CALL FINDFLX(LU,NBIN,NRK,NX,NY,NV,NL,NLA,NLAY,IWEIGHT,IOS)
        IF(IOS.NE.0)GOTO 9999
        LX=NX
        LY=NY
        IF(CABF.EQ.'F')THEN
          NDX=NX
          NSIZE=NX*NY
          NV=0
        ELSE IF(CABF.EQ.'V')THEN
          NDX=NV
          NSIZE=NV*NV
          NX=NV
          NY=NV
        ENDIF
        IF(NSIZE.GT.MAXSIZE) THEN
          CALL FXYMSC('too much for this program')
          GOTO 99998
        ENDIF
        CALL GETFLX(LU,NBIN,LX,LY,NV,NL,NLA,NLAY,IWEIGHT,
     6    FLKOP, WORK(41),WORK(41),WORK(41),A,A)
C THE HEADER IS ALSO OUTPUT:
        WRITE(6,888)FLKOP(1:80),FLKOP(81:160)
  888   FORMAT(A80)
        WRITE(6,889) LX, LY, NV
  889   FORMAT(' NX=',I3,' NY=',I3,' NV=',I3)
      ELSE
        CALL FXYMSC('wrong input format specification')
      ENDIF
      NINP=NINP+1
 79   CONTINUE
      IF(CLOG.EQ.'L')THEN
        DO 902 J=1,NX*NY
 902    IF(A(J).NE.0.0)A(J)=ALOG(A(J))
      ENDIF
  54  ASUM=0.0
      AMIN=A(1)
      AMAX=AMIN
      DO 911 J=1,NX*NY
      AIJ=A(J)
      ASUM=AIJ+ASUM
      IF(AIJ.GT.AMAX)AMAX=AIJ
      IF(AIJ.LT.AMIN)AMIN=AIJ
  911 CONTINUE
      AVERAGE=ASUM/(NX*NY)
      WRITE(6,943)NINP,AMIN,AMAX,AVERAGE
  943 FORMAT('NR:',I2,' MIN=',G9.3,' MAX=',G9.3,' AVERAGE=',G9.3)
      IFLAG=0
      GOTO 55
C COME BACK TO THIS POINT AFTER A GRAPH IS COMPLETED:
555   IF(IFLAG.EQ.0)THEN
        QDISPLA = .true.
c edit june 2018: replace FSLEEP by PGCURS = mouseclick
        write(6,9008)
        CALL PGCURS(CURX, CURY, CURCH)
        WRITE(6,5555)
        READ(5,*)IFLAG
5555    FORMAT('FILE THIS PLOT? (0=NO)')
        IF(IFLAG.NE.0) THEN
          CALL OPENPGPLOT
          IF (KAPPA.EQ.5011) GOTO 5011 
          IF (KAPPA.EQ.3011) GOTO 3011 
          IF (KAPPA.EQ. 402) GOTO 402 
          IF (KAPPA.EQ.7781) GOTO 7781 
        ENDIF
      ELSE
        IFLAG=0
      ENDIF
C ASK OPTION
 55   CALL FXYMSC(
     +'1,2=CONTOUR,3=GRAY,4=3D,5=NUMTXT,6=SMOOT,7=SUM,8=DMP,>8=SKP')
C non advertised options: 0=STOP, -1=ask CURSOR and STOP
      READ(5,*)ISWITCH
      IF(ISWITCH.GT.8)GOTO 2
C           1 2 3 4 5  6  7   8
      GOTO (3,3,5,4,7,86,77,688),ISWITCH
      if(ISWITCH.eq.-1)then
        CALL OPENPGDIS
        write(6,9008)
 9008   FORMAT('==> Click mouse in PGPLOT window <==')
        CALL PGCURS(CURX, CURY, CURCH)
      endif
      GOTO 99998

C OPTION GRAY SCALE MAP / or color image:
5     CONTINUE
      WRITE(6,501)
501   FORMAT('ZMIN,ZMAX')
      READ(5,*) ZMIN,ZMAX
      IF(.not.QNUMTXT)THEN
        XLEFT=1
        XRIGHT=NX
        YLOW=1
        YHIGH=NY
      ENDIF
      TR(2)=(XRIGHT-XLEFT)/(NX-1)
      TR(6)=(YHIGH-YLOW)/(NY-1)
      TR(1)=XLEFT-TR(2)
      TR(4)=YLOW-TR(6)
      CALL OPENPGDIS
      CALL PGASK(.FALSE.)
      CALL PGPAGE()
C RE-ENTRY POINT FOR PLOTFILE OUTPUT:
5011  CONTINUE
      CALL PGENV(XLEFT,XRIGHT,YLOW,YHIGH,JUST,-2)
C for gray scale map NPALETT=1, for color image NPALETT=2
*     NPALETT = 2
      NPALETT = 1
      ICILO=1
      ICIHI=18
      CALL PGSCIR(ICILO, ICIHI)
      BRIGHT = 0.5
      CONTRA  = 1.0
      CALL PALETT(NPALETT, CONTRA, BRIGHT)
      if (NPALETT.eq.1) then
        CALL PGIMAG(A,NDX,NY,1,NX,1,NY,ZMAX,ZMIN,TR)
      else
        CALL PGIMAG(A,NDX,NY,1,NX,1,NY,ZMIN,ZMAX,TR)
        CALL PALETT(1, CONTRA, BRIGHT)
      endif
      CALL PGBOX('IBCNST',0.0,0,'IVBCNST',0.0,0)
      IF(QNUMTXT)CALL PGLAB(XYLAB(1),XYLAB(2),TOPLAB)
      KAPPA= 5011
      GOTO 555

C OPTIONS CONTOUR PLOT:
3     CONTINUE
      WRITE(6,301)
301   FORMAT('INL,ZMIN,DZ,NLABEL')
      READ(5,*) INL,ZMIN,DZ,NLABEL
      if(INL.gt.NLEVEL)then
        write(6,*)'warning: INL set to',NLEVEL,' (is max. value)'
        INL=NLEVEL
      endif
      do 302 I=1,INL
      CONTOURS(I)=(I-1)*DZ + ZMIN
302   CONTINUE
      CALL OPENPGDIS
      CALL PGASK(.FALSE.)
C RE-ENTRY POINT FOR PLOTFILE OUTPUT:
3011  CONTINUE
      IF(ISWITCH.EQ.1)THEN
        IF(.not.QNUMTXT)THEN
            XLEFT=1
          XRIGHT=NX
          YLOW=1
          YHIGH=NY
        ENDIF
        TR(2)=(XRIGHT-XLEFT)/(NX-1)
        TR(6)=(YHIGH-YLOW)/(NY-1)
        TR(1)=XLEFT-TR(2)
        TR(4)=YLOW-TR(6)
        CALL PGENV(XLEFT,XRIGHT,YLOW,YHIGH,JUST,-2)
        CALL PGBOX('IBCNST',0.0,0,'IVBCNST',0.0,0)
        IF(QNUMTXT)CALL PGLAB(XYLAB(1),XYLAB(2),TOPLAB)
      ENDIF
      IF(NLABEL.GE.0)CALL PGCONT(A,NDX,NY,1,NX,1,NY,CONTOURS,INL,TR)
      IF(NLABEL.NE.0)THEN
        do 303 I=1,INL,ABS(NLABEL)
        CI=CONTOURS(I)
        IF(CONTOURS(INL).LT.9.5.AND.DZ.GE.0.1)THEN
          WRITE(CHARLEV,'(F3.1)')CI
        ELSE IF(CONTOURS(INL).LT.999.5.AND.DZ.GE.1)THEN
          WRITE(CHARLEV,'(I3)')NINT(CI)
        ELSE
          WRITE(CHARLEV,'(I3)')I
        ENDIF
        CALL PGCONL(A,NDX,NY,1,NX,1,NY,CONTOURS(I),TR,CHARLEV,20,I)
303     CONTINUE
      ENDIF
      KAPPA= 3011
      GOTO 555

C 3-D OPTION:
  4   CALL FXYMSC('HITE,ANGLA,ANGLB,XLEN,YLEN')
      READ(5,*)HITE(1),ANGLA,ANGLB,XLEN,YLEN
      IF(ABS(HITE(1)).GE.10000.0)THEN
          CALL FXYMSC('ZMIN,ZMAX,TIX,TIY,TIZ')
          READ(5,*)ZMIN,ZMAX,TIX,TIY,TIZ
      ENDIF
      MX0=1
      MY0=1
      NX1=NX
      NY1=NY
      IF(HITE(1).LT.0.0)THEN
          CALL FXYMSC('ANGLP,X0,Y0,Z0')
          READ(5,*) HITE(2),HITE(3),HITE(4),HITE(5)
C BEWARE: THE LINE ABOVE MIGHT BE REPLACED BY
C         READ(5,*)(HITE(J),J=2,5)
C HOWEVER THEN AN ERRATIC BEHAVIOUR OF THE FORTRAN READ OCCURS
C WHEN A SLASH ( / ) IS INPUT IN RESPONSE TO THE PREVIOUS READ !!?
 4400     CALL FXYMSC('MX0,MY0 IS "ORIGIN". SHOULD BE > 0')
          CALL FXYMSC('NX1,NY1 IS SUB-SIZE TO BE PLOTTED')
          CALL FXYMSC('MX0,MY0,NX1,NY1')
          READ(5,*)MX0,MY0,NX1,NY1
          IF(MX0.LE.0.OR.MY0.LE.0.OR.NX1+MX0.GT.NX+1.OR.NY1+MY0.GT.NY+1)
     +    THEN
              CALL FXYMSC('VALUES GIVEN WERE ILLEGAL, TRY AGAIN')
              GOTO 4400
          ENDIF
      ELSE
          HITE(2)=0
          HITE(3)=0
          HITE(4)=0
          HITE(5)=0
      ENDIF
      CALL OPENPGDIS
      CALL PGASK(.FALSE.)
C RE-ENTRY POINT FOR PLOTFILE OUTPUT:
402   CONTINUE
      CALL PGPAGE()
      NN0=MX0+(MY0-1)*NDX
      CALL PGSVP(0.0, 1.0, 0.0, 1.0)
      CALL PGSWIN(0.0, 200.0, 0.0, 180.0)
      CALL SYMBOL (100.0,170.0,1.0,'ANGLA ANGLB ANGLP   X0   Y0   Z0',
     + 0.0,32)
      WRITE(STRING1,229) ANGLA,ANGLB,HITE(2),HITE(3),HITE(4),HITE(5)
  229 FORMAT(6F6.0)
      CALL SYMBOL (100.0,160.0,1.0,STRING1,0.0,36)
      IF(IFLAG.EQ.0 )THEN
      ELSE
          CALL FXYMSC('TEXT FOR PLOT')
          READ(5,'(A40)') STRING1
          CALL SYMBOL (100.0,175.0,1.0,STRING1,0.0,40)
      ENDIF
      CALL PGBBUF
      CALL THREED(A(NN0),NDX,NX1,NY1,HITE,ANGLA,ANGLB,XLEN,YLEN)
      CALL PGEBUF
      KAPPA= 402
      GOTO 555

c option sum
  77  CONTINUE
      WRITE(6,771)
  771 FORMAT('SUM X=1, Y=2, REFLECT X=3, Y=4:')
      READ(5,*) IWIE
      IF (IWIE.EQ.1) THEN
          DO 772 IY=1,NY
          SUM=0.0
          IB=(IY-1)*NDX
          DO 773 IX=1,NX
          SUM=SUM+A(IB+IX)
  773     CONTINUE
          WORK(IY)=SUM
  772     CONTINUE
          NN=NY
          IAX=2
          GOTO 778
      ELSE IF (IWIE.EQ.2) THEN
          DO 777 IX=1,NX
          SUM=0.0
          DO 776 IY=1,NY
          SUM=SUM + A( IX +(IY-1)*NDX )
  776     CONTINUE
          WORK(IX)=SUM
  777     CONTINUE
          NN=NX
          IAX=1
          GOTO 778
      ELSE IF (IWIE.EQ.3) THEN
          DO 782 IY=1,NY
          IB=(IY-1)*NDX
          IC=IB+NX+1
          DO 783 IX=1,NX/2
          TMP=A(IB+IX)
          A(IB+IX)=A(IC-IX)
  783     A(IC-IX)=TMP
  782     CONTINUE
          GOTO 55
      ELSE IF (IWIE.EQ.4) THEN
          DO 787 IX=1,NX
          DO 786 IY=1,NY/2
          TMP=A(IX + (IY-1)*NDX )
          A(IX + (IY-1)*NDX ) = A(IX + (NY-IY)*NDX)
  786     A(IX + (NY-IY)*NDX) = TMP
  787     CONTINUE
          GOTO 55
      ENDIF
  778 CONTINUE
      SUM0=0.0
      SUM1=0.0
      SUM2=0.0
      DO 7782 I0=1,NN
      SUM0 = WORK(I0) + SUM0
      SUM1 = WORK(I0)*I0 + SUM1
 7782 CONTINUE
      IF(SUM0 .eq. 0.0)goto 7781
      AMOM1 = SUM1/SUM0
      DO 7783 I0=1,NN
      SUM2 = WORK(I0)*((I0-AMOM1)**2) + SUM2
 7783 CONTINUE
      AMOM2 = SQRT(SUM2/SUM0) 
      WRITE(6,7784) AMOM1, AMOM2
 7784 FORMAT(' MEAN I =', F7.3, ' STANDARD DEV =', F7.3)
      CALL OPENPGDIS
      CALL PGASK(.FALSE.)
C RE-ENTRY POINT FOR PLOTFILE OUTPUT:
 7781 CONTINUE
      AMIN= 0.5
      AMAX= NN+0.5
      IF(QNUMTXT)THEN
        IF(IWIE.EQ.1)THEN
          AMIN=YLOW
          AMAX=YHIGH
        ELSE IF(IWIE.eq.2)THEN
          AMIN=XLEFT
          AMAX=XRIGHT
        ENDIF
      ENDIF
      CALL PLOTJE(WORK,NN,AMIN,AMAX,XYLAB(IAX),TOPLAB,SMAX)
      KAPPA= 7781
      GOTO 555

c option DMP: write out array FLUX to LU=15
  688 CONTINUE
      WRITE(15,*)NX, NY
      DO 1688 J=1,NY
      DO 2688 I=1,NX
      WRITE(15,*)A(I + (J-1)*NDX)
 2688 CONTINUE
 1688 CONTINUE
      GOTO 55

C NUMTXT
 7    CONTINUE
      WRITE(6,701)
701   FORMAT('XMIN,XMAX,YMIN,YMAX')
      READ(5,*)XLEFT,XRIGHT,YLOW,YHIGH
      WRITE(6,702)
702   FORMAT('TEXT FOR X-AXIS, TEXT FOR Y-AXIS, TOP label (3 lines)')
      READ(5,703)XYLAB(1)
      READ(5,703)XYLAB(2)
      READ(5,703)TOPLAB
703   FORMAT(A80)
      QNUMTXT=.true.
      WRITE(6,704)
704   FORMAT('The same scale for X and Y axes? (0=N0, 1=YES):')
      READ(5,*) JUST
      GOTO 55

c option SMOOTH
86    CALL SMOOTH(A,NDX,NX,NY)
      GOTO 54

 9999 WRITE(6,*) CURFILNAM(1:NFILNAM), ': end of file or read error'
99998 CLOSE (LU)
99999 CONTINUE
      CALL CLOSEPGFIL
      CALL PGEND()
      END
***************************************************************
      SUBROUTINE SMOOTH(A,NDX,NX,NY)
      IMPLICIT NONE
      REAL A
      INTEGER NDX,NX,NY
      DIMENSION A(NDX,NY)

      INTEGER I,J,K,L,IM,JM,IP,JP
      REAL S

      DO 1 K=1,2
      DO 1 L=1,2
      DO 1 I=K,NX,2
      DO 1 J=L,NY,2
      IM=I-1
      JM=J-1
      IP=I+1
      JP=J+1
      IF(IM.LT.1)IM=1
      IF(JM.LT.1)JM=1
      IF(IP.GT.NX)IP=NX
      IF(JP.GT.NY)JP=NY
      S=(A(I,JM)+A(I,JP)+A(IM,J)+A(IP,J))*0.125
     + +(A(IM,JM)+A(IM,JP)+A(IP,JM)+A(IP,JP))*0.0625 + A(I,J)*0.25
      A(I,J)=S
1     CONTINUE
      END
**********************************************************
      SUBROUTINE PLOTJE(WORK,NN,ALEFT,ARIGHT,XLAB,TOPLAB, YMAX)
C plot array work(1) .. work(NN)
C ALEFT, ARIGHT: axis information
      INTEGER NN
      REAL WORK(NN)
      REAL ALEFT,ARIGHT
      CHARACTER*80 XLAB, TOPLAB

      XXX(J)=((FLOAT(J)-0.5)*ARIGHT+(FLOAT(NN-J)+0.5)*ALEFT)/FLOAT(NN)

      IF(YMAX .LE. 0)THEN
        DO 6 J=1,NN
        IF(WORK(J) .gt. YMAX) YMAX=WORK(J)
   6    CONTINUE
      ENDIF
      CALL PGENV(ALEFT, ARIGHT, 0.0, YMAX*1.2, 0, 0)
      DO 7 J=1,NN
      CALL PGPT(1, XXX(J), WORK(J), 9)
   7  CONTINUE
      CALL PGMOVE(XXX(1), WORK(1))
      DO 8 J=2,NN
      CALL PGDRAW(XXX(J), WORK(J))
   8  CONTINUE
      CALL PGLAB(XLAB,'sum',TOPLAB)
      END

      subroutine SYMBOL(x, y, size, text, angle, nchar)
      character*(*) text

      if(len(text).gt.0)then
      call PGQCH(oldsize)
      call PGSCH(size)
      call PGPTXT(x, y, angle, 0, text(1:nchar))
      call PGSCH(oldsize)
      else
      write(6,*)'warning! PLOTXY:SYMBOL called with zero length text!'
      endif
      end

      SUBROUTINE PALETT(TYPE, CONTRA, BRIGHT)
C-----------------------------------------------------------------------
C Set a "palette" of colors in the range of color indices used by
C PGIMAG.
C From the PGPLOT distribution file pgdemo4.f
C-----------------------------------------------------------------------
      INTEGER TYPE
      REAL CONTRA, BRIGHT
C
      REAL GL(2), GR(2), GG(2), GB(2)
      REAL RL(9), RR(9), RG(9), RB(9)
      REAL HL(5), HR(5), HG(5), HB(5)
      REAL WL(10), WR(10), WG(10), WB(10)
      REAL AL(20), AR(20), AG(20), AB(20)
C
      DATA GL /0.0, 1.0/
      DATA GR /0.0, 1.0/
      DATA GG /0.0, 1.0/
      DATA GB /0.0, 1.0/
C
      DATA RL / 0.0, 0.1, 0.17, 0.33, 0.50, 0.67, 0.83, 1.0, 1.0/
      DATA RR / 1.0, 0.0,  0.0,  0.0,  0.6,  1.0,  1.0, 1.0, 1.0/
      DATA RG / 1.0, 0.2,  0.5,  1.0,  1.0,  1.0,  0.6, 0.0, 1.0/
      DATA RB / 1.0, 0.3,  0.6,  1.0,  0.3,  0.0,  0.0, 0.0, 1.0/
C
      DATA HL /0.0, 0.2, 0.4, 0.6, 1.0/
      DATA HR /0.0, 0.5, 1.0, 1.0, 1.0/
      DATA HG /0.0, 0.0, 0.5, 1.0, 1.0/
      DATA HB /0.0, 0.0, 0.0, 0.3, 1.0/
C
      DATA WL /0.0, 0.5, 0.5, 0.7, 0.7, 0.85, 0.85, 0.95, 0.95, 1.0/
      DATA WR /0.0, 1.0, 0.0, 0.0, 0.3,  0.8,  0.3,  1.0,  1.0, 1.0/
      DATA WG /0.0, 0.5, 0.4, 1.0, 0.0,  0.0,  0.2,  0.7,  1.0, 1.0/
      DATA WB /0.0, 0.0, 0.0, 0.0, 0.4,  1.0,  0.0,  0.0, 0.95, 1.0/
C
      DATA AL /0.0, 0.1, 0.1, 0.2, 0.2, 0.3, 0.3, 0.4, 0.4, 0.5,
     :         0.5, 0.6, 0.6, 0.7, 0.7, 0.8, 0.8, 0.9, 0.9, 1.0/
      DATA AR /1.0, 0.2, 0.3, 0.3, 0.5, 0.5, 0.0, 0.0, 0.0, 0.0,
     :         0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0/
      DATA AG /1.0, 0.2, 0.3, 0.3, 0.0, 0.0, 0.0, 0.0, 0.8, 0.8,
     :         0.6, 0.6, 1.0, 1.0, 1.0, 1.0, 0.8, 0.8, 0.0, 0.0/
      DATA AB /1.0, 0.2, 0.3, 0.3, 0.7, 0.7, 0.7, 0.7, 0.9, 0.9,
     :         0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0/
C
      IF (TYPE.EQ.1) THEN
C        -- gray scale
         CALL PGCTAB(GL, GR, GG, GB, 2, CONTRA, BRIGHT)
      ELSE IF (TYPE.EQ.2) THEN
C        -- rainbow
         CALL PGCTAB(RL, RR, RG, RB, 9, CONTRA, BRIGHT)
      ELSE IF (TYPE.EQ.3) THEN
C        -- heat
         CALL PGCTAB(HL, HR, HG, HB, 5, CONTRA, BRIGHT)
      ELSE IF (TYPE.EQ.4) THEN
C        -- weird IRAF
         CALL PGCTAB(WL, WR, WG, WB, 10, CONTRA, BRIGHT)
      ELSE IF (TYPE.EQ.5) THEN
C        -- AIPS
         CALL PGCTAB(AL, AR, AG, AB, 20, CONTRA, BRIGHT)
      END IF
      END
