C ************* THREE D ***************************************
      SUBROUTINE THREED(A,MAXN,NI,NJ,HIT,ANGLA,ANGLB,XS,YS)
C
C THE 3D FIGURE IS SCALED IN A BOX OF ABS(NI)*ABS(NJ)*ABS(HITE)
C
C FUNCTION VALUES IN ARRAY A, DIMENSION A(MAXN,NJ).
C
C HIT IS A 5 ELEMENT ARRAY.
C HOWEVER IF HIT(1).GE.0.0 ONLY THE FIRST ELEMENT IS USED, AND
C  HIT MAY ALSO BE A SIMPLE VARIABLE.
C  IF ABS(HIT(1)).GE.10000.0 3-D AXES WITH TICKMARKS ARE DRAWN.
C  IF HIT(1).LT. 0.0, A 3D FIGURE WITH PERSPECTIVE IS DRAWN.
C
C HITE [=ABS(HIT(1)) OR ABS(HIT(1))-10000.0] IS THE HEIGHT OF THE
C  FIGURE (BEFORE PROJECTION) IN THE SAME UNITS AS NI AND NJ,
C  I.E. Z IS SCALED TO Z*HITE/(ZMAX-ZMIN).
C
C PARAMETERS FOR AXES ARE TO BE SUPPLIED VIA COMMON BLOCK CAX3D:
C     COMMON /CAX3D/ QAX3D,QSCERR,ZZ1,ZZ2,TIX,TIY,TIZ
C     LOGICAL QAX3D,QSCERR; VALUE IRRELEVANT TO USER.
C  ZZ1,ZZ2 : MIN. AND MAX. VALUES OF Z.
C        IF ZZ1=ZZ2 MIN. AND MAX. VALUES TAKEN FROM DATA.
C        IF DATA OUTSIDE ZZ1,ZZ2 OCCUR TRUNCATION TAKES PLACE.
C  TIX,TIY,TIZ: DISTANCES BETWEEN TICK MARKS
C   IF TIZ<0 : DISTANCE BETWEEN TICK MARKS IS (ZMAX-ZMIN)/(-TIZ)
C   (FOR Z AXIS ONLY).
C
C PARAMETERS FOR PERSPECTIVE PROJECTION:
C  HIT(2)= HALF-ANGLE UNDER WHICH THE 'OBJECT' IS SEEN.
C  HIT(3)..HIT(5): X0,Y0,Z0 = CENTRAL POINT.
C
C THE BOX IS PROJECTED IN PERSPECTIVE FROM DIRECTION ANGLA,ANGLB
C
C ABS(XS) AND ABS(YS) SPECIFY THE MAXIMUM HORIZONTAL & VERTICAL SIZE OF
C  THE    P R O J E C T E D   FIGURE.
C THE PROJECTION IS SCALED ( WITHOUT DISTORTION) TO FILL AS MUCH
C AS POSSIBLE OF THE RECTANGLE ABS(XS)*ABS(YS)
C
C XS < 0 : NO LINES IN X-DIRECTION
C YS < 0 : NO LINES IN Y-DIRECTION
C
      COMMON/COMTRD/NMAX,N,M,HITE,SA,CA,SB,CB,XSS,YSS,H0,V0,H1,V1,SH,SV,
     2  XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,ZSC,X0,Y0,Z0,SX
      DIMENSION H(2),V(2),A(MAXN,NJ),HIT(5)
      COMMON /CAX3D/ QAX3D,QSCERR,ZZ1,ZZ2,TIX,TIY,TIZ
C
      LOGICAL QAX3D,QSCERR
C
      PARAMETER (RADIAN=3.141593/180.0)
C
      NMAX=MAXN
      N=IABS(NI)
      M=IABS(NJ)
C
      QAX3D=.FALSE.
      HITE=ABS(HIT(1))
      IF (HITE .GE. 10000.0 ) THEN
C     BEGIN AXES SEE FRAME3D
C     AXIS INFORMATION IN /CAX3D/
          QAX3D=.TRUE.
          HITE=HITE-10000.0
C     END   AXES SEE FRAME3D
      ENDIF
      IF(HITE .EQ. 0.0) HITE=(NI+NJ)/2
C
C
      YSS=ABS(YS)
      XSS=ABS(XS)
      IF(FLOAT(N*M)*XS*YS.EQ.0.0) THEN
      CALL FXYMSC('THREED : NX,NY,XLEN OR YLEN IS 0 !')
                             RETURN
      ENDIF
C
      ANGA=ANGLA*RADIAN
      ANGB=ANGLB*RADIAN
      SA=SIN(ANGA)
      CA=COS(ANGA)
      SB=SIN(ANGB)
      CB=COS(ANGB)
      IF(ABS(CB).LT.0.01)THEN
      CALL FXYMSC('THREED:  ******* TILT!!!!! ******')
      CALL FXYMSC('YOU ARE TRYING TO LOOK STRAIGHT DOWN AT THE SURFACE')
                             RETURN
      ENDIF
      XMIN=1.
      XMAX = N
      YMIN=1.
      YMAX = M
      ZMIN=A(1,1)
      ZMAX=ZMIN
      DO 170 I=1,N
      DO 170 J=1,M
      IF(ZMIN.GT.A(I,J))ZMIN=A(I,J)
      IF(ZMAX.LT.A(I,J))ZMAX=A(I,J)
170   CONTINUE
      IF(ZMIN.EQ.ZMAX)THEN
          CALL FXYMSC('THREED: *** ALL Z VALUES EQUAL ***')
          RETURN
      ENDIF
C
      IF(QAX3D)THEN
C BEGIN 3D AXIS , SEE /CAX3D/
C QSCERR IS FLAG FOR INTERACTIVE TEKTRONIX VERSION
          QSCERR=.FALSE.
C ZZ1=ZZ2 : Z-AXIS COMPLETELY FILLED
          IF(ZZ1.EQ.ZZ2)         GO TO 26
          IF( ZMIN.LT.ZZ1 .OR. ZMAX .GT.ZZ2) THEN
              QSCERR=.TRUE.
              CALL FXYMSC('3D AXES :   Z-VALUES OUTSIDE (Z1,Z2) ')
C NOT AN ERROR BUT A WARNING: PICTURE IS TRUNCATED.
          ENDIF
          ZMIN=ZZ1
          ZMAX=ZZ2
      ENDIF
C END       3D AXIS , SEE /CAX3D/
   26 CONTINUE
C
C SCALING FACTOR FOR Z:
      ZSC=HITE/(ZMAX-ZMIN)
C
C PERSPECTIVE.
C CENTRAL POINT IS X0,Y0,Z0. 1/SX IS THE OBSERVERS DISTANCE.
      X0=0.0
      Y0=0.0
      SX=0.0
      IF(HIT(1).LT.0.0)SX=HIT(2)
      IF (SX .NE. 0.0) THEN
          SX=SIN(SX*RADIAN)/(COS(SX*RADIAN)*0.5*SQRT((XMAX-XMIN)**2+
     2       (YMAX-YMIN)**2+HITE**2))
          X0=HIT(3)
          Y0=HIT(4)
          Z0=HIT(5)
      ENDIF
C
C MAKE SURE Z-AXIS IS IN THE PICTURE
      CALL XOTATE(1.0,1.0,ZMAX,H0,V0)
      H1=H0
      V1=V0
C GET HORIZONTAL AND VERTICAL BOUNDS OF PICTURE AND GROUND PLANE.
      DO 193 I=1,N
      XI=I
      DO 193 J=1,M
      YJ=J
      ZK=A(I,J)
      IF(ZK.LT.ZMIN)ZK=ZMIN
      IF(ZK.GT.ZMAX)ZK=ZMAX
      CALL XOTATE(XI,YJ,ZK,H(1),V(1))
      CALL XOTATE(XI,YJ,0.0,H(2),V(2))
      DO 193 K=1,2
      IF(H(K).LT.H0)H0=H(K)
      IF(H(K).GT.H1)H1=H(K)
      IF(V(K).LT.V0)V0=V(K)
      IF(V(K).GT.V1)V1=V(K)
193   CONTINUE
C SCALE IN XSIZE*YSIZE WITHOUT DISTORTION
      SH=XSS/(H1-H0)
      SV=YSS/(V1-V0)
      IF (SH.LT.SV) THEN
          SV=SH
      ELSE
          SH=SV
      ENDIF
C
C    FIX PLOT-ORIGIN
      CALL PLOT ( 20.0, 10.0, -3)
C
      IF(XS.GT.0.0) CALL SLICE3D(A,1,2,N,M)
      IF(YS.GT.0.0) CALL SLICE3D(A,2,1,M,N)
      IF (QAX3D) CALL FRAME3D(A)
C
      END
C **** AX3D: PLOT AN AXIS FOR A THREE-D GRAPH. ****
      SUBROUTINE AX3D(A,X1,X2,DI,KI,DL,KL,INCS,NAME)
      CHARACTER*1 NAME
      COMMON/COMTRD/NMAX,N,M,HITE,SA,CA,SB,CB,XSS,YSS,H0,V0,H1,V1,SH,SV,
     2  XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,ZSC,X0,Y0,Z0,SX
      DIMENSION A(NMAX,M),X1(3),X2(3),XC(3),XT(3)
C
C     GOTO X1 WITH PEN UP
      IQ=0
      DO 10 I=1,3
10    XC(I)=X1(I)
C     MAIN LOOP. START WITH TICKMARK
100   CALL CANSEE(A,XC(1),XC(2),XC(3),IP)
      XC(KL)=XC(KL)+DL
      CALL PLOT3D(XC,IP,IQ)
      XC(KL)=XC(KL)-DL
      CALL PLOT3D(XC,IP,IQ)
C     INNER LOOP. MOVE TO NEXT TICKMARK IN INCS STEPS
      DO 2 J=1,INCS
      XC(KI)=XC(KI)+DI
C     CHECK IF DONE. ASSUME DI.GE.0.0
      IF(XC(KI)-X2(KI).GT.0.5*DI)GOTO 3
      CALL CANSEE(A,XC(1),XC(2),XC(3),IP)
      CALL PLOT3D(XC,IP,IQ)
 2    CONTINUE
      GOTO 100
3     CONTINUE
C     XC NOW POINTS ONE INCREMENT DX BEYOND END OF AXIS.
C     IF THIS IS OUTSIDE THE PLOT,DRAW ARROW AND NAME
      CALL XOTATE(XC(1),XC(2),XC(3),HH,VV)
      IF(HH.LE.H0 .OR. HH.GE.H1 .OR. VV.LE.V0 .OR. VV.GE.V1)THEN
          IQ=1
          IP=1
          XC(KI)=XC(KI)+DI
          DO 303 I=1,3
  303     XT(I)=XC(I)
          XT(KL)=XT(KL)-DL*0.3
          XT(KI)=XT(KI)-DI*0.6
          CALL PLOT3D(XC,IP,IQ)
          CALL PLOT3D(XT,IP,IQ)
          XT(KL)=XT(KL)+DL*0.6
          CALL PLOT3D(XT,IP,IQ)
          CALL PLOT3D(XC,IP,IQ)
C     ONE STEP FURTHER AND CALL SYMBOL
          XC(KI)=XC(KI)+DI
          IQ=0
          CALL PLOT3D(XC,IP,IQ)
             CALL PGQPOS(HH,VV)
             CALL SYMBOL(HH,VV,1.0,NAME,0.0,1)
      ENDIF
      END
C **** CANSEE:RETURN P=1 IF POINT IS VISIBLE, P=0 IF IT IS HIDDEN ****
      SUBROUTINE CANSEE(Z,XI,YJ,ZK,P)
      COMMON/COMTRD/NMAX,N,M,HITE,SA,CA,SB,CB,XSS,YSS,H0,V0,H1,V1,SH,SV,
     2  XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,ZSC,X0,Y0,Z0,SX
      DIMENSION Z(NMAX,M)
      INTEGER P
      LOGICAL NHIGHER,NLOWER
C
      CALL XOTATE(XI, YJ, ZK, H, ZS)
C
C FIND DIRECTION OF STEP VECTOR:
      DELX=CA*CB + (H*SA+ZS*CA*SB)*SX
      DELY=SA*CB + (ZS*SA*SB-H*CA)*SX
C
      NHIGHER=.FALSE.
      NLOWER =.FALSE.
      P=1
      XB=XI
      YB=YJ
      GOTO 364
   30 CONTINUE
C WHERE ARE THE NEXT INTEGER X AND Y VALUES?
      IF(DELX)40,41,42
40    XINT=AINT(XB-0.002)
      GOTO 44
41    XINT=XB
      DY=1.0E10
      GOTO 47
42    XINT=AINT(XB+1.002)
44    DY=(XINT-XB)*DELY/DELX
C
47    IF(DELY)50,51,52
50    YINT=AINT(YB-0.002)
      GOTO 53
51    YINT=YB
      DX=1.0E10
      GOTO 60
52    YINT=AINT(YB+1.002)
53    DX=(YINT-YB)*DELX/DELY
60    CONTINUE
C
C TAKE THE SMALLEST OF THESE TWO STEPS.
      STEPX=(XINT-XB)**2+DY**2
      STEPY=(YINT-YB)**2+DX**2
      IF(STEPX.LT.STEPY)THEN
          XB=XINT
          YB=YB+DY
      ELSE
          XB=XB+DX
          YB=YINT
      ENDIF
C CHECK IF WE CROSSED A BORDER. IF SO, EXIT WITH P=1.
      IF(XB.LT.1.0 .OR. XB.GT.XMAX .OR. YB.LT.1.0 .OR. YB.GT.YMAX)RETURN
C FIND Z BY LINEAR INTERPOLATION ALONG THE BORDERS OF A SQUARE.
 364  I1=XB
      I2=I1+1
      DX=XB-FLOAT(I1)
      J1=YB
      J2=J1+1
      DY=YB-FLOAT(J1)
      ZZ=Z(I1,J1)*(1.0-DX-DY)
C NOTE. THE FOLLOWING RELIES ON EITHER DX OR DY (OR BOTH) BEING 0.
C TEST FOR DX=DY=0 NECESSARY TO STAY WITHIN ARRAY BOUNDS.
      IF(DX.LT.0.002 .AND. DY.LT.0.002) GOTO 100
      IF ( DX.LT.0.002 ) THEN
          ZZ=ZZ+Z(I1,J2)*DY
      ELSE
          ZZ=ZZ+Z(I2,J1)*DX
      ENDIF
100   CONTINUE
C TRUNCATE IF OUTSIDE RANGE.
      IF ( ZZ.GT.ZMAX ) ZZ=ZMAX
      IF ( ZZ.LT.ZMIN  ) ZZ=ZMIN
      CALL XOTATE(XB, YB, ZZ, H, ZB)
      NLOWER=NLOWER .OR. ZB-ZS .LT. -ABS(ZS*0.001)
      NHIGHER=NHIGHER.OR.ZB-ZS .GT. ABS(ZS*0.001)
      IF ( .NOT. (NLOWER.AND.NHIGHER) ) GOTO 30
C LOWER AS WELL AS HIGHER POINTS IN PATH: EXIT WITH P=0.
      P=0
      END
C **** FRAME3D: DRAW AXES FOR THREED *****
      SUBROUTINE FRAME3D(A)
      COMMON/COMTRD/NMAX,N,M,HITE,SA,CA,SB,CB,XSS,YSS,H0,V0,H1,V1,SH,SV,
     2  XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,ZSC,X0,Y0,Z0,SX
      DIMENSION A(NMAX,M)
      COMMON /CAX3D/ QAX3D,QSCERR,ZZ1,ZZ2,TIX,TIY,TIZ
      LOGICAL QAX3D
C
      DIMENSION CORNER(3,8)
      DATA ((CORNER(I,J),I=1,2),J=1,8) /16*1.0/
C
      CORNER(1,2)=XMAX
      CORNER(1,4)=XMAX
      CORNER(2,3)=YMAX
      CORNER(2,4)=YMAX
      DO 1 I=5,8
      CORNER(3,I)=ZMAX
      CORNER(1,I)=CORNER(1,I-4)
      CORNER(2,I)=CORNER(2,I-4)
  1   CONTINUE
      IX=TIX
      IY=TIY
      DIZ=TIZ
      IF(DIZ.LT.0.0)DIZ=-ZMAX/DIZ
      IZ=TIZ*ZSC
      IF(IX.LE.0)IX=1
      IF(IY.LE.0)IY=1
      IF(IZ.LE.0)IZ=1
      DX=TIX/IX
      DY=TIY/IY
      DZ=DIZ/IZ
      CALL AX3D(A,CORNER(1,1),CORNER(1,2),DX,1,-DY,2,IX,' ')
      CALL AX3D(A,CORNER(1,2),CORNER(1,4),DY,2, DX,1,IY,' ')
      CALL AX3D(A,CORNER(1,1),CORNER(1,3),DY,2,-DX,1,IY,' ')
      CALL AX3D(A,CORNER(1,3),CORNER(1,4),DX,1, DY,2,IX,' ')
      CALL AX3D(A,CORNER(1,5),CORNER(1,6),DX,1,-DY,2,IX,' ')
      CALL AX3D(A,CORNER(1,5),CORNER(1,7),DY,2,-DX,1,IY,' ')
      CALL AX3D(A,CORNER(1,1),CORNER(1,5),DZ,3,-DX,1,IZ,' ')
      CALL AX3D(A,CORNER(1,2),CORNER(1,6),DZ,3, DX,1,IZ,' ')
      CALL AX3D(A,CORNER(1,3),CORNER(1,7),DZ,3,-DX,1,IZ,' ')
      CALL AX3D(A,CORNER(1,7),CORNER(1,8),DX,1, DY,2,IX,'X')
      CALL AX3D(A,CORNER(1,6),CORNER(1,8),DY,2, DX,1,IY,'Y')
      CALL AX3D(A,CORNER(1,4),CORNER(1,8),DZ,3, DX,1,IZ,'Z')
      END
      SUBROUTINE FXYMSC(MESS)
      CHARACTER*(*) MESS
C WRITE CHARACTER STRING MESS TO CONSOLE 
      WRITE(6,28)MESS
  28  FORMAT(A)
      END
        SUBROUTINE PLOT(X,Y,MODE)
        real X,Y
        integer MODE

        integer NEWMODE, OLDMODE
        real xbase, ybase
        save OLDMODE, xbase, ybase
        data OLDMODE/3/
        data xbase, ybase /0.0, 0.0/

        NEWMODE=MODE
        if(MODE.eq.0)NEWMODE=OLDMODE
        if(MODE.gt.0)OLDMODE=MODE

        if(NEWMODE.eq.2)then
           CALL PGDRAW(X+xbase,Y+ybase)
        else  if(NEWMODE.eq.3)then
           CALL PGMOVE(X+xbase,Y+ybase)
        else if(MODE.eq. -3) then
           xbase=X
           ybase=Y
        else
          write(6,*) 'PLOT', X,Y, MODE
        endif
        end
      SUBROUTINE PLOT3D(X,IP,IQ)
      COMMON/COMTRD/NMAX,N,M,HITE,SA,CA,SB,CB,XSS,YSS,H0,V0,H1,V1,SH,SV,
     2  XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,ZSC,X0,Y0,Z0,SX
      DIMENSION X(3)
      CALL XOTATE(X(1),X(2),X(3),H,V)
      CALL PLOT((H-H0)*SH,(V-V0)*SV,3-IP*IQ)
      IQ=IP
      END
C **** SCANSEE: DETERMINE TRANSITION POINT ****
      SUBROUTINE SCANSEE( Z, X1, X2, XT, IP, IQ )
C DIMENSION OF Z IRRELEVANT FOR THIS ROUTINE.
      DIMENSION Z(1,1),X1(3),X2(3),XT(3)
      FRAC=0.5
      DFRAC=0.25
      DO 100 I=1,3
100   XT(I)= 0.5*(X1(I)+X2(I))
      DO 1 K=1,6
      CALL CANSEE(Z,XT(1),XT(2),XT(3),NP)
      IF (NP.EQ.IP) THEN
          FRAC=FRAC+DFRAC
      ELSE
          FRAC=FRAC-DFRAC
      ENDIF
      DO 200 J=1,3
 200  XT(J)=X1(J)*(1.0-FRAC) + X2(J)*FRAC
  1   DFRAC=0.5*DFRAC
      END
C **** SLICE3D. DRAW SLICES IN DIRECTION I1, IN PLANES OF CONSTANT I2 **
      SUBROUTINE SLICE3D(A,I1,I2,M1,M2)
      COMMON/COMTRD/NMAX,N,M,HITE,SA,CA,SB,CB,XSS,YSS,H0,V0,H1,V1,SH,SV,
     2  XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,ZSC,X0,Y0,Z0,SX
      DIMENSION A(NMAX,M),IX(2),X(3),XL(3),XT(3)
      INTEGER P,Q
      L = 0
      LD = 1
      DO 1060 J = 1, M2
      X(I2) = J
      IX(I2) = J
      Q = 0
      DO 1030 I = 1, M1
      L = L + LD
      X(I1) = L
      IX(I1)=L
      X(3)=A(IX(1),IX(2))
      IF(X(3).GT.ZMAX)X(3)=ZMAX
      IF(X(3).LT.ZMIN)X(3)=ZMIN
      CALL CANSEE(A,X(1),X(2),X(3),P)
      IF(P.EQ.Q .OR. I.EQ.1) GOTO 170
      CALL SCANSEE(A, X, XL, XT, P, Q )
      CALL PLOT3D( XT, Q, Q)
      Q = P
  170 CALL PLOT3D( X, P, Q)
      XL(1)=X(1)
      XL(2)=X(2)
      XL(3)=X(3)
 1030 CONTINUE
C END OF INNER LOOP. CHANGE DIRECTION.
      L = L + LD
      LD = -LD
 1060 CONTINUE
      END
C **** XOTATE: ROTATE ANGA AROUND Z-AXIS, THEN -ANGB AROUND NEW Y-AXIS**
      SUBROUTINE XOTATE (XX,YY,ZZ,  YP, ZP )
      COMMON/COMTRD/NMAX,N,M,HITE,SA,CA,SB,CB,XSS,YSS,H0,V0,H1,V1,SH,SV,
     2  XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,ZSC,X0,Y0,Z0,SX
      X=XX-X0
      Y=YY-Y0
      Z=(ZZ-Z0)*ZSC
      YP=Y*CA-X*SA
      ZP=Z*CB-(X*CA+Y*SA)*SB
C THE FOLLOWING, UNTIL END, MAY BE REMOVED IF NO PERSPECTIVE NEEDED.
      XP= (X*CA+Y*SA)*CB + Z*SB
      SS=1.0-SX*XP
      YP=YP/SS
      ZP=ZP/SS
      END
