* --------------------------------------------------- subroutine MASSA
      SUBROUTINE MASSA(PART,Z,N,AMASS,EXCESS)
      IMPLICIT NONE
* PARAMETERS:
* PART    (INPUT)  MNEMONIC OF A NUCLIDE, E.G. 28SI  CHARACTER*5
* Z       (OUTPUT) ATOMIC NUMBER                     REAL
* N       (OUTPUT) NEUTRON NUMBER                    INTEGER
* AMASS   (OUTPUT) ATOMIC MASS IN AMU                REAL
* EXCESS  (OUTPUT) MASS EXCESS IN MeV                REAL
*
      INTEGER M
      PARAMETER (M=4)
      CHARACTER*5 PART(M)
      REAL Z(M)
      INTEGER N(M)
      REAL AMASS(M),EXCESS(M)

      INTEGER IORD(M),INT(3)
      REAL REA(3)
      INTEGER CONST(4)
      CHARACTER*28 LINE
      REAL AMU
      PARAMETER (AMU=931.5016*1000.0)
      INTEGER LEN
      INTEGER I,J,K,IJ,IK,KB,IPT
      INTEGER ITERM, IFLG
      REAL Q
      character*80 fullname
      external fullname

      DATA LEN/12/
      DATA CONST/0,3,6,15/
*
* SORT PARTS. IORD=POINTER TABLE
      DO 10 I=1,M
10    IORD(I)=I
      DO 20 I=2,M
      DO 20 K=M,I,-1
      J=K-1
      IJ=IORD(J)
      IK=IORD(K)
      IF(PART(IJ).LE.PART(IK))GOTO 20
* INTERCHANGE J,K
      IORD(J)=IK
      IORD(K)=IJ
20    CONTINUE
*
*  TABLE LOOKUP
      OPEN(14,FILE=fullname('massa.tab'), STATUS='OLD', ERR=999)
   28 FORMAT(A28)
      DO 200 K=1,M
        J=IORD(K)
        IF(K.GT.1)GOTO 110               
c        TRY SAME PART FIRST
 100    CONTINUE
* GET RECORD
        READ(14,28,END=99)LINE
 110    IF(PART(J).EQ.LINE(16:20))THEN
* PART FOUND, STORE DATA.
          DO 245 KB=1,3
          IPT=CONST(KB)
          LEN=CONST(KB+1)
          CALL GETNUM(REA(KB),INT(KB),LINE,LEN,IPT,ITERM,IFLG)
          IPT=0
  245     CONTINUE
          Z(J)=REA(1)
          N(J)=INT(2)
          AMASS(J)=REA(1)+REA(2)+ REA(3)/AMU
          EXCESS(J)=REA(3)/1000.0
        ELSE
          GOTO 100
        ENDIF
 200  CONTINUE
      Q=EXCESS(1)+EXCESS(2)-EXCESS(3)-EXCESS(4)
      CLOSE(14)
      RETURN
  99  CONTINUE
* ERROR : MASS NOT FOUND.
      CLOSE(14)
      CALL OUT_(PART(J))
      AMASS(J)=-1.0E37
      CALL ERUIT_('***** MASS NOT FOUND')
c error, cannot find massa.tab
 999  CONTINUE
      CALL ERUIT_('error in opening '//fullname('massa.tab'))
      END
