* --------------------------------------------------- subroutine RBSIM
      SUBROUTINE RBSIM
      implicit none

* simulate RBS spectra, using output of channeling simulation program

      include 'rbsim.com'
      include 'rbstp.com'

C ---
      INTEGER N(4)
      REAL A(4),Z(4),X2(1029),E2(1029),EXCESS(4)

      INTEGER I, NUNIMP
      REAL SUMZ, EPS, UNIMP

      CALL OUT_('RBSIM7 version April 2013')
      DO 34 I=1,1029
      E(I)=0
      X(I)=0
      EUIT(I)=0
      VARIAN(I)=0
      XSECT(I)=0
  34  CONTINUE
*   ask introducing questions, read yield and resonance curve
      CALL INPY
*
*    If -.FLA :read simulated yield, energy loss, and straggling
      IF (IFILE.GE.2)CALL INPFLX
*
*    depth energy relation
      CALL RBSQSTION
* -   GET THE MASS OF THE PARTICLES OF THE REACTION
      CALL MASSA(PART,Z,N,A,EXCESS)
      Q=EXCESS(1)+EXCESS(2)-EXCESS(3)-EXCESS(4)
      ZION=Z(1)
      IF ( Z1.NE.Z(1) .AND. IFILE.GT.1 ) THEN
        WRITE(*,*)'Z1 specified is ',Z(1),' in FLX file Z1=',Z1
        CALL ERUIT_('? Z1 in conflict with FLX file')
      ENDIF
      Z1=Z(1)
      Z2=Z(2)
* -   GET THE Z2 VALUES OF THE STOPPING MATERIAL
      SUMZ=0
      CALL GETZ(PARTB,Z2S,IMAX)
      DO 447 I=1,IMAX
      SUMZ=Z2S(I)*RS(I) + SUMZ
  447 CONTINUE
      ZSTOP=SUMZ/RTOT
* -   DETERMINE THE ENERGY OF INCOMING PARTICLE AS FUNCTION OF DEPTH
      CALL INDEP(A)
* -  CALCULATE THE PARTICLE ENERGY AFTER SCATTERING FOR EVERY DEPTH
      CALL RBSKINMA(A)
      IF (YK .GT. 0) THEN
          ESTEP=(E(1)-EJ0)/YK
      ELSE
          ESTEP=-1.0E-3 * YK
      ENDIF
      RVAR(25)=ESTEP/(-1.0E-3)
* -  CALCULATE THE ENERGY LOSS OF THE OUTGOING PARTICLE
      ZION=Z(3)
      NUNIMP=1028
      EPS   =EMAX/NUNIMP
      CALL ESTOP(EMAX,X2,E2,UNIMP,A(3),Z(3),EPS,NUNIMP)
* -  MAKE A TABLE OF ENERGY TO DEPTH
      CALL RBSDEP(E2,X2,NUNIMP)
*
*
* 3. build a spectrum
      CALL SPECTRUM

      END
* --------------------------------------------------- subroutine INTER
      SUBROUTINE INTER(Y,X,Y1,X1,N)
      IMPLICIT NONE
      INTEGER N
      REAL Y(N),X(N), Y1,X1
* 3 POINTS LAGRANGE INTERPOLATION
* Y,X,X1,N ARE INPUT, Y1 IS OUTPUT = 'Y(X1)'

      REAL S, D1,D2,D3, P1,P2
      INTEGER I,J,K

      S = X(N)-X(1)
c     ONLY SIGN OF S MATTERS
      I = 1
      J = N
  1   K = ( I + J ) / 2
      IF ( X(K)*S .LE. X1*S ) THEN
          I = K
      ELSE
          J = K
      ENDIF
      IF ( J-I .GT. 1 ) GOTO 1
      IF ( I .EQ. 1 ) THEN
          IF ( X(1)*S .GT. X1*S ) THEN
               Y1 = Y(1)
               RETURN
          ENDIF
          I = 2
      ELSE IF ( J .EQ. N .AND. X(J)*S .LT. X1*S ) THEN
               Y1 = Y(N)
               RETURN
      ENDIF
      K=I-1
      J=I+1
      D1=X(J)-X(I)
      D2=X(K)-X(I)
      D3=X(J)-X(K)
      IF ( D1.EQ.0 .OR. D2.EQ.0 .OR. D3.EQ.0 ) THEN
          write(6,*)'X1=',X1,' N=',N, "X(K)...", X(K),X(I),X(J)
          CALL ERUIT_('INTER: interpolation between equal values!!?')
          Y1=Y(I)
          RETURN
      ENDIF
      P1 = ( Y(J)-Y(I) ) * ( X1 - X(K) ) / D1
      P2 = ( Y(K)-Y(I) ) * ( X(J)-X1   ) / D2
      Y1 = ( P1+P2 ) * ( X1-X(I) ) / D3  +  Y(I)
      END
* ---------------------------------------------------- subroutine INPY
      SUBROUTINE INPY
      implicit NONE

      include 'rbsim.com'

      INTEGER I, ISTAT
      REAL ER, DUMMY
      CHARACTER*3 YES
      CHARACTER*26 PROMPT(3)
      DATA PROMPT/'random yield vs depth Y/N:',
     +            'random stopping   Y/N:',
     +            'random straggling Y/N:'/
c
      IFILE=0
      CALL TXTARG(FLXFIL,'Name .FLA  file (if needed):')
* expand filenames (substitute symbols such as '~')
      CALL FEXPANDFN(FLXFIL)
      CALL CRLF
      if(FLXFIL(1:1).GT.' ')then
        CALL WRITT(FLXFIL)
        CALL CRLF
      endif
      CALL TXTARG(ASCII ,'Name ASCII file (if needed):')
      CALL FEXPANDFN(ASCII)
      CALL CRLF
      if(ASCII(1:1).GT.' ')then
        CALL WRITT(ASCII)
        CALL CRLF
      endif
*
* default number of bins. (.le. NBIN, 100 will do.)
      NRK= 256
      RBIN =NRK
      DO 7 I=1,3
        CALL TXTARG(YES,PROMPT(I))
        RSV(I)= ((YES .GE. 'Y  ') .AND. (YES .LE. 'Yes')
     +     .OR.  (YES .GE. 'y  ') .AND. (YES .LE. 'yes') )
        CALL CRLF
   7  CONTINUE
      CALL OUT_('0=uniform, or already in Y(z)')
      CALL OUT_('1=Rutherford')
      CALL OUT_('2=read from ASCII file')
      CALL INTARG(IXSECT,'Cross section type:(add 10 for testing)')
c-- TO OBTAIN TEST OUTPUT, GIVE IXSECT+10
      IF(IXSECT.GE.10) THEN
          IXSECT=IXSECT-10
          TESTFLAG=.TRUE.
      ELSE
          TESTFLAG=.FALSE.
      ENDIF
      CALL WRITRCR('Cross section type', FLOAT(IXSECT), 1)
      IF(IXSECT.EQ.2)THEN
          OPEN(14,FILE=ASCII,STATUS='OLD',IOSTAT=ISTAT,ERR=999)
          CALL READASC(RESCURV,200,ER,DUMMY)
          NER=INT(ER)/2
          CLOSE(14)
      ENDIF
      IF(RSV(1).AND.RSV(2).AND.RSV(3))THEN
          CALL REALARG(T0,'E-beam(MeV):')
          CALL REALARG(ZPMAX,'max. depth, [along surface normal] (nm):')
          ZZMAX=0
          ZSTEP=0
          RETURN
c          EXIT IF ALL RANDOM
      ENDIF
      CALL CRLF
      CALL INTARG(IFILE,'Y(z) from ASCII file=1, FLX file=2:')
      IF (IFILE.GT.1) RETURN
      OPEN(14,FILE=ASCII,STATUS='OLD',IOSTAT=ISTAT,ERR=999)
      CALL READASC(RAAK,NBIN,RBIN,ZSTEP)
      ZZMAX=ZSTEP*RBIN
      CLOSE(14)
      CALL REALARG(T0,'E-beam(MeV):')
      RETURN
c     EXIT IF ASCII READ
 999  CONTINUE
 9999 FORMAT(' CAN NOT OPEN FILE, IOSTAT=',I4/1X,A70)
      WRITE(6,9999)ISTAT,ASCII
      CALL ERUIT_('error in opening ASCII file')
      END
* -------------------------------------------------- subroutine INPFLX
      SUBROUTINE INPFLX
      implicit NONE
      INTEGER NLS
      PARAMETER ( NLS = 8 )

      include 'rbsim.com'

* INPUT RESULTS FROM PROGRAM FLUX.
      REAL RAAK2(0:NBIN-1,NLS,2),DAV2(0:NBIN-1,NLS),DDAV2(0:NBIN-1,NLS)
      INTEGER NLA(2)
      INTEGER ISTAT, KZ, NBIN1, NX,NY,NV,NL,NLAY,IWGHT,IOS

      OPEN(14,FILE=FLXFIL,STATUS='OLD',IOSTAT=ISTAT,ERR=999)
      CALL INTARG(KZ,'seq.nr. on FLX file:')
      NLA(1)=0
      NLA(2)=0
      NLAY=2
c NLAY will be set in INPFLX. Preset here because it is also used
c to specify array size of NLA
* SKIP TO RECORD KZ OF FLUX FILE:
      CALL SKIPFLX(14,KZ,NBIN1,NRK,NX,NY,NV,NL,NLA,NLAY,IWGHT,IOS)
      IF(IOS.EQ.-1)GOTO 99
      IF(IOS.NE.0 .OR. NBIN1.GT.NBIN )THEN
          CALL ERUIT_('flx file error')
      ENDIF
      RBIN =NRK
      CALL INPFLX2(NBIN1,NL,NLA,NLAY,IWGHT,RAAK2,DAV2,DDAV2)
      CLOSE(14)
      RETURN
*
  99  CONTINUE
c     COME HERE ON ERROR ON LU 14 (INCLUDING EOF/EOM)
      CALL ERUIT_('end of file or read error')
 999  CONTINUE
 9999 FORMAT(' CAN NOT OPEN FILE, IOSTAT=',I4/1X,A70)
      WRITE(6,9999)ISTAT,FLXFIL
      CALL ERUIT_('error in opening FLUX file')
      END
* ------------------------------------------------- subroutine INPFLX2
      SUBROUTINE INPFLX2(NBIN1,NL,NLA,NLAY,IWGHT,RAAK2,DAV2,DDAV2)
      IMPLICIT NONE
      INTEGER NBIN1, NL, NLAY, IWGHT
      INTEGER NLA(2)
      REAL RAAK2(0:NBIN1-1,NL,NLAY),DAV2(0:NBIN1-1,NL),
     + DDAV2(0:NBIN1-1,NL)
* INPUT RESULTS FROM PROGRAM FLUX.

      include 'rbsim.com'

c      INTEGER I, IFLG, IPT, ITERM, KLAD, LEN
      INTEGER IL, IL1, IL2
      INTEGER K, KL, KLAY, L, LE, LS, NLAP
      REAL DUMMY
      REAL SUMRAAK,SUMDAV,SUMDDAV,RSUM
      CHARACTER*160 FLKOP
      CHARACTER*32 TMPTXT
      CHARACTER*20 ATIME
      INTEGER ICOMNRS(2)

* debugging output:
*     integer j,at,layer

      CALL GETFLX(14,NBIN1,0,0,0,NL,NLA,NLAY,IWGHT,
     +            FLKOP,RAAK2,DAV2,DDAV2,DUMMY,DUMMY)
**
* debugging output:
*     write (6,'(//''INPFLX2:'')')
*     write (6,*)' NBIN1=',NBIN1,' NL=',NL,
*    + ' NLAY=',NLAY,' NLA=',NLA(1),NLA(2)
*     do 983 layer=1,NLAY
*     do 980 at=1,NLA(1)
*     write(6,*) 'LAYER =',layer,' atom=',at
*     write(6,'(/5X,3A9)')'raak2', 'dav2', 'ddav2'
*     do 981 j=0,nbin1-1
*     write(6,'(I4,1X,3f9.3)')
*    + j,raak2(j,at,layer),dav2(j,at),ddav2(j,at)
*981  continue
*980  continue
*983  continue
**
* UNPACK FLKOP
c      IPT=52
c      LEN=160
c      DO 3 I=1,13
c      CALL GETNUM(COMNRS(I),KLAD,FLKOP,LEN,IPT,ITERM,IFLG)
c      IF(IFLG.NE.0)CALL ERUIT_('error in header')
c  3   CONTINUE
      READ(FLKOP,5)TMPTXT,ATIME,COMNRS(1),COMNRS(2),
     3 COMNRS(3),COMNRS(4),COMNRS(5),COMNRS(6),COMNRS(7),ICOMNRS(1),
     8 COMNRS(9),COMNRS(10),COMNRS(11),COMNRS(12),ICOMNRS(2)
  5   FORMAT(A32,A20,3F8.3,2F8.1,2F8.0,I6,F8.4,2F8.5,F8.2,I6,I4)
      COMNRS(8)= ICOMNRS(1)
      COMNRS(13)=ICOMNRS(2)
      ZSTEP=0.1*ADELZ*UD
      ZZMAX=NRK*ZSTEP
      CALL OUT_(FLKOP)
* debugging output:
*     write(6,'((5F14.3))')(COMNRS(I),I=1,13)
      WRITE(OUTBUF,221)ANG(1),ANG(2), T0, ZZMAX
      CALL OUT_ (OUTBUF)
 221  FORMAT(' th,ph=',F7.2,F8.2, '  T0=',F7.3,' MeV.  Max.depth=',
     5  F7.1, ' nm')

      KLAY=1
      IF(NLAY.GT.1)THEN
        CALL INTARG(KLAY,'LAYER [1/2/(3=both)]:')
      ENDIF

      IF(KLAY.GT.NLAY)THEN
C Summation of the yield over all layers
        KL=1
        DO 51 K=2,NLAY
        DO 50 LS=1,NLA(K)
        DO 52 L=0,NRK-1
        RAAK2(L,LS,1)=RAAK2(L,LS,1)+RAAK2(L,LS,K)
  52    CONTINUE
  50    CONTINUE
  51    CONTINUE
      ELSE
        KL=KLAY
      ENDIF

      IF(KLAY.LE.NLAY)THEN
        NLAP=NLA(KLAY)
      ELSE
        NLAP=NLA(1)
        IF(NLA(2).gt.NLAP)NLAP=NLA(2)
      ENDIF
      WRITE(TMPTXT,224)NLAP,NLAP+1
  224 FORMAT('ATOM SPECIES [1..',I1,',(',I1,'=average)]')
      IL=1
      IF(NLAP.GT.1)THEN
        CALL INTARG(IL,TMPTXT)
      ENDIF
      IF(IL.gt.NLAP)THEN
        IL2=NLAP
        IL=1
      ELSE
        IL2=IL
      ENDIF

      IF(IL.eq.IL2)THEN
        LE=IL
        IF(IWGHT.LT.0)LE=1
        DO 10 L=0,NRK-1
         RAAK(L)=RAAK2(L,IL,KL)
          DAV(L)= DAV2(L,LE)
         DDAV(L)=DDAV2(L,LE)
  10    CONTINUE
      ELSE
C Average of yield and energy loss over the atomic species
        RSUM= IL2-IL+1
        DO 12 L=0,NRK-1
        LE=IL
        IF(IWGHT.LT.0)LE=1
        SUMRAAK=0
        SUMDAV =0
        SUMDDAV=0
        DO 11 IL1=IL,IL2
          SUMRAAK= SUMRAAK + RAAK2(L,IL1,KL)
          SUMDAV =  SUMDAV +  DAV2(L,LE)
          SUMDDAV= SUMDDAV + DDAV2(L,LE)
          IF(IWGHT.GE.0)LE=LE+1
  11    CONTINUE
        RAAK(L)= SUMRAAK/RSUM
         DAV(L)= SUMDAV /RSUM
        DDAV(L)= SUMDDAV/RSUM
  12    CONTINUE
      ENDIF
**
* debugging output:
*     write (6,'(//''INPFLX2: ADOPTED VALUES'')')
*     write (6,'(/5X,3A9)')'raak', 'dav', 'ddav'
*     do 982 j=0,NRK-1
*     write (6,'(I4,1X,3f9.3)') j, raak(j), dav(j), ddav(j)
*982  continue
**
      END
* --------------------------------------------------- subroutine INDEP
      SUBROUTINE INDEP(A)
      REAL A(4)

      include 'rbsim.com'
      include 'rbstp.com'
      include 'rbspectr.com'

*
      REAL STOPPWR(1029),ET(1029)
C
      FMIN=0.5
      ET0=E0

      ETMIN=ET0*FMIN
      DO 71 I=1,1029
      ET(I)= ( (I-1)*ET0 + (1029-I)*ETMIN ) / 1028.0
  71  CONTINUE

      CALL ST(ET,A(1),Z1,STOPPWR,1029)
C Now STOPPWR contains DEDX in the range ETMIN ... ET0
C
      DX0=DIK0/COSIN
      IF(ZSTEP.LE.0)THEN
        IF(ZZMAX.LE.0)ZZMAX=ZPMAX/COSIN
        ZSTEP=ZZMAX/RBIN
      ENDIF
      X(1)=0
      E(1)=E0
      VARIAN(1)=0
      XSECT(1)=0
      NSURF=25
      IF(DIK0.EQ.0)NSURF=1
      NSTEP=NRK+NSURF-1
* SET UP ARRAYS E,X,XSECT,VARIAN
* XSECT IS LATER MODIFIED IN SUBROUTINE KINEMA
* VARIAN IS UPDATED IN SUBROUTINE DEP
* E(I),X(I),VARIAN(I) ARE VALUES AT THE BORDERS OF INTERVALS, BUT
* XSECT(I)=CROSS SECTION INTEGRATED OVER INTERVAL X(I-1)..X(I)
      DO 74 I=2,NSURF
      X(I)=(I-1)*DX0/(NSURF-1)
   74 XSECT(I)=FIK0*DX0/(NSURF-1)
      DO 77 I=1,NRK
      RAKI=1.0
      X(I+NSURF)=DX0+ZSTEP*I
      IF(.NOT.RSV(1))RAKI=RAAK(I-1)
      XSECT(I+NSURF)=RAKI*ZSTEP
  77  CONTINUE
      STOPPOW=FIN*FST(E0,ET,STOPPWR)

      DE=0.0
      DDE=0.0
      DO 79 I=2,NSTEP+1
      IF(RSV(2).OR.I.LE.NSURF)THEN
          DELX= X(I)-X(I-1)
          E(I)=E(I-1)+STOPPOW*DELX
          STOPOLD=STOPPOW
          STOPPOW=FIN*FST( E(I) ,ET,STOPPWR)
          E(I)=E(I)+0.5*(STOPPOW-STOPOLD)*DELX
          IF( E(I) .LT. ETMIN ) THEN
            IF( E(I) .GT. 0.0) THEN
              ET0=ETMIN
              ETMIN=ETMIN*0.2
              DO 78 J=1,1029
              ET(J)= ( (J-1)*ET0 + (1029-J)*ETMIN ) / 1028.0
  78          CONTINUE
              CALL ST(ET,A(1),Z1,STOPPWR,1029)
C
            ELSE
              E(I)=0
              NSTEP=I-1
              GOTO 80
            ENDIF
          ENDIF
      ELSE
          II=I-NSURF-1
          IF(II.GE.NRK-1)THEN
              DE=FIN*( DAV(NRK-1)-DAV(NRK-2) ) + DE
          ELSE
              DE=0.5*FIN*(DAV(II)+DAV(II+1))
          ENDIF
          E(I)=E(NSURF)-DE*0.001
      ENDIF
      IF(RSV(3).OR.I.LE.NSURF)THEN
          VARIAN(I)=BOHR(ZION,ZSTOP,ATPV,X(I))
      ELSE
          II=I-NSURF-1
          IF(II.GE.NRK-1)THEN
              DDE=DDE+ DDAV(NRK-1)-DDAV(NRK-2)
          ELSE
              DDE=0.5*(DDAV(II)+DDAV(II+1))
          ENDIF
          VARIAN(I)=(DDE*0.001)**2+VARIAN(NSURF)
      ENDIF
  79  CONTINUE
  80  CONTINUE

      IF(TESTFLAG) THEN
          DO 479 I=1,NSTEP+1
          CALL PUTINSP(NTST( 8),I,dble(XSECT(I)))
          CALL PUTINSP(NTST( 9),I,dble(VARIAN(I)*1.0E6))
          CALL PUTINSP(NTST(10),I,dble(E(I)*1.0E3))
  479     CONTINUE
      ENDIF
      END
* ------------------------------------------------------- function FST
      REAL FUNCTION FST(E,ET,STOPPWR)
      IMPLICIT NONE
      REAL E, ET(1029), STOPPWR(1029)
C FUNCTION PROCEDURE TO CALCULATE DE/DX BY INTERPOLATION
C NOTICE THAT THE RESULT IS NEGATIVE
      REAL S

      CALL INTER(STOPPWR,ET,S,E,1029)
      FST=-S
      END
* -------------------------------------------------- subroutine RBSDEP
      SUBROUTINE RBSDEP(E2,X2,NUNIMP)
      implicit NONE
      REAL X2(1029),E2(1029)
      INTEGER NUNIMP

      include 'rbsim.com'
      include 'rbstp.com'

      INTEGER I
      REAL X1, XL
      REAL BOHR
      EXTERNAL BOHR
*
*debug output
*     write(6,*)
*     write(6,*) 'I, X(I), E(I), X1, XL, EUIT(I)'
*
      EMAX=E(1)
      EMIN=E(1)
      EUIT(1)=E(1)
      DO 281 I=2,NSTEP+1
        CALL INTER(X2,E2,X1,E(I),NUNIMP+1)
        XL=X(I)*COSIN/COSUIT
        CALL INTER(E2,X2,EUIT(I),XL+X1,NUNIMP+1)
        IF  (EUIT(I).LE.0.0) THEN
            EUIT(I)=0.0
            EMIN=0
* LINEAR EXTRAPOLATION TO OBTAIN ZERO INTERSECTION:
            X1=(X(I-1)*EUIT(I-2)-X(I-2)*EUIT(I-1))/(EUIT(I-2)-EUIT(I-1))
            DMAX=X1
            X(I)=X1
* SET NSTEP TO THE NUMBER-1 OF SIGNIFICANT POINTS OF EUIT
            NSTEP = I-2   ! must be 2, not 1 (6/3/92 PJMS)
            RETURN
        ENDIF
        IF(EUIT(I).LT.EMIN)THEN
            EMIN=EUIT(I)
        ELSE IF(EUIT(I).GT.EMAX)THEN
            EMAX=EUIT(I)
        ELSE
          CALL OUT_('RELATION DEPTH-ENERGY NOT 1 TO 1')
        ENDIF
        VARIAN(I)=VARIAN(I)+BOHR(ZION,ZSTOP,ATPV,XL)
*
*debug output
*     write(6,'(I3,5F10.3)')I, X(I), E(I), X1, XL, EUIT(I)
*
  281 CONTINUE
      DMAX=X(NSTEP+1)
      END
C ------------------------------------------------------ function BOHR
      FUNCTIO  N BOHR  (Z1,Z2,ATPV,DEPTH)
      IMPLICIT NONE
      REAL BOHR, Z1, Z2, ATPV, DEPTH

* BOHR STRAGGLING
*    Z1,Z2  = CHARGE OF PROJECTILE AND TARGET, IN UNITS OF e.
*    DEPTH  = THE TARGET LAYER THICKNESS (in nm)
*    ATPV   = ATOMS PER cm3 * 1.0E22
*    BOHR   = VARIANCE OF STRAGGLING DISTRIBUTION (in MeV^2)
*
      real c, e, alfa, esq, equad, fourpi, P10, fBohr
      parameter(c=2.99792458E8)
c     speed of light in m/s
      parameter(e=1.6021892E-19)
c     elementary charge in Coulomb
      parameter(alfa=c*c*1.0E-7)
c     1/(4*pi*epsilon0)
      parameter(esq=e*alfa)
c     e*e/(4*pi*epsilon0) in eV.m
      parameter(equad=esq*esq)
      parameter(fourpi=12.56637061)
c     4*pi
      parameter(P10=1.0E7)
c     conversion factor
      parameter(fBohr=fourpi*equad*P10)

      BOHR =  Z1*Z1 * Z2 * fBohr * ATPV * DEPTH
      END
* ------------------------------------------------ subroutine RBSKINMA
      SUBROUTINE RBSKINMA(A)
      IMPLICIT NONE
      REAL A(4)

      include 'rbsim.com'
      include 'rbstp.com'

      REAL T(4)
      REAL COSPHR,SINPHR,BB,CC,XL1,XL2,STH2,XCM,T3,TTOTP,THETA,CML
      INTEGER I

      EMAX=0.0
      IZMAX=0
      COSPHR=COS(PHR*0.01745329252)
      SINPHR=SIN(PHR*0.01745329252)

* PARAMETERS FOR SCREENING CORRECTION
* SEE E.HUTTEL ET AL., NUCLEAR INSTRUMENTS AND METHODS B12(1985)193
      IF (IXSECT.EQ.1) THEN
          BB=3.3E-5*Z1*Z2*(Z1**(2.0/3.0)+Z2**(2.0/3.0))**0.5
          CC=0.6
      ELSE
          BB=0.0
          CC=0.0
      ENDIF

      DO 130 I=1,NSTEP+1
        XL1=XL2
        T(1)=E(I)
        CALL KINEM(A,T,Q,COSPHR,SINPHR,TTOTP,THETA,CML)
          STH2=SIN(0.5*THETA)
        IF(T(3).LT.0.0)THEN
            IF(I.EQ.1)CALL ERUIT_('REACTION IMPOSSIBLE AT THIS ENERGY')
            T(3)=0.0
        ENDIF
        IF(IXSECT.EQ.0)THEN
            XCM=(1.0                        )/(    STH2**2)**2
            XL2=(Z1*Z2)**2 * XCM / CML
        ELSE IF (IXSECT.EQ.1)THEN
            XCM=(1.0-BB/TTOTP*(1.0-CC+CC/STH2))/(TTOTP*STH2**2)**2
            XL2=(Z1*Z2)**2 * XCM / CML
        ELSE
          IF(T(1).lt.RESCURV(0))THEN
            XL2=0.0
          ELSE
            CALL INTER(RESCURV(NER),RESCURV(0),XL2,T(1),NER)
          ENDIF
        ENDIF
        T3=T(3)
C Added september 1995. Multiply by number of particles per volume
        XL2= XL2*ATPV
C
        IF(I.EQ.1)THEN
            XL1=XL2
        ELSE
            T(1)=SQRT(VARIAN(I))+E(I)
            CALL KINEM(A,T,Q,COSPHR,SINPHR,TTOTP,THETA,CML)
            IF(T(3).LT.0.0)T(3)=0.0
            if(ABS(T(3)-T3).gt.1.0E-10)
     +        VARIAN(I)=VARIAN(I)*((T(3)-T3)/(T(1)-E(I)))**2
        ENDIF
* bug removed 21 Feb 2001: the wrong T(3) was assigned to E(I) !!
        E(I)= T3

        IF(IZMAX.EQ.0 .AND.VARIAN(I).GT.0.02*E(I)**2) IZMAX=I
        XSECT(I)=XSECT(I)*(XL1+XL2)*0.5
        IF(EMAX.LT.E(I))EMAX=E(I)
 130  CONTINUE
      END
* --------------------------------------------------- subroutine KINEM
      SUBROUTINE KINEM(AK,T,Q,COSP,SINP,TP,THETA,CML)
      IMPLICIT NONE
      REAL AK(4), T(4), Q, COSP, SINP, TP, THETA, CML
* RELATIVISTIC KINEMATICS OF A 2-PARTICLE REACTION .
* PARTICLE 1 IS BOMBARDING PARTICLE
* PARTICLE 2 IS ORIGINALLY AT REST
* PARTICLES 3 AND 4 ARE OUTGOING PARTICLES.
* THE ALGORITHM IS SUITABLE FOR HIGH AS WELL AS LOW VELOCITIES,
* INCLUDING ZERO. (E.G. DECAY OF A RADIOACTIVE NUCLEUS).
* MASSES A,KINETIC ENERGIES T,TOTAL ENERGIES E,LINEAR MOMENTA P AND
* Q-VALUE ALL IN SAME UNITS, I.E. MeV.
* ANGLES IN RADIANS.
* INPUT: AK(1..4),T(1),Q,COS(PSI),SIN(PSI)
* PSI=LAB ANGLE 3,THETA= CM ANGLE 3
* IF T3 IS DOUBLE VALUED THE LARGER VALUE IS TAKEN.
      REAL  A(4),P(4),E(4), ET, BETA, ECM, ALFA, B
      REAL X, T3P, T4P, PP, W, S, C, CSP, AA
      INTEGER I

c statement functions FP, FE, FT:
      REAL FP, FE, FT, TX, PX, AX, EX
      FP(TX,AX)=SQRT(TX*(TX+2.0*AX))
      FE(PX,AX)=SQRT(PX**2+AX**2)
      FT(PX,EX,AX)=PX**2/(EX+AX)

      DO 35 I=1,4
      A(I)=AK(I)*931.5016
 35   CONTINUE
      THETA=0
      T(3)=-1.0
* T(3) REMAINS NEGATIVE ON ERROR
      E(1)=A(1)+T(1)
      E(2)=A(2)
      P(1)=FP(T(1),A(1))
      ET=E(1)+E(2)
      P(2)=0.0
      BETA=P(1)/ET
      ECM=SQRT(2.0*T(1)*A(2)+(A(1)+A(2))**2)
      ALFA=ECM/ET
      B=BETA**2/(1.0+ALFA)
* CALCULATE KINETIC ENERGIES IN C.M. SYSTEM
      TP=T(1)+Q-B*ET
      X=0.5*TP/ECM
      T3P=X*(ECM-A(3)+A(4))
      T4P=X*(ECM+A(3)-A(4))
      IF(T3P.LT.0.0.OR.T4P.LT.0.0)RETURN
      PP=FP(T3P,A(3))
      W=BETA*(T3P+A(3))
      S=ALFA*PP
      C=BETA*A(3)
      CSP=C*SINP
      IF(CSP.GT.S)RETURN
      AA=(S+CSP)*(S-CSP)
      P(3)=(ALFA*W*COSP+SQRT(AA))/(1.0-(BETA*COSP)**2)
      IF(P(3).LT.0.0)RETURN
      E(3)=FE(P(3),A(3))
      T(3)=FT(P(3),E(3),A(3))
      S=P(3)*SINP
      C=(P(3)*COSP-BETA*E(3))/ALFA
      THETA=ATAN2(S,C)
      CML=(PP+W*COS(THETA))/ALFA*PP**2/P(3)**3
      END
* ------------------------------------------------------ function ERFF
      FUNCTION ERFF(W)
      IMPLICIT NONE
      REAL ERFF, W

*   INTEGRAL FROM -INF TO W OF EXP(-X*X) / SQRT(PI)

      REAL WA, FW

      REAL FY, FZ, X, Y
      FY(X)  =  1.0 / ( 1.0 + 0.3275911*X )
      FZ(Y)  =  ((((0.94064607*Y-1.287822453) * Y + 1.25969513)
     2     * Y - 0.252128668) * Y + 0.225836846) * Y * 0.564189585

      WA  =  ABS(W)
      IF ( WA .GT. 9.0 ) THEN
          FW  =  0.0
      ELSE
          FW  =  FZ( FY(WA) ) * EXP(-WA*WA)
      ENDIF
      IF ( W .GT. 0.0 ) THEN
          ERFF  =  1.0 - FW
      ELSE
          ERFF  =  FW
      ENDIF
      END
C ------------------------------------------------ subroutine SPECTRUM
      SUBROUTINE SPECTRUM
      implicit NONE

      include 'rbsim.com'
      include 'rbstp.com'
      include 'rbspectr.com'

      REAL ERFF
      EXTERNAL ERFF

      REAL SP(0:1023)
      REAL DELE, DETVAR, DSP, E1, E2, EJ, EP1, EP2, EU
      REAL S, S1, S2, V, V1, V2, XX, YM
      INTEGER I, J, JMAX, JMIN, K, NDE

      DETVAR=(0.001*DETFWHM)**2/ALOG(256.0)
**
* debugging output:
*     write (6,'(//''VALUES FOR SPECTRUM CONSTRUCTION'')')
*     write (6,'(/5X,4A9)')'Xsect', 'variance', 'Eout', 'depth'
*     do 982 j=1,NSTEP+1
*     write (6,'(I4,1X,4f9.3)')
*    + j, XSECT(j),(VARIAN(j) + DETVAR)*1.0E6, EUIT(j)*1000.0, X(j)
*982  continue
**
      DO 1023 J=0,1023
 1023 SP(J)=0
* the cross section at depth I is a function of the energy. However
* in the following it is given a constant value equal to the cross
* section at <E(I)>. This is only allowed if the energy spread is
* relatively small. IZMAX was set in subroutine KINEMA.
      IF(IZMAX.GT.0)THEN
        EU=EUIT(IZMAX)
        J=NINT((EU-EJ0)/ESTEP)
        WRITE(6,734)'*** WARNING APPROXIMATION INACCURATE FOR E <'
     +  ,EU,' CHANNEL <',J
 734    FORMAT(A,F8.3,A,I5)
      ENDIF
      DO 4095 I=2,NSTEP+1
      E1=EUIT(I-1)
      E2=EUIT(I)
C prevent floating point exception:
      IF(ABS(E1-E2).LT. 1.0E-8*ESTEP)GOTO 4095
      V1=VARIAN(I-1)+DETVAR
      V2=VARIAN(I)  +DETVAR
      YM=XSECT(I)/(E1-E2)*ESTEP
      S1=SQRT(2.0*V1)
      S2=SQRT(2.0*V2)
      NDE=ABS((S2-S1)/(S1+S2)*200.0)+1
      DELE=(E2-E1)/NDE
      S=S2
      IF(S1.GT.S2)S=S1
      JMIN=NINT(((E2-EJ0)-5.0*S)/ESTEP)-1
      IF(JMIN.LT.0)JMIN=0
      JMAX=INT(( (E1-EJ0) +5.0*S)/ESTEP)+2
      IF(JMAX.GT.1023)JMAX=1023
      DO 2047 J=JMIN,JMAX
      EJ=J*ESTEP + EJ0
      DO 2047 K=1,NDE
      EP2=E1+K*DELE
      EP1=EP2-DELE
      V=((K-0.5)*V2 + (NDE-K+0.5)*V1)/NDE
      S=SQRT(2.0*V)
      DSP= YM*(ERFF((EJ-EP2)/S)-ERFF((EJ-EP1)/S))
**
* debugging output:
*     WRITE(6,'(2I5,1X,F8.0)') I,J, DSP
**
      SP(J)=SP(J)+DSP
 2047 CONTINUE
 4095 CONTINUE
      IF (TESTFLAG) THEN
          DO 6143 I=1,NSTEP+1
          CALL PUTINSP(NTST(4),I,dble(XSECT(I) ))
          CALL PUTINSP(NTST(5),I,dble(VARIAN(I)*1.0E6))
          CALL PUTINSP(NTST(6),I,dble(EUIT(I)  *1000.0))
          CALL PUTINSP(NTST(7),I,dble(X(I)  *10.0))
 6143     CONTINUE
      ENDIF
      DO 8191 J=0,1023
      CALL PUTINSP(ND,J,dble(SP(J)))
      IF (NX.NE.0) THEN
          CALL INTER(X,EUIT,XX,J*ESTEP+EJ0,NSTEP+1)
          CALL PUTINSP(NX,J,dble(XX*10.0))
      ENDIF
 8191 CONTINUE
      IF(YK.GT.0)THEN
          ESTEP=(EMAX-EJ0)/YK
      ELSE
          ESTEP=-1.0E-3*YK
      ENDIF
      CALL CRLF
      CALL WRITT('REACTION  ')
      CALL WRITT(PART(2))
      CALL WRITT('(')
      CALL WRITT(PART(1))
      CALL WRITT(',')
      CALL WRITT(PART(3))
      CALL WRITT(')')
      CALL WRITT(PART(4))
      CALL CRLF
      CALL OUT_(' *------------------------------*')
      IF(Q.NE.0.0)
     1CALL WRITRCR(' *    Q VALUE       :',Q,4)
      IF(RLEV4.NE.0.0)
     1CALL WRITRCR(' *    LEVEL PART 4  :',RLEV4,4)
      CALL WRITRCR(' *    INCOMING ANGLE:',PHI,2)
      CALL WRITRCR(' *    OUTGOING ANGLE:',PHU,2)
      CALL WRITRCR(' *    REACTION ANGLE:',PHR,2)
 700  FORMAT(1X,A20,F8.3)
 701  FORMAT(1X,A22,A14)
      WRITE(OUTBUF,701)'*    STOPPING IN   :  ',BUFFER1
      CALL OUT_(OUTBUF)
      WRITE(OUTBUF,700)'*    density       :',DENS
      CALL OUT_(OUTBUF)
      WRITE(OUTBUF,700)'* atoms / 100 A^3  :',ATPV
      CALL OUT_(OUTBUF)
      WRITE(OUTBUF,700)'*   Incident Energy:',E0
      CALL OUT_(OUTBUF)
      WRITE(OUTBUF,700)'*  Max. Exit Energy:',EMAX
      CALL OUT_(OUTBUF)
      WRITE(OUTBUF,700)'*  corresp. channel:',(EMAX-EJ0)/ESTEP
      CALL OUT_(OUTBUF)
      WRITE(OUTBUF,700)'*detector resolution:',DETFWHM
      CALL OUT_(OUTBUF)
      IF(EMIN.GT.0.01*EMAX) THEN
      WRITE(OUTBUF,700)'*    Minimum Energy:',EMIN
         CALL OUT_(OUTBUF)
      ENDIF
      CALL OUT_(' *------------------------------*')
      IF ( RANGE .GT. 0 ) THEN
         WRITE(OUTBUF,702)PART(1), RANGE
         CALL OUT_(OUTBUF)
      ENDIF
 702  FORMAT(1X, 'Range * cos(PHIin) of ', A4,
     2 'in ',A14,':',F8.1,' nm')
      WRITE(OUTBUF,703)DMAX*COSIN, EUIT(NSTEP+1)
      CALL OUT_(OUTBUF)
 703  FORMAT(1X, 'Max.depth (normal to surface):',
     + F8.1,' nm, for Eout =',F8.3,' MeV')
      WRITE(OUTBUF,704)NSTEP
      CALL OUT_(OUTBUF)
 704  FORMAT(I4,' steps in depth-energy relation')
      END
* ------------------------------------------------- subroutine READASC
      SUBROUTINE READASC(ARRAY,MAXSIZE,SIZE,AUXNUM)
      IMPLICIT NONE
      INTEGER MAXSIZE
      REAL ARRAY(MAXSIZE)
      REAL SIZE, AUXNUM

C subroutine READASC reads an array of real numbers from a file
C assigned to logical unit 14.
C The file is assumed to have the following structure:
C   **name1
C   Ndata auxnum
C   Ndata real numbers
C   **name2
C   etcetera
C Where name1, name2,.. are identifiers of subfiles.
C  Each name is 8 symbols long (or less symbols, padded with spaces),
C  and must be preceeded in the file by ** in column 1.
C Ndata is the number of real numbers in the subfile,
C auxnum is an extra real number (e.g. step size, energy or whatever).
C
C CALLING SEQUENCE
C     CALL READASC(ARRAY,MAXSIZE,SIZE,AUXNUM)
C where
C     ARRAY   = the array to store the data to be read
C     MAXSIZE = the maximum number of data allowed (input)
C     SIZE    = the actual number of data read (i.e. Ndata), (output)
C               Note that SIZE is returned as a REAL number.
C     AUXNUM  = auxnum (output).
C
C The name of the subfile is asked by READASC from the mainstream
C input (console or XCT program).
C Error exits occur when the subfile is not found, or if MAXSIZE is
C exceeded.
C
      INTEGER LU
      PARAMETER (LU=14)
      CHARACTER*80 NAME,BUFFER
      INTEGER IER, INTSIZE, NREAD

      CALL TXTARG(NAME(3:80),'subfile name:')
      NAME(1:2)= '**'
*     REWIND(LU)
      SIZE=0
 111  CONTINUE
      READ(LU,222,ERR=331,END=333)BUFFER
 222  FORMAT(A80)
      IF(BUFFER .NE. NAME)GOTO 111
C NAME FOUND, READ SIZE AND AUXNUM
      CALL RINASCII(LU,ARRAY,BUFFER,2,NREAD,IER)
      IF(IER.EQ.0)THEN
          SIZE=ARRAY(1)
          INTSIZE=SIZE
          IF(INTSIZE.GT.MAXSIZE)CALL ERUIT_('file exceeds max size')
          AUXNUM=ARRAY(2)
          CALL RINASCII(LU,ARRAY,BUFFER,INTSIZE,NREAD,IER)
      ENDIF
      IF(IER.NE.0)CALL ERUIT_('Read error')
      RETURN
 331  CALL ERUIT_('read error')
 333  CALL ERUIT_('file not found.')
      END
* ----------------------------------------------- subroutine RBSQSTION
      SUBROUTINE RBSQSTION
      implicit NONE

      include 'rbsim.com'
      include 'rbstp.com'
      include 'rbspectr.com'

      INTEGER INTCHAR
      EXTERNAL INTCHAR
      INTEGER ISTATE, J, J1, J2, I, NT
      REAL ASTOP
      REAL YK0
      LOGICAL BUFFEREND
      CHARACTER*1 CHARJ
      REAL AVOGADRO
      PARAMETER(AVOGADRO=60.2252)
c     * Avogadro's number * 1E-22
      REAL DR
      PARAMETER(DR=0.01745329252)
      CHARACTER*9 SPYIELD, SPDEPTH, SPTEST(4:10)
      CHARACTER*20 TSTPROMPT(4:10)
      DATA TSTPROMPT /'sp for cross section',
     + 'sp for tot.variance:',
     + 'sp for E_out       :',
     + 'sp of X values     :',
     + 'sp incoming x sect :',
     + 'sp incoming varian :',
     + 'sp incoming energy :'/
C ---
* DEFAULT VALUES
      PHI     =RVAR(20)
      PHU     =RVAR(21)
      PHR     =RVAR(22)
      DIK0    =RVAR(23)
      FIK0    =RVAR(24)
      YK      =RVAR(25)
      EJ0     =0
      ND      =RVAR(26)
      DETFWHM =RVAR(27)
      FIN     =1.0
      FUT     =1.0
      DENS    =0.0
      ATPV    =0.0
      RLEV4   =0.0
C
      CALL OUT_(
     + 'stopping calculated by subroutine RSTOP (J.F.Ziegler, 1987)')
      CALL OUT_(
     + 'using 1988 data tables (scoef.88).')
      CALL OUT_(
     + ' Give particles 1,2,3,4 (example 2H 14N 1H 15N) or STOP' )
      CALL TXTARG(PART(1),' beam particle (default 4HE):')
      IF(PART(1).EQ.' ')PART(1)='4HE  '
      CALL TXTARG(PART(2),'target nuclide (default 28SI):')
      IF(PART(2).EQ.' ')PART(2)='28SI '
      CALL TXTARG(PART(3),'detected particle:')
      CALL TXTARG(PART(4),'residual nucleus: ')
**    CALL REALARG(RLEV4,'level of residual nucleus:')
      IF(PART(3).EQ.' ')PART(3)=PART(1)
      IF(PART(4).EQ.' ')PART(4)=PART(2)
      DO 62 J=1,4
      CALL UPCASE(PART(J))
  62  CONTINUE
      CALL REALARG(PHI,'PHI IN, PHI OUT (Normal direction =0.0): ')
      CALL REALARG(PHU,'PHI OUT: ')
*
      COSIN = COS ( PHI*DR )
      COSUIT= COS ( PHU*DR )
      IF(COSIN.LE.0 .OR. COSUIT.LE.0)
     + CALL ERUIT_('*** PHI VALUES SHOULD BE LESS THEN 90 ! ***')
        CALL REALARG(PHR,'Reaction angle(backwards=180):')
*
      CALL TXTARG(BUFFER1,'Stopping material. Examples SI, SI1O2: ')
      CALL UPCASE(BUFFER1)
      IF(BUFFER1.EQ.' ')BUFFER1='SI'
      IMAX=0
      ISTATE=0
      J2=1
      J1=1
      DO 67 J=1,14
      CHARJ=BUFFER1(J:J)
      BUFFEREND = CHARJ.EQ.' '
      IF( (CHARJ.GE.'A' .AND. CHARJ.LE.'Z') .OR.
     +    (BUFFEREND .AND. ISTATE.EQ.2) ) THEN
          IF(ISTATE.EQ.2)THEN
              RS(IMAX)=INTCHAR(BUFFER1(J1:J2))
c                INTCHAR converts CHARACTER to INTEGER*4
              IF(BUFFEREND)GOTO 68
          ENDIF
          IF(ISTATE.NE.1)THEN
              J1=J
              IMAX=IMAX+1
              IF(IMAX.GT.4)CALL ERUIT_('*** only 4 elements allowed')
          ENDIF
          ISTATE=1
          J2=J
      ELSE IF ( (CHARJ.GE.'0' .AND. CHARJ.LE.'9') .OR.
     +    (BUFFEREND .AND. ISTATE.EQ.1) ) THEN
          IF(ISTATE.EQ.1)THEN
              IF(J2-J1.GT.1)CALL ERUIT_('*** error in element name')
              PARTB(IMAX)=BUFFER1(J1:J2)
              J1=J
              RS(IMAX)=1
              IF(BUFFEREND)GOTO 68
          ELSE IF(ISTATE.NE.2)THEN
              CALL ERUIT_('*** Letter expected')
          ENDIF
          ISTATE=2
          J2=J
      ELSE
          CALL ERUIT_('*** only CAPITALS and digits allowed ***')
      ENDIF
  67  CONTINUE
      CALL ERUIT_('*** name too long')
  68  IF(ISTATE.EQ.0)CALL ERUIT_('No stopping material')
      RTOT=0
      DO 69 I=1,IMAX
      WRITE(6,668) PARTB(I),RS(I)
 668  FORMAT(1X,A2,F7.3)
  69  RTOT=RTOT+RS(I)
*
      IF(RTOT.NE.1)THEN
          DENS=0
        CALL REALARG(DENS,'density in g/cm3:')
C###    CALL REALARG(ZSTOP,'Average Z of stopping material:')
        CALL REALARG(ASTOP,'Average A of stopping material:')
        ATPV=DENS*AVOGADRO/ASTOP
      ENDIF
      CALL REALARG(DIK0,'Thickness of surface layer (nm):')
      CALL REALARG(FIK0,'fraction of bulk atoms in surf.layer:')
      E0=T0
      CALL REALARG(YK,
     +'Give +ch.nr. corresponding to max. E out, or -keV/ch:')
        YK0=EJ0*1.0E3
      CALL REALARG(YK0,
     + 'Give energy (keV) of channel 0:')
        EJ0=YK0*1.0E-3
      CALL FGETVAR('sp for yield      :',ND,SPYIELD,0)
      CALL FGETVAR('sp for depth scale:',NX,SPDEPTH,0)
      CALL REALARG(DETFWHM,'detector resolution (keV FWHM):')
      CALL REALARG(FIN,'Fin:')
      CALL REALARG(FUT,'Fuit:')
      if (TESTFLAG) then
        do 1039 nt=4,10
        call FGETVAR(TSTPROMPT(nt),NTST(nt),SPTEST(nt),0)
 1039   continue
      endif
      RVAR(20)=PHI
      RVAR(21)=PHU
      RVAR(22)=PHR
      RVAR(23)=DIK0
      RVAR(24)=FIK0
      RVAR(25)=YK
c     MODIFIED LATER TO -ESTEP IN KEV
      RVAR(26)=ND
      RVAR(27)=DETFWHM
      END
* --------------------------------------------------- subroutine ESTOP
      SUBROUTINE ESTOP(E0,X,E,RANGE,A1,Z1,EPS,NSTEP)
      implicit NONE
      INTEGER NSTEP
      REAL E0,RANGE,A1,Z1,EPS
      REAL X(NSTEP+1),E(NSTEP+1)

      include 'rbstp.com'

      REAL EI(1028),DEDXI(1028),DEDX(1028+1)
      INTEGER I
      REAL DX1, DX2, DX3

* This routine calculates the path length X as a function of energy E,
* starting with E(1)=E0, X(1)=0, taking NSTEP steps -EPS in energy.
* RANGE is only calculated if the final energy is zero. If this occurs
* before NSTEP steps the value of NSTEP is reduced.
* Hence NSTEP should be a variable, not a constant.
* SUBROUTINE ST is called to calculate dE/dX.
      E(1)=E0
      DO 126 I=1,NSTEP
      E(I+1) = E(I) - EPS
      IF ( E(I+1) .LT. 0.5*EPS ) E(I+1)=0
      EI(I)=0.5*(E(I)+E(I+1))
  126 CONTINUE
      CALL ST(E,A1,Z1,DEDX,NSTEP+1)
      CALL ST(EI,A1,Z1,DEDXI,NSTEP)
      X(1)=0
      RANGE=0
      DX1= 1.0/(FUT*DEDX(1))
      DO 128 I=1,NSTEP
      DX2= 1.0/(FUT*DEDXI(I))
      IF ( E(I+1) .GT. 0 ) THEN
c     SIMPSON'S RULE
          DX3= 1.0/(FUT*DEDX(I+1))
          X(I+1)= ( DX1 + 4.0*DX2 + DX3 ) * EPS/6.0 + X(I)
          DX1=DX3
      ELSE
          X(I+1)=DX2*E(I) + X(I)
          RANGE=X(I+1)
          NSTEP=I
          GOTO 130
      ENDIF
 128  CONTINUE
 130  CONTINUE
      END
* ---------------------------------------------------- subroutine GETZ
      SUBROUTINE GETZ(PARTA,Z,M)
      IMPLICIT NONE
C FIND THE ATOMIC NUMBER Z OF ELEMENTS WITH CHEMICAL SYMBOLS GIVEN IN PA
C
C PARTA(M)  (INPUT)  MNEMONIC OF ELEMENT(S)  e.g. SI   CHARACTER*2
C Z(M)      (OUTPUT) ATOMIC NUMBER                     REAL
C   M       (INPUT)  NUMBER OF ELEMENTS, M <= 8        INTEGER
C
      INTEGER M
      CHARACTER*2 PARTA(M)
      REAL Z(M)

      CHARACTER*1 CH
      CHARACTER*2 MNEMA
      INTEGER IFOUND(8)
      CHARACTER*28 LINE
      INTEGER INT, ITERM, IFLG
      INTEGER LEN, J, KK, KL, IPT, NFOUND
      character*80 fullname
      external fullname
      DATA LEN/3/
C
      DO 100 J=1,M
      IFOUND(J)=0
      Z(J)=-1.0E37
 100  CONTINUE
      OPEN(14,FILE=fullname('massa.tab'), STATUS='OLD', ERR=999)
 300  CONTINUE
C GET RECORD
        READ(14,28,END=99)LINE
   28   FORMAT(A28)
C EXTRACT ELEMENT NAME
        KK=0
        DO 134 KL=16,20
        CH=LINE(KL:KL)
        IF (CH .GE. 'A') THEN
c        skip numeric characters
            KK=KK+1
            IF(KK .LE. 2) THEN
                MNEMA(KK:KK)=CH
            ELSE
                MNEMA='??'
c                more than 3 letters in element nam
            ENDIF
        ENDIF
 134    CONTINUE
        DO 135 KL=KK+1,2
        MNEMA(KL:KL)=' '
 135    CONTINUE
C COMPARE WITH NAMES GIVEN IN PARTA
      NFOUND=0
      DO 200 J=1,M
      IF (IFOUND(J) .EQ. 0) THEN
        IF(PARTA(J).EQ.MNEMA)THEN
          IPT=0
          CALL GETNUM(Z(J),INT,LINE,LEN,IPT,ITERM,IFLG)
          IFOUND(J)=1
        ENDIF
      ENDIF
      IF (IFOUND(J) .NE. 0) NFOUND=NFOUND+1
 200  CONTINUE
      IF (NFOUND .EQ. M) GOTO 500
      GOTO 300
c error, cannot find massa.tab
 999  CONTINUE
      CALL ERUIT_('error in opening '//fullname('massa.tab'))
c error, end of file
  99  CONTINUE
      DO 400 J=1,M
      IF(IFOUND(J).EQ.0) WRITE(6,*) 'ELEMENT ',PARTA(J),' NOT FOUND'
 400  CONTINUE
      CALL ERUIT_('error in GETZ')
 500  CONTINUE
      CLOSE(14)
      RETURN
      END
C ------------------------------------------------------ subroutine ST
      SUBROUTINE ST(E,A1,Z1,DEDX,NSTEP)
      IMPLICIT NONE
C STOPPING POWER IN MeV/nm
C E IS AN ARRAY OF ENERGIES IN MEV (INPUT)
C A1 = MASS, Z1 = CHARGE NUMBER, OF STOPPED PARTICLE
C DEDX IS OUTPUT ARRAY. NSTEP THE NUMBER OF VALUES IN E AND DEDX.
      INTEGER NSTEP
      REAL E(NSTEP),A1,Z1,DEDX(NSTEP)

      include 'rbstp.com'

      REAL ATRHO(4)
      REAL SE(1029,4)
      INTEGER I,N,NMIN,NSTOP,K
      REAL SUMA2,SUMARO,SUMRHO,S,EN,A2

      NMIN=1
  99  CONTINUE
      IF(E(NMIN).LE.0)THEN
        DEDX(NMIN)=0
        NMIN=NMIN+1
        IF(NMIN.LT.NSTEP)GOTO 99
      ENDIF

      SUMA2=0.0
      SUMARO=0.0
      SUMRHO=0.0

      DO 200 I=1,IMAX
       A2=0.0
       DO 199 N=NMIN,NSTEP,100
        NSTOP=N+99
        IF(NSTOP.GT.NSTEP)NSTOP=NSTEP
        DO 198 K=N,NSTOP
         SE(K,I)=E(K)*1000.0
 198    CONTINUE
        IF(E(NSTOP).le.0.0)NSTOP=NSTOP-1
        CALL rstop(Z1,A1,Z2S(I),EN,SE(N,I),NSTOP+1-N,1,88,ATRHO(I),A2)
 199   CONTINUE
       SUMA2=SUMA2 + RS(I)*A2
       SUMARO=SUMARO + RS(I)*A2*ATRHO(I)
       SUMRHO=SUMRHO + RS(I)*ATRHO(I)
 200  CONTINUE

      IF ( DENS .LE. 0 ) DENS = SUMARO / ( RTOT* 6.02252E23 )
      IF ( ATPV .LE. 0 ) ATPV = SUMRHO*1.0E-22 / RTOT

      DO 300 N=NMIN,NSTEP
      S=0.0
        DO 216 I=1,IMAX
        S=S+SE(N,I)*RS(I)
 216    CONTINUE
      DEDX(N)=S*DENS*6.02252E-5/SUMA2
  300 CONTINUE

      IF(NMIN.GT.1)THEN
        DEDX(NMIN-1)=DEDX(NMIN)
      ENDIF
      END
C ------------------------------------------------ subroutine RINASCII
      SUBROUTINE RINASCII(LU,ARRAY,LINE,NN,NREAD,IER)
      IMPLICIT NONE
      INTEGER LU,NN,NREAD,IER
      REAL ARRAY(NN)
      CHARACTER*80 LINE

C NN numbers are read from LU, and stored in ARRAY.
C IER=0 on normal return, IER=2 if error in layout, IER=SVC1 status on
C  read error. NREAD is number of numbers read.
C Layout of data as for GETNUM. Maximum line length is 80 characters.
C Every call starts with reading a new line, (NN.le.0 has the effect
C  'skip a line'
C LINE is a line buffer of at least 80 bytes. On return it contains
C  the last line read.

      INTEGER LUNIT, LEN, IPT, ITERM, INT
      REAL RE

      LUNIT=LU
      NREAD=0
1000  CONTINUE
      READ(LUNIT,1100,ERR=2000,END=2000)LINE
1100  FORMAT(A80)
      LEN=80
      DO 1111 LEN=80,1,-1
      IF(LINE(LEN:LEN) .GT. ' ') GOTO 1112
 1111 CONTINUE
      GOTO 1000
 1112 CONTINUE
      IPT=0
      ITERM=0
1200  IF(NREAD.LT.NN)THEN
          CALL GETNUM(RE,INT,LINE,LEN,IPT,ITERM,IER)
c          LINE EXHAUSTED:
          IF(IER.EQ.3)GOTO 1000
c          ERROR:
          IF(IER.NE.0)GOTO 2000
          NREAD=NREAD+1
          ARRAY(NREAD)=RE
          GOTO 1200
      ENDIF
      RETURN
2000  CONTINUE
      CALL  ERUIT_('error in layout of ascii file')
      END
* ------------------------------------------------- subroutine WRITRCR
      subroutine WRITRCR(STRING,VAL,NDECS)
      implicit NONE
      CHARACTER*(*) STRING
      REAL VAL
      INTEGER NDECS

C write a formatted line of text, containing 'STRING' and 'VAL'
      if(NDECS.eq.2)then
        write(6,102)STRING, VAL
      else
        write(6,104)STRING, VAL
      endif
  102 format(A,F7.2)
  104 format(A,F9.4)
      end
