      PROGRAM XTAL
C FIND THE PROJECTED POSITIONS OF LATTICE ATOMS AND IMPURITIES
C IN A CRYSTAL.
C
      PARAMETER(NATOM=2)
      PARAMETER(NATOM2=0)
      PARAMETER(NL=1)
      REAL S(3,NATOM)
      COMMON /COMBOL/ SX,RB,A,B,C
C ARRAY S CONTAINS THE POSITIONS OF THE LATTICE ATOMS
C WITHIN AN ELEMENTARY CELL.
C
C ARRAY F DEFINES REFLECTION OPERATORS THAT APPLY TO THE UNIT CELL
C WHEN ITS ORIGIN IS SHIFTED FROM (0,0,0) TO ANOTHER ATOM POSITION.
      REAL F(3,NATOM)
C ARRAY IXYZ CONTAINS EQUIVALENT DIRECTIONS OF AN IMPURITY
C WITH RESPECT TO A PURE LATTICE POSITION.
C E.G. THE TRIPLET (+1,-3,-2) MEANS THAT A SHIFT (DX,DY,DZ) =
C (X1,-X3,-X2) IS EQUIVALENT WITH (DX,DY,DZ) = (X1,X2,X3).
C
C FOR BCC THERE ARE IN GENERAL 48 EQUIVALENT SHIFTS:
      PARAMETER (NIMP=48)
      DIMENSION IXYZ(3,NIMP)
C
C THE FOLLOWING IS FOR THE BCC STRUCTURE:
      DATA S /0, 0, 0,   0.5,0.5, 0.5   /
      DATA F/6*1 /
      DATA IXYZ/+1,+2,+3, +1,-2,-3, -1,-2,+3, -1,+2,-3,
     /          +1,+2,-3, +1,-2,+3, -1,+2,+3, -1,-2,-3,
     /          +1,+3,+2, +1,-3,-2, -1,-3,+2, -1,+3,-2,
     /          +1,+3,-2, +1,-3,+2, -1,+3,+2, -1,-3,-2,
     /          +2,+1,+3, +2,-1,-3, -2,-1,+3, -2,+1,-3,
     /          +2,+1,-3, +2,-1,+3, -2,+1,+3, -2,-1,-3,
     /          +2,+3,+1, +2,-3,-1, -2,-3,+1, -2,+3,-1,
     /          +2,+3,-1, +2,-3,+1, -2,+3,+1, -2,-3,-1,
     /          +3,+1,+2, +3,-1,-2, -3,-1,+2, -3,-1,-2,
     /          +3,+1,-2, +3,-1,+2, -3,+1,+2, -3,-1,-2,
     /          +3,+2,+1, +3,-2,-1, -3,-2,+1, -3,+2,-1,
     /          +3,+2,-1, +3,-2,+1, -3,+2,+1, -3,-2,-1/
C
      CALL XTALGEN(S,SP,IXYZ,F,NATOM,NATOM2,NIMP,NL,'bcc')
      END
