      PROGRAM XTAL
C FIND THE PROJECTED POSITIONS OF LATTICE ATOMS AND IMPURITIES
C IN A CRYSTAL.

      PARAMETER(NATOM=1,NATOM2=1,NL=2)
      REAL S(3,NATOM),SP(3,NATOM2)
      COMMON /COMBOL/ SX,RB,A,B,C

C ARRAY S CONTAINS THE POSITIONS OF THE LATTICE ATOMS
C WITHIN AN ELEMENTARY CELL.

C ARRAY F DEFINES REFLECTION OPERATORS THAT APPLY TO THE UNIT CELL
C WHEN ITS ORIGIN IS SHIFTED FROM (0,0,0) TO ANOTHER ATOM POSITION.
      REAL F(3,NATOM)

C ARRAY IXYZ CONTAINS EQUIVALENT DIRECTIONS OF AN IMPURITY
C WITH RESPECT TO A PURE LATTICE POSITION.
C E.G. THE TRIPLET (+1,-3,-2) MEANS THAT A SHIFT (DX,DY,DZ) =
C (X1,-X3,-X2) IS EQUIVALENT WITH (DX,DY,DZ) = (X1,X2,X3).

C FOR BCC THERE ARE IN GENERAL 48 EQUIVALENT SHIFTS:
      PARAMETER (NIMP=48)
      DIMENSION IXYZ(3,NIMP)

C THE FOLLOWING IS FOR THE A STRUCTURE:
      DATA SP /0, 0, 0 /
C THE FOLLOWING IS FOR THE B STRUCTURE:
      DATA S/0.5, 0.5, 0.5 /

      DATA F/3*1/
      DATA IXYZ/+1,+2,+3, +1,-2,-3, -1,-2,+3, -1,+2,-3,
     /          +1,+2,-3, +1,-2,+3, -1,+2,+3, -1,-2,-3,
     /          +1,+3,+2, +1,-3,-2, -1,-3,+2, -1,+3,-2,
     /          +1,+3,-2, +1,-3,+2, -1,+3,+2, -1,-3,-2,
     /          +2,+1,+3, +2,-1,-3, -2,-1,+3, -2,+1,-3,
     /          +2,+1,-3, +2,-1,+3, -2,+1,+3, -2,-1,-3,
     /          +2,+3,+1, +2,-3,-1, -2,-3,+1, -2,+3,-1,
     /          +2,+3,-1, +2,-3,+1, -2,+3,+1, -2,-3,-1,
     /          +3,+1,+2, +3,-1,-2, -3,-1,+2, -3,-1,-2,
     /          +3,+1,-2, +3,-1,+2, -3,+1,+2, -3,-1,-2,
     /          +3,+2,+1, +3,-2,-1, -3,-2,+1, -3,+2,-1,
     /          +3,+2,-1, +3,-2,+1, -3,+2,+1, -3,-2,-1/

      CALL XTALGEN(S,SP,IXYZ,F,NATOM,NATOM2,NIMP,NL,'bcc-2')
      END
