      PROGRAM XTAL
      PARAMETER(NATOM=16,NATOM2=2)
      PARAMETER(NL=2)
      REAL S(3,NATOM),SP(3,NATOM2)
      COMMON /COMBOL/ SX,RB,A,B,C
C ARRAY S CONTAINS THE POSITIONS OF THE LATTICE ATOMS
C WITHIN AN ELEMENTARY CELL.
C ARRAY F DEFINES REFLECTION OPERATORS THAT APPLY TO THE UNIT CELL
C WHEN ITS ORIGIN IS SHIFTED FROM (0,0,0) TO ANOTHER ATOM POSITION.
      REAL F(3,NATOM)
C ARRAY IXYZ CONTAINS EQUIVALENT DIRECTIONS OF AN IMPURITY
C WITH RESPECT TO A PURE LATTICE POSITION.
C E.G. THE TRIPLET (+1,-3,-2) MEANS THAT A SHIFT (DX,DY,DZ) =
C (X1,-X3,-X2) IS EQUIVALENT WITH (DX,DY,DZ) = (X1,X2,X3).
C
C FOR DIAMOND THERE ARE IN GENERAL 24 EQUIVALENT SHIFTS:
      PARAMETER(NIMP=24)
      DIMENSION IXYZ(3,NIMP)
C
C THE FOLLOWING IS FOR THE FE STRUCTURE:
      DATA S /
     1 0.25,0.25,0,
     1 0.75,0.25,0,
     1 0.25,0.75,0,
     1 0.75,0.75,0,
     2 0.25,0.25,0.5,
     2 0.75,0.25,0.5,
     2 0.25,0.75,0.5,
     2 0.75,0.75,0.5,
     3 0.5,  0,0.25,
     3   0,0.5,0.25,
     3 0.5,  0,0.75,
     3   0,0.5,0.75,
     4   0,  0,0.31,
     4   0,  0,0.69,
     4 0.5,0.5,0.19,
     4 0.5,0.5,0.81/
C
C THE FOLLOWING IS FOR THE  N STRUCTURE:
      DATA SP/ 0, 0, 0,   0.5, 0.5, 0.5 /
C
      DATA F/NATOM*1, NATOM*1, NATOM*1/
      DATA IXYZ/+1,+2,+3, +1,-2,-3, -1,-2,+3, -1,+2,-3,
     /          +1,+3,+2, +1,-3,-2, -1,-3,+2, -1,+3,-2,
     /          +2,+1,+3, +2,-1,-3, -2,-1,+3, -2,+1,-3,
     /          +2,+3,+1, +2,-3,-1, -2,-3,+1, -2,+3,-1,
     /          +3,+1,+2, +3,-1,-2, -3,-1,+2, -3,+1,-2,
     /          +3,+2,+1, +3,-2,-1, -3,-2,+1, -3,+2,-1/

      CALL XTALGEN(S,SP,IXYZ,F,NATOM,NATOM2,NIMP,NL,'Fe16N2')
      END
