      PROGRAM XTAL
C FIND THE PROJECTED POSITIONS OF LATTICE ATOMS AND IMPURITIES
C IN A CRYSTAL.
C
      PARAMETER(NATOM=4,NATOM2=4,NL=2)
      REAL S(3,NATOM),SP(3,NATOM2)
      COMMON /COMBOL/ SX,RB,A,B,C,PGRATIO

C ARRAY S CONTAINS THE POSITIONS OF THE LATTICE ATOMS
C WITHIN AN ELEMENTARY CELL.

C ARRAY F DEFINES REFLECTION OPERATORS THAT APPLY TO THE UNIT CELL
C WHEN ITS ORIGIN IS SHIFTED FROM (0,0,0) TO ANOTHER ATOM POSITION.
      REAL F(3,NATOM)

C ARRAY IXYZ CONTAINS EQUIVALENT DIRECTIONS OF AN IMPURITY
C WITH RESPECT TO A PURE LATTICE POSITION.
C E.G. THE TRIPLET (+1,-3,-2) MEANS THAT A SHIFT (DX,DY,DZ) =
C (X1,-X3,-X2) IS EQUIVALENT WITH (DX,DY,DZ) = (X1,X2,X3).
C
C FOR DIAMOND THERE ARE IN GENERAL 24 EQUIVALENT SHIFTS:
      PARAMETER (NIMP=24)
      DIMENSION IXYZ(3,NIMP)

C THE FOLLOWING IS FOR THE GA STRUCTURE:
      DATA S /0, 0, 0,   0, 0.5, 0.5,   0.5, 0, 0.5,   0.5, 0.5, 0/

C THE FOLLOWING IS FOR THE AS STRUCTURE:
      DATA SP/0.25,0.25,0.75,   0.25,0.75,0.25,   0.75,0.25,0.25,
     +        0.75,0.75,0.75 /

      DATA F/12*1/
      DATA IXYZ/+1,+2,+3, +1,-2,-3, -1,-2,+3, -1,+2,-3,
     /          +1,+3,+2, +1,-3,-2, -1,-3,+2, -1,+3,-2,
     /          +2,+1,+3, +2,-1,-3, -2,-1,+3, -2,+1,-3,
     /          +2,+3,+1, +2,-3,-1, -2,-3,+1, -2,+3,-1,
     /          +3,+1,+2, +3,-1,-2, -3,-1,+2, -3,+1,-2,
     /          +3,+2,+1, +3,-2,-1, -3,-2,+1, -3,+2,-1/

      CALL XTALGEN(S,SP,IXYZ,F,NATOM,NATOM2,NIMP,NL,'GaAs')
      END
