      SUBROUTINE BPLOT(XP,YP,ZP,NSYMBOL)
C PLOT A SMALL CIRCLE AT XP,YP,ZP. FILL STYLE DEPENDING ON NSYMBOL
      COMMON /COMBOL/SX,RB,A,B,C,PGRATIO
      SS=1.0 + (ZP+3.0*A)*SX
      X=XP/SS
      Y=YP/SS
      R=RB/SS
      CALL PGQFS(IFILLSTYL)
      IF (NSYMBOL.LE.0) THEN
        NFILLST= 2
      ELSE
        NFILLST= 1
      ENDIF
C PLOT A CIRCLE
      CALL PGSFS(NFILLST)
      CALL PGCIRC(X, Y, R)
      CALL PGSFS(IFILLSTYL)
      END

      SUBROUTINE MPLOT(XP,YP,ZP)
C PLOT A MARKING SYMBOL
      COMMON /COMBOL/SX,RB,A,B,C,PGRATIO
      SS=1.0 + (ZP+3.0*A)*SX
      X=XP/SS
      Y=YP/SS
      CALL PGQCH(OLDHITE)
      CALL PGSCH(2.5*RB/SS*PGRATIO)
      CALL PGPT(1,X,Y,18)
      CALL PGSCH(OLDHITE)
      END

      SUBROUTINE ROT(R,I,S,C)
C ROTATE MATRIX R ABOUT AXIS I, ANGLE WITH SINE S, AND COSINE C.
      REAL R(3,3),U(3,3),T(3,3)
      J=I+1
      IF(J.GT.3)J=1
      K=J+1
      IF(K.GT.3)K=1
      DO 1 L=1,3
      DO 1 M=1,3
  1   U(L,M)=0.0
      U(I,I)=1.0
      U(J,J)=C
      U(J,K)=S
      U(K,J)=-S
      U(K,K)=C
      DO 2 L=1,3
      DO 2 M=1,3
      T(L,M)=0.0
      DO 2 N=1,3
  2   T(L,M)=T(L,M)+U(L,N)*R(N,M)
      DO 3 L=1,3
      DO 3 M=1,3
  3   R(L,M)=T(L,M)
      END

      SUBROUTINE PLAN(X,IX,IY,IZ,RM,ANGLE)
C MARK A PLANE
      REAL X(3)
      COMMON /COMBOL/ SX,RB,A,B,C,PGRATIO
      INTEGER N,HKL(3)
      CHARACTER*80 TEXT
      HKL(1)=IX
      HKL(2)=IY
      HKL(3)=IZ
      IORD=SQRT(FLOAT(IX**2+IY**2+IZ**2))+0.001
      HITE=(17-2*IORD)*0.006*RM
      RN=SQRT(X(1)**2+X(2)**2)/RM
      RX=X(1)/RN
      RY=X(2)/RN
      CALL PGMOVE( 0.9*RX,  0.9*RY)
      CALL PGDRAW( RX,  RY)
      RX=RX*1.07
      RY=RY*1.07
      TEXT(1:1)='('
      N=2
      DO 10 K=1,3
      IF(HKL(K).GE.0)THEN
        WRITE(TEXT(N:),'(I1)')HKL(K)
        N=N+1
      ELSE
        WRITE(TEXT(N:),'(I2)')HKL(K)
        N=N+2
      ENDIF
  10  CONTINUE
      TEXT(N:N)=')'
      P=HITE/(RM*1.07)*0.7
      CALL SYMBOL(RX+P*RY,RY-P*RX,HITE,TEXT,ANGLE,N)
      END

      SUBROUTINE SORT(R,N)
      INTEGER N,T,FLIP
      REAL R(N),TMP
      T=N
 100  IF(T.LE.1)RETURN
      FLIP=0
      DO 200 I=2,T
      IF(R(I).LT.R(I-1))THEN
          TMP=R(I)
          R(I)=R(I-1)
          R(I-1)=TMP
          FLIP=I
      ENDIF
 200  CONTINUE
      T=FLIP-1
      GOTO 100
      END

      SUBROUTINE SYMBOL(X, Y, HITE, TEXT, ANGLE, NTEXT)
C PLOT TEXT
      REAL X,Y,HITE,ANGLE
      CHARACTER*(*) TEXT
      INTEGER NTEXT
      COMMON /COMBOL/ SX,RB,A,B,C,PGRATIO
      CALL PGQCH(OLDHITE)
      CALL PGSCH(HITE*PGRATIO)
      CALL PGPTXT(X,Y,ANGLE, 0.0, TEXT(1:NTEXT))
      CALL PGSCH(OLDHITE)
      END
