C ===---===---===---===---===---===---===---===---=== SUBROUTINE YIMP1
      SUBROUTINE YIMP1(YIELD, FLUX, NX, NY, NSITES,
     + LATTIC, MODX, MODY, XUN, YUN, XYW, UI2SQ)

      IMPLICIT NONE
      INTEGER NX,NY,NSITES
      REAL YIELD, FLUX(NX*NY)
      INTEGER LATTIC, MODX, MODY
      REAL XUN, YUN
      REAL XYW(3,NSITES)
      REAL UI2SQ

C Calculate the impurity yield for one angle, by convolution of
C the FLUX with the sites at XYW with vibration amplitude UI2SQ

      REAL GAUSAR
      EXTERNAL GAUSAR

      REAL PRUTS
      PARAMETER (PRUTS=1.0/12.0)
      REAL EPSX,EPSY,SWI,WI, XU, YU, GX
      REAL U2X, U2Y, YI,XI, RNX, RNY
      INTEGER LATTIX
      INTEGER NX2, NX4, NY2, NY4
      INTEGER I,J,K,JX,KY,JXMIN,JXMAX,KYMIN,KYMAX,MODJX,MODKY
C
C
C SOME OFTEN USED CONSTANTS
      RNX=NX
      RNY=NY
      NX2=2*NX
      NX4=4*NX
      NY2=2*NY
      NY4=4*NY
      LATTIX=LATTIC
C
C BIN WIDTH CORRECTION
      U2X = UI2SQ -   (XUN/RNX)**2 * PRUTS
      U2Y = UI2SQ -   (YUN/RNY)**2 * PRUTS
      IF(U2X .GT. 1.0E-16) THEN
          U2X = SQRT (U2X)
      ELSE
          U2X = 1.0E-8
      ENDIF
      IF ( U2Y .GT. 1.0E-16 ) THEN
          U2Y = SQRT (U2Y)
      ELSE
          U2Y = 1.0E-8
      ENDIF
C INTEGRATION INTERVALS, -EPS TO +EPS, IN UNITS OF U2,
C CORRESPONDING TO THE SIZE OF ONE SUBCELL.
C THE FLUX IS ASSUMED CONSTANT OVER SUCH A SUBCELL.
      EPSX = 0.5 * XUN / (U2X * RNX)
      EPSY = 0.5 * YUN / (U2Y * RNY)
**TEST NORMALIZATION: SHOULD ALWAYS GIVE YIELD = 1.000
*     DO 965 J=  1,NX*NY
*965  FLUX(J)=1.0
C DETERMINE YIELD
      YIELD=0.0
      SWI = 0.0
      DO 73 I=1,NSITES
      XI=XYW(1,I) / XUN
      YI=XYW(2,I) / YUN
      WI=XYW(3,I)
      SWI = SWI + WI
C INTEGRATE FROM -6 TO +6 TIMES U2,SHOULD BE CLOSE ENOUGH TO INFINITY
      JXMIN = 0.5 + ( XI - 6.0*U2X/XUN ) * RNX
      JXMAX = 1.0 + ( XI + 6.0*U2X/XUN ) * RNX
      KYMIN = 0.5 + ( YI - 6.0*U2Y/YUN ) * RNY
      KYMAX = 1.0 + ( YI + 6.0*U2Y/YUN ) * RNY
      MODJX=MODX*NX
      MODKY=MODY*NY
      DO 72 J = JXMIN,JXMAX
      XU = ( (FLOAT(J)-0.5) / RNX -XI ) * XUN / U2X
      GX =  GAUSAR(XU-EPSX  ,  XU+EPSX)
      DO 71 K = KYMIN,KYMAX
C CALL INTERNAL SUBROUTINE THAT TRANSLATES J,K INTO ARRAY INDICES
C JX,KY OF ARRAY FLUX, DEPENDING ON THE LATTICE TYPE
C MAKE SURE THE FOLLOWING CORRESPONDS TO THE STRUCTURE USED IN FLUX.
      JX = J - 1
      KY = K - 1
C  MAP JX,KY TO UNIT CELL
C BRING JX INTO THE RANGE [1..MODJX] BY TRANSLATION
      JX = JX - JX/MODJX*MODJX
      IF ( JX.LT.0 ) JX = JX + MODJX
C SAME FOR YY
      KY = KY - KY/MODKY*MODKY
      IF ( KY.LT.0 ) KY = KY + MODKY
   
C SWITCH ACCORDING TO LATTICE TYPE
C skip if MODX and MODY both 0
      IF ( MODJX.eq.0 .and. MODKY.eq.0) goto 777
      
      IF ( LATTIX .EQ. 100 ) GOTO 100
      IF ( LATTIX .EQ. 110 ) GOTO 110
      IF ( LATTIX .EQ. 111 ) GOTO 111
      IF ( LATTIX .EQ. 2100) GOTO 2100
      IF ( LATTIX .EQ. 2110) GOTO 2110
      IF ( LATTIX .EQ. 2211) GOTO 2211
      IF ( LATTIX .EQ. 3111) GOTO 3111
      IF ( LATTIX .EQ. 6001) GOTO 6101
      IF ( LATTIX .EQ. 6101) GOTO 6101
C FLUX4 stuff
      IF ( LATTIX .EQ. 2310 ) GOTO 2310
      IF ( LATTIX .EQ. 4041 ) GOTO 4041
      IF ( LATTIX .EQ. 2021 ) GOTO 2021
      IF ( LATTIX .EQ. 1120 ) GOTO 1120
      IF ( LATTIX .EQ. 1010 ) GOTO 1010
      IF ( LATTIX .EQ. 1000 ) GOTO 1000
      IF ( LATTIX .EQ. 1001 ) GOTO 1001
      IF ( LATTIX .EQ. 6000 ) GOTO 6000
      IF ( LATTIX .EQ. 6102 ) GOTO 6102
      IF ( LATTIX .EQ. 6200 ) GOTO 6200
      IF ( LATTIX .EQ. 6201 ) GOTO 6201
      IF ( LATTIX .EQ. 6300 ) GOTO 6300
      IF ( LATTIX .EQ. 6400 ) GOTO 6400
      IF ( LATTIX .EQ. 7000 ) GOTO 7000
      IF ( LATTIX .EQ. 7100 ) GOTO 7100
      IF ( LATTIX .EQ. 7200 ) GOTO 7200
      IF ( LATTIX .EQ. 8000 ) GOTO 8000
      IF ( LATTIX .EQ. 8100 ) GOTO 8100
      IF ( LATTIX .EQ. 8101 ) GOTO 8101
      IF ( LATTIX .EQ. 8200 ) GOTO 8200
      IF ( LATTIX .EQ. 8201 ) GOTO 8201
      write(6,99)'lattice type code',LATTIX,' not supported'
  99  FORMAT(/'ERROR: ',A,I5,A/)
      STOP 'Unkown LATTICE type'
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C INTERNAL ROUTINES FOR MAPPING COORDINATES ACCORDING TO LATTICE TYPE
C
  100 CONTINUE
C
C PbF2 LATTICE, <100> PROJECTION
C SHIFT INTO THE RANGE [0..2*NF]
      IF ( JX.GE.NX2 ) THEN
          JX = JX - NX2
      ENDIF
      IF ( KY.GE.NY2 ) THEN
          KY = KY - NY2
      ENDIF
C BRING INTO THE RANGE [0..NF] BY REFLECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      IF ( KY.GE.NY ) THEN
          KY = NY2-1 - KY
      ENDIF
      GOTO 777
C
  110 CONTINUE
C PbF2 LATTICE, <110> PROJECTION
      IF ( JX.GE.NX2 ) THEN
          JX = NX4-1 - JX
      ENDIF
      IF ( KY.GE.NY ) THEN
          KY = NY2-1 - KY
      ENDIF
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
          KY = NY-1 - KY
      ENDIF
      GOTO 777
C
 2100 CONTINUE
C GaAs LATTICE, <100> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      IF ( KY.GE.NY ) THEN
          KY = NY2-1 - KY
      ENDIF
      GOTO 777
C
 2110 CONTINUE
C GaAs LATTICE, <110> PROJECTION
      IF ( KY.GE.NY ) THEN
          KY = NY2-1 - KY
      ENDIF
      IF ( JX.GE.NX ) THEN
          JX = JX - NX
          KY = NY-1 - KY
      ENDIF
      GOTO 777
C
  111 CONTINUE
C PbF2 LATTICE, <111> PROJECTION
C GaAs LATTICE, <111> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      IF ( KY.GE.NY2 ) THEN
          KY = KY - NY2
      ENDIF
      IF  ( KY.GE. NY )  THEN
          KY = KY - NY
      ENDIF
      GOTO 777
C
 2211 CONTINUE
C GaAs LATTICE, <211> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      IF ( KY.GE.NY ) THEN
          IF ( KY .GE. NY2 ) THEN
              KY = KY - NY2
          ELSE
              KY = KY - NY
          ENDIF
      ENDIF
      GOTO 777

 3111 CONTINUE
C BCC LATTICE, <111> PROJECTION
      IF ( JX.GE.NX ) THEN
C         REFLECTION WITH RESPECT TO X=NX:
          JX = NX2-1 - JX
      ENDIF
C TRANSLATE IN Y DIRECTION
      IF ( KY.GE.NY2 ) THEN
          KY = KY - NY2
      ENDIF
      IF  ( KY.GE. NY )  THEN
          KY = KY - NY
      ENDIF
      GOTO 777

 6101 CONTINUE
C HEXAGONAL LATTICE, (SiC, Wurtzit) <0001> PROJECTION
      IF ( JX.GE.NX ) THEN
C     REFLECTION WITH RESPECT TO X=NX:
         JX = NX2-1 - JX
      ENDIF
      IF ( KY.GE.NY2 ) THEN
          KY = KY - NY2
      ENDIF
      IF  ( KY.GE. NY )  THEN
C     REFLECTION WITH RESPECT TO X=0.5*XUN:
          JX = NX-1 - JX
C     TRANSLATION BY Y=YUN:
          KY = KY - NY
      ENDIF
      GOTO 777

 2310 CONTINUE
C GaAs LATTICE, <310> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = JX - NX
          KY = KY - NY/2
      ENDIF
      GOTO 777
C
 4041 CONTINUE
C LiNbO3 LATTICE, <04-4-1> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      GOTO 777
C
 1120 CONTINUE
C LiNbO3 LATTICE, <11-20> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = JX - NX
      ENDIF
      IF ( KY.GE.NY ) THEN
          IF ( KY .GE. NY2 ) THEN
              KY = KY - NY2
              JX = JX + NX2 - NX4/3
                 IF ( JX.GE.NX ) THEN
                  JX = JX - NX
                 ENDIF
          ELSE
              KY = KY - NY
              JX = JX - NX2/3
                 IF ( JX.LT.0 ) THEN
                  JX = JX + NX
                 ENDIF
          ENDIF
      ENDIF
      GOTO 777
C
 1010 CONTINUE
C LiNbO3 LATTICE, <01-10> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = JX - NX
      ENDIF
      IF ( KY.GE.NY ) THEN
              KY = KY - NY
              JX = NX-1 - JX
      ENDIF
      GOTO 777
C
 2021 CONTINUE
C LiNbO3 LATTICE, <02-21> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      GOTO 777
C
 1000 CONTINUE
C LiNbO3 LATTICE, <0001> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      IF ( KY.GE.NY ) THEN
          IF ( KY .GE. NY2 ) THEN
              KY = KY - NY2
          ELSE
              KY = KY - NY
          ENDIF
      ENDIF
      GOTO 777
C
 1001 CONTINUE
C LiNbO3 LATTICE, <0001> PROJECTION
      IF ( KY.GE.NY ) THEN
          IF ( KY .GE. NY2 ) THEN
              KY = KY - NY2
          ELSE
              KY = KY - NY
          ENDIF
      ENDIF
      GOTO 777

 6000 CONTINUE
C Al2O3 LATTICE, <0001> PROJECTION
          IF ( KY.GE.NY ) THEN
              IF ( KY.GE.NY2 ) THEN
              KY = KY - NY2
              ELSE
              KY = KY - NY
              ENDIF
           ENDIF
      GOTO 777

 6102 CONTINUE
C Al2O3 LATTICE, <11-20> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = JX - NX 
      ENDIF
          IF ( KY.GE.NY ) THEN
            IF ( KY.GE.NY2 ) THEN
            KY = KY - NY2
            JX = JX + NX2 - NX4/3  
              IF( JX.GE.NX ) THEN
              JX = JX - NX
              ENDIF
            ELSE
            KY = KY - NY
            JX = JX - NX2/3  
              IF( JX.LT.0 ) THEN
              JX = JX + NX
              ENDIF
            ENDIF
          ENDIF
        GOTO 777
      
 6200 CONTINUE
C Al2O3 LATTICE, <01-10> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = JX - NX 
       ENDIF
         IF ( KY.GE.NY ) THEN
          KY = KY - NY
          JX = NX-1 - JX 
         ENDIF
      GOTO 777

 6201 CONTINUE
C Al2O3 LATTICE, <01-10> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = JX - NX 
      ENDIF
          IF ( KY.GE.NY ) THEN
            IF ( KY.LT.NY2 ) THEN
            KY = KY - NY
            ELSE
            KY = KY - NY2
            ENDIF
          ENDIF
      GOTO 777

 6300 CONTINUE
C Al2O3 LATTICE, <10-11> PROJECTION
         IF ( KY.GE.NY ) THEN
          KY = KY - NY
          JX = NX -1 - JX 
         ENDIF
      GOTO 777

 6400 CONTINUE
C Al2O3 LATTICE, <02-21> PROJECTION
        IF ( JX.GE.NX ) THEN
             JX = NX2-1 - JX
        ENDIF
      GOTO 777

 7000 CONTINUE
C hcp LATTICE, <10-10> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      IF ( KY.GE.NY2 ) THEN
          KY = KY - NY2
      ENDIF
      IF  ( KY.GE. NY )  THEN
          KY = NY2-1 - KY
      ENDIF
      GOTO 777
 7100 CONTINUE
C hcp LATTICE, <11-20> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = JX - NX
      ENDIF
      IF ( KY.GE.NY2 ) THEN
          KY = KY - NY2
      ENDIF
      IF  ( KY.GE. NY )  THEN
          KY = NY2-1 - KY
      ENDIF
      GOTO 777
 7200 CONTINUE
C hcp LATTICE, <0001> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      IF ( KY.GE.NY2 ) THEN
          KY = KY - NY2
      ENDIF
      IF  ( KY.GE. NY )  THEN
          KY = KY - NY
          JX = NX-1 - JX
      ENDIF
      GOTO 777
 8000 CONTINUE
C Wurtzite LATTICE, <0001> PROJECTION
      IF ( JX.GE.NX ) THEN
          JX = NX2-1 - JX
      ENDIF
      IF ( KY.GE.NY2 ) THEN
          KY = KY - NY2
      ENDIF
      IF  ( KY.GE. NY )  THEN
          KY = KY - NY
          JX = NX-1 - JX
      ENDIF
      GOTO 777
 8100 CONTINUE
 8101 CONTINUE
C no special action required
      GOTO 777
 8200 CONTINUE
 8201 CONTINUE
C Wurtzite LATTICE, <-2113> PROJECTION
         IF ( JX. GE. NX) THEN
          JX = JX - NX
          IF ( KY .GE. NY/2) THEN
            KY = KY - NY/2
          ELSE
            KY = KY + NY/2
          ENDIF
         ENDIF
      GOTO 777
C ----
  777 CONTINUE
      JX=JX+1
      KY=KY+1
C X,Y RELATIVE TO IMPURITY SITE, IN UNITS OF U2:
      YU = ( (FLOAT(K)-0.5) / RNY -YI ) * YUN / U2Y
C INTEGRATE OVER ONE SUBCELL:
      YIELD=YIELD + FLUX(JX + (KY-1)*NX) * GX *
     *      GAUSAR(YU-EPSY  ,  YU+EPSY) *  WI
  71  CONTINUE
  72  CONTINUE
  73  CONTINUE
      YIELD = YIELD / SWI
      END
