C INTERNAL ROUTINES FOR MAPPING COORDINATES ACCORDING TO LATTICE TYPE
C
C ================= PART 1. THE FLUX3 CASE =========================
C
C Uniform steps in Z
C Z coordinate described by integer JZ
C XX = X coordinate
C PX = X direction
C when flipping PX also flip INVERTX
C XUNKL = Xunit
C TWOXUNKL = 2 Xunits
C XX = TWOXUNKL describes a reflection with respect to X = 1 (Xunit)
C Analogous for Y
C
  100 CONTINUE
C PbF2 LATTICE, <100> PROJECTION
C SHIFT INTO THE RANGE [0..2*XUNKL] ALSO REQUIRES SHIFTING Z
      IF ( XX.GE.TWOXUNKL ) THEN
        XX = XX - TWOXUNKL
        JZ = JZ + 2
      ENDIF
      IF ( YY.GE.TWOYUNKL ) THEN
        YY = YY - TWOYUNKL
        JZ = JZ + 2
      ENDIF
C BRING INTO THE RANGE [0..XUNKL] BY REFLECTION, AND SHIFTING Z
      IF ( XX.GE.XUNKL ) THEN
        XX = TWOXUNKL - XX
        PX =  - PX
        INVERTX = -INVERTX
        JZ = JZ + 2
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
        YY = TWOYUNKL - YY
        PY =  - PY
        INVERTY = -INVERTY
        JZ = JZ + 2
      ENDIF
      GOTO 7
C
  110 CONTINUE
C PbF2 LATTICE, <110> PROJECTION
      IF ( XX.GE.TWOXUNKL ) THEN
        XX = 2.0*TWOXUNKL - XX
        PX =  - PX
        INVERTX = -INVERTX
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
        YY = TWOYUNKL - YY
        PY =  - PY
        INVERTY = -INVERTY
      ENDIF
      IF ( XX.GE.XUNKL ) THEN
        XX = TWOXUNKL - XX
        YY = YUNKL - YY
        PX =  - PX
        INVERTX = -INVERTX
        PY =  - PY
        INVERTY = -INVERTY
        JZ = JZ + 1
      ENDIF
      GOTO 7
C
 2100 CONTINUE
C GaAs LATTICE, <100> PROJECTION
C BCC  LATTICE, <100> PROJECTION
C BCC  LATTICE, <110> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
        XX = TWOXUNKL - XX
        PX =  - PX
        INVERTX = -INVERTX
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
        YY = TWOYUNKL - YY
        PY =  - PY
        INVERTY = -INVERTY
      ENDIF
      GOTO 7
C
 3110 CONTINUE
C SPINEL LATTICE <110> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
        XX = TWOXUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
        YY = TWOYUNKL - YY
        PY =  - PY
        INVERTY = -INVERTY
C Difference with case '2100'. extra shift in z
        JZ = JZ + 4
      ENDIF
      GOTO 7
C
 2110 CONTINUE
C GaAs LATTICE, <110> PROJECTION
      IF ( YY.GE.YUNKL ) THEN
        YY = TWOYUNKL - YY
        PY =  - PY
        INVERTY = -INVERTY
      ENDIF
      IF ( XX.GE.XUNKL ) THEN
        XX = XX - XUNKL
        YY = YUNKL - YY
        PY =  - PY
        INVERTY = -INVERTY
        JZ = JZ + 1
      ENDIF
      GOTO 7
C
  111 CONTINUE
C PbF2 LATTICE, <111> PROJECTION
C GaAs LATTICE, <111> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
C         REFLECTION WITH RESPECT TO X=XUNKL:
        XX = TWOXUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
      ENDIF
      JY= YY /YUNKL
C NOW, JY = 0, 1, or 2
      IF ( JY.EQ.0 ) GOTO 7
C TRANSLATE IN Y DIRECTION, AND ADJUST Z COORDINATE ACCORDINGLY
      YY=YY-JY*YUNKL
      JZ=JZ-4*JY
      GOTO 7
C
 2111 CONTINUE
C FCC LATTICE, <111> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
C         REFLECTION WITH RESPECT TO X=XUNKL:
        XX = TWOXUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
      ENDIF
      JY= YY /YUNKL
      IF ( JY.EQ.0 ) GOTO 7
C TRANSLATE IN Y DIRECTION, AND ADJUST Z COORDINATE ACCORDINGLY
      YY=YY-JY*YUNKL
      JZ=JZ - JY
      GOTO 7
C

 3111 CONTINUE
C BCC LATTICE, <111> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
C         REFLECTION WITH RESPECT TO X=XUNKL:
        XX = TWOXUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
      ENDIF
      JY= YY /YUNKL
      IF ( JY.EQ.0 ) GOTO 7
C TRANSLATE IN Y DIRECTION, AND ADJUST Z COORDINATE ACCORDINGLY
      YY=YY-JY*YUNKL
      JZ=JZ+2*JY
      GOTO 7
C
 4111 CONTINUE
C NaCl LATTICE, <111> PROJECTION ("3111", reflected in y=0 plane)
      IF ( XX.GE.XUNKL ) THEN
C         REFLECTION WITH RESPECT TO X=XUNKL:
        XX = TWOXUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
      ENDIF
      JY= YY /YUNKL
      IF ( JY.EQ.0 ) GOTO 7
C TRANSLATE IN Y DIRECTION, AND ADJUST Z COORDINATE ACCORDINGLY
      YY=YY-JY*YUNKL
      JZ=JZ-2*JY
      GOTO 7
C
 2211 CONTINUE
C GaAs LATTICE <211> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
        XX = TWOXUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
        IF ( YY.GE.TWOYUNKL ) THEN
            YY = YY - TWOYUNKL
            JZ = JZ + 2
        ELSE
            YY = YY - YUNKL
            JZ = JZ + 4
        ENDIF
      ENDIF
      GOTO 7
C
 5100 CONTINUE
C HEXAGONAL ErSi2  LATTICE, <0001> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
C       REFLECTION WITH RESPECT TO X=XUN:
        XX = TWOXUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
      ENDIF
      IF ( YY.GE.TWOYUNKL ) THEN
C       REFLECTION WITH RESPECT TO Y=TWOYUN:
        YY = TWOYUNKL*2.0 - YY
        PY = -PY
        INVERTY = -INVERTY
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
C       REFLECTION WITH RESPECT TO Y=YUN:
        YY = TWOYUNKL - YY
        PY = -PY
        INVERTY = -INVERTY
C       REFLECTION WITH RESPECT TO X=0.5*XUN:
        XX = XUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
      ENDIF
      GOTO 7
C
C
 6001 CONTINUE
C HEXAGONAL 6H or 4H SiC LATTICE, <0001> PROJECTION
 6101 CONTINUE
C HEXAGONAL WURTZITE LATTICE, <0001> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
C       REFLECTION WITH RESPECT TO X=XUN:
        XX = TWOXUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
C       REFLECTION WITH RESPECT TO X=0.5*XUN:
        XX = XUNKL - XX
        PX = -PX
        INVERTX = -INVERTX
C       TRANSLATION BY Y=YUN:
        YY = YY - YUNKL
      ENDIF
      GOTO 7
C
 6103 CONTINUE
C HEXAGONAL WURTZITE LATTICE, <11-20> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
C       TRANSLATION BY X=XUN:
        XX = XX - XUNKL
C       Translate one step in Z direction:
        JZ = JZ +1
      ENDIF
      GOTO 7
C
 6104 CONTINUE
C HEXAGONAL WURTZITE LATTICE, <1-100> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
Coming soon!      
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
Coming soon!      
      ENDIF
      GOTO 7
C      
C ================= PART 2. FLUX4 STUFF ============================
C
C Z coordinate described by DELZZ, in Angstrom units
C if DELZZ is set exit by GOTO 77, else GOTO 7
C Under label 77 the new value of JZ is set, depending on DELZZ
C The following is the same as for the FLUX3 case
C XX = X coordinate
C PX = X direction
C when flipping PX also flip INVERTX
C XUNKL = Xunit
C TWOXUNKL = 2 Xunits
C XX = TWOXUNKL describes a reflection with respect to X = 1 (Xunit)
C Analogous for Y
C IYUM= + if coming from above, - if coming from below
C
 2310 CONTINUE
C GaAs LATTICE <310> PROJECTION

C seemed to be wrong . added the following 2 lines (PJMS march 2004)
      DELZ1=0.0
      DELZ2=0.0

      IF ( XX.GE.XUNKL ) THEN
          XX = XX - XUNKL
          YY = YY - 0.5*YUNKL
	  DELZ1= 6.2574
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
	IJJ = YY/(YUNKL)
        IF ( YY.LT.0 ) IJJ = IJJ - 1
        YY = YY - IJJ*YUNKL
        DELZ2= 3.5757 * IJJ
      ENDIF
      DELZZ = DELZ1 + DELZ2
      GOTO 77
C
 4041 CONTINUE
C LiNbO3 LATTICE, <04-4-1> PROJECTION
          DELZZ1=0.0
       IF ( XX.GE.XUNKL ) THEN
C          REFLECTION WITH RESPECT TO X=XUNKL:
           XX = TWOXUNKL - XX
           PX = -PX
          INVERTX= -INVERTX
           DELZZ1=6.3786
       ENDIF
C TRANSLATE IN Y DIRECTION, AND ADJUST Z COORDINATE ACCORDINGLY
      DELZZ2=-IYUM*4.445
      
      DELZZ=DELZZ1 + DELZZ2
      GOTO 77
C
 4042 CONTINUE
C LiNbO3 LATTICE, <04-4-1> PROJECTION
C TRANSLATE IN Y DIRECTION, AND ADJUST Z COORDINATE ACCORDINGLY
      DELZZ2=-IYUM*4.445
      
      DELZZ= DELZZ2
      GOTO 77
      
 2021 CONTINUE
C LiNbO3 LATTICE, <02-21> PROJECTION
          DELZZ1=0.0
       IF ( XX.GE.XUNKL ) THEN
C          REFLECTION WITH RESPECT TO X=XUNKL:
           XX = TWOXUNKL - XX
           PX = -PX
          INVERTX= -INVERTX
           DELZZ1=3.7646
       ENDIF 
C TRANSLATE IN Y DIRECTION, AND ADJUST Z COORDINATE ACCORDINGLY
      DELZZ2=-IYUM*0.490
      
      DELZZ=DELZZ1 + DELZZ2
      GOTO 77
      
 2022 CONTINUE
C LiNbO3 LATTICE, <02-21> PROJECTION
C TRANSLATE IN Y DIRECTION, AND ADJUST Z COORDINATE ACCORDINGLY
      DELZZ2=-IYUM*0.490
      
      DELZZ= DELZZ2
      GOTO 77
      

 1010 CONTINUE
C LiNbO3 LATTICE, <10-10> PROJECTION
          DELZZ1=0.0
          DELZZ2=0.0
          DELZZ3=0.0
      IF ( XX.GE.XUNKL ) THEN
C     Translate in x direction and adjust z coordinate (0.5*ZUNIT) 
          XX = XX - XUNKL 
          DELZZ1=4.4583
      ENDIF
C TRANSLATE IN Y DIRECTION AND ADJUST Z COORDINATE ACCORDINGLY 
C (5.944=2*ZUNIT/3)
      DELZZ2=-IYUM*5.9444
      
C TRANSLATE IN Y DIRECTION AND ADJUST X, Z COORDINATES ACCORDINGLY
C (2.9722=ZUNIT/3)
         IF ( YY.GE.YUNKL ) THEN
          YY = YY - YUNKL
          XX = XUNKL - XX 
	  PX= -PX
          INVERTX= -INVERTX
          DELZZ3=-2.9722
         ENDIF
      DELZZ=DELZZ1 + DELZZ2 + DELZZ3
      GOTO 77
      
 1120 CONTINUE
C LiNbO3 LATTICE, <11-20> PROJECTION
          DELZZ1=0.0
          DELZZ2=0.0
      IF ( XX.GE.XUNKL ) THEN
C     Translate in x direction and adjust z coordinate (0.5*ZUNIT) 
          XX = XX - XUNKL 
          DELZZ1=2.574
      ENDIF
      
C TRANSLATE IN Y DIRECTION AND ADJUST X and Z COORDINATES ACCORDINGLY 
          IF ( YY.GE.YUNKL ) THEN
            IF ( YY.LT.TWOYUNKL ) THEN
            YY = YY - YUNKL
            XX = XX + XUNKL/3.0  
            DELZZ2= 2.574
	      IF(XX.GT.XUNKL) THEN
	      XX = XX - XUNKL
              DELZZ2= 0.0
	      ENDIF
            ELSE
            YY = YY - TWOYUNKL
            XX = XX + 2.0*XUNKL/3.0  
            DELZZ2= 0.0
	      IF(XX.GE.XUNKL) THEN
	      XX = XX - XUNKL
              DELZZ2= 2.574
	      ENDIF
            ENDIF
          ENDIF
      DELZZ=DELZZ1 + DELZZ2
      GOTO 77

 1000 CONTINUE
C LiNbO3 LATTICE, <0001> PROJECTION
          DELZZ1=0.0
          DELZZ2=0.0
      IF ( XX.GE.XUNKL ) THEN
C     Translate in x direction and adjust z coordinate (0.5*ZUNIT) 
          XX = TWOXUNKL - XX 
	  PX= -PX
          INVERTX= -INVERTX
          DELZZ1=6.9315
      ENDIF
      
C TRANSLATE IN Y DIRECTION AND ADJUST X and Z COORDINATES ACCORDINGLY 
          IF ( YY.GE.YUNKL ) THEN
              IF ( YY.GE.TWOYUNKL ) THEN
              YY = YY - TWOYUNKL
              DELZZ2= 2.0*ZUNKL/3.0
	      ELSE
	      YY = YY - YUNKL
              DELZZ2= ZUNKL/3.0
	      ENDIF
           ENDIF
      DELZZ=DELZZ1 + DELZZ2
      GOTO 77

 1001 CONTINUE
C LiNbO3 LATTICE, <0001> PROJECTION
          DELZZ2=0.0
      
C TRANSLATE IN Y DIRECTION AND ADJUST X and Z COORDINATES ACCORDINGLY 
          IF ( YY.GE.YUNKL ) THEN
              IF ( YY.GE.TWOYUNKL ) THEN
              YY = YY - TWOYUNKL
              DELZZ2= 2.0*ZUNKL/3.0
	      ELSE
	      YY = YY - YUNKL
              DELZZ2= ZUNKL/3.0
	      ENDIF
           ENDIF
      DELZZ=DELZZ2
      GOTO 77
      
 6000 CONTINUE
C Al2O3 LATTICE, <0001> PROJECTION
          DELZZ2=0.0
      
C TRANSLATE IN Y DIRECTION AND ADJUST X and Z COORDINATES ACCORDINGLY 
          IF ( YY.GE.YUNKL ) THEN
              IF ( YY.GE.TWOYUNKL ) THEN
              YY = YY - TWOYUNKL
              DELZZ2= 2.0*ZUNKL/3.0
	      ELSE
	      YY = YY - YUNKL
              DELZZ2= ZUNKL/3.0
	      ENDIF
           ENDIF
      DELZZ=DELZZ2
      GOTO 77

 6102 CONTINUE
C Al2O3 LATTICE, <11-20> PROJECTION
          DELZZ1=0.0
          DELZZ2=0.0
      IF ( XX.GE.XUNKL ) THEN
C     Translate in x direction and adjust z coordinate (0.5*UD) 
          XX = XX - XUNKL 
          DELZZ1=2.379
      ENDIF
      
C TRANSLATE IN Y DIRECTION AND ADJUST X and Z COORDINATES ACCORDINGLY 
          IF ( YY.GE.YUNKL ) THEN
            IF ( YY.LT.TWOYUNKL ) THEN
            YY = YY - YUNKL
            XX = XX + XUNKL/3.0  
            DELZZ2= 2.379
	      IF(XX.GT.XUNKL) THEN
	      XX = XX - XUNKL
              DELZZ2= 0.0
	      ENDIF
            ELSE
            YY = YY - TWOYUNKL
            XX = XX + 2.0*XUNKL/3.0  
            DELZZ2= 0.0
	      IF(XX.GE.XUNKL) THEN
	      XX = XX - XUNKL
              DELZZ2= 2.379
	      ENDIF
            ENDIF
          ENDIF
      DELZZ=DELZZ1 + DELZZ2
      GOTO 77
      
 6200 CONTINUE
C LiNbO3 LATTICE, <01-10> PROJECTION
          DELZZ1=0.0
          DELZZ2=0.0
          DELZZ3=0.0
      IF ( XX.GE.XUNKL ) THEN
C     Translate in x direction and adjust z coordinate (0.5*UD) 
          XX = XX - XUNKL 
          DELZZ1=4.1205
      ENDIF
C TRANSLATE IN Y DIRECTION AND ADJUST Z COORDINATE ACCORDINGLY (5.494=2*UD/3)
      DELZZ2=-IYUM*5.49407
      
C TRANSLATE IN Y DIRECTION AND ADJUST X, Z COORDINATES ACCORDINGLY (2.747=UD/3)
         IF ( YY.GE.YUNKL ) THEN
          YY = YY - YUNKL
          XX = XUNKL - XX 
	  PX= -PX
          INVERTX= -INVERTX
          DELZZ3=-2.747
         ENDIF
      DELZZ=DELZZ1 + DELZZ2 + DELZZ3
      GOTO 77

 6201 CONTINUE
C Al2O3 LATTICE, <01-10> PROJECTION
          DELZZ1=0.0
          DELZZ2=0.0
      IF ( XX.GE.XUNKL ) THEN
C     Translate in x direction and adjust z coordinate (0.5*UD) 
          XX = XX - XUNKL 
          DELZZ1=2.379
      ENDIF
      
C TRANSLATE IN Y DIRECTION AND ADJUST X and Z COORDINATES ACCORDINGLY 
          IF ( YY.GE.YUNKL ) THEN
            IF ( YY.LT.TWOYUNKL ) THEN
            YY = YY - YUNKL
            DELZZ2= 2.379
	    ELSE
            YY = YY - TWOYUNKL
            DELZZ2= 5.49407
	    ENDIF
          ENDIF
      DELZZ=DELZZ1 + DELZZ2
      GOTO 77

 6300 CONTINUE
C Al2O3 LATTICE, <10-11> PROJECTION
          DELZZ=0.0
      
C TRANSLATE IN Y DIRECTION ADJUST X and Z COORDINATES ACCORDINGLY (2.5641=UD/2)
         IF ( YY.GE.YUNKL ) THEN
          YY = YY - YUNKL
          XX = XUNKL - XX 
	  PX= -PX
          INVERTX= -INVERTX
          DELZZ=2.5641
         ENDIF
      GOTO 77

 6400 CONTINUE
C Al2O3 LATTICE, <02-21> PROJECTION
C TRANSLATE IN Y DIRECTION, AND ADJUST Z COORDINATE ACCORDINGLY
      DELZZ2=-IYUM*0.490
      DELZZ= DELZZ2
      GOTO 77
 
 7000 CONTINUE
C hcp lattice, <10-10> PROJECTION
      IF ( XX.GE.XUNKL ) THEN
          XX = TWOXUNKL - XX
          PX = -PX
          INVERTX= -INVERTX
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
          YY = TWOYUNKL - YY
          PY = -PY
          INVERTY= -INVERTY
      ENDIF
      GOTO 7
C
 7100 CONTINUE
C hcp LATTICE, <11-20> PROJECTION
      IF ( YY.GE.YUNKL ) THEN
          YY = TWOYUNKL - YY
          PY = -PY
          INVERTY= -INVERTY
      ENDIF
      IF ( XX.GE.XUNKL ) THEN
          XX = XX - XUNKL
          JZ = JZ + 1
      ENDIF
      GOTO 7

 7200 CONTINUE
C hcp LATTICE, <0001> PROJECTION

      IF ( XX.GE.XUNKL ) THEN
          XX = TWOXUNKL - XX
          PX = -PX
          INVERTX= -INVERTX
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
          YY = YY - YUNKL
          XX = XUNKL - XX
          PX = -PX
          INVERTX= -INVERTX
      ENDIF
      GOTO 7

 7300 CONTINUE
C HCP LATTICE, <10-11> PROJECTION
      GOTO 7

 8000 CONTINUE
C WURTZITE LATTICE, <0001> PROJECTION

      IF ( XX.GE.XUNKL ) THEN
          XX = TWOXUNKL - XX
          PX = -PX
          INVERTX= -INVERTX
      ENDIF
      IF ( YY.GE.YUNKL ) THEN
          YY = YY - YUNKL
          XX = XUNKL - XX
          PX = -PX
          INVERTX= -INVERTX
C ????    JZ = JZ+1 ; this line should not be here (PJMS march 2004)
      ENDIF
      GOTO 7

 8100 CONTINUE
C GAN1011, WURTZITE LATTICE, <10-11> PROJECTION

C TRANSLATE IN Y DIRECTION ADJUST Z COORDINATE ACCORDINGLY
      DELZZ= -0.4687*ZUNKL*IYUM
      GOTO 77

 8101 CONTINUE
C GAN1011, WURTZITE LATTICE, <10-11> PROJECTION

C TRANSLATE IN Y DIRECTION ADJUST Z COORDINATE ACCORDINGLY
      DELZZ= -0.4605*ZUNKL*IYUM
      GOTO 77

 8200 CONTINUE
C GAN2113, WURTZITE LATTICE, <-2113> PROJECTION

      DELZZ= 0.2742*ZUNKL*IYUM
      IF (XX.GE.XUNKL) THEN
        XX = XX -XUNKL
	IF(YY.GE.YUNKL*0.5)THEN
	  YY = YY - YUNKL*0.5
	  DELZZ= DELZZ + 0.1371*ZUNKL
	ELSE
	  YY = YY + YUNKL*0.5
	  DELZZ= DELZZ - 0.1371*ZUNKL
	ENDIF
      ENDIF
      GOTO 77

 8201 CONTINUE
C ALN2113, WURTZITE LATTICE, <-2113> PROJECTION

      DELZZ= 0.28086*ZUNKL*IYUM
      IF (XX.GE.XUNKL) THEN
        XX = XX -XUNKL
	IF(YY.GE.YUNKL*0.5)THEN
	  YY = YY - YUNKL*0.5
	  DELZZ= DELZZ + 0.14044*ZUNKL
	ELSE
	  YY = YY + YUNKL*0.5
	  DELZZ= DELZZ - 0.14044*ZUNKL
	ENDIF
      ENDIF
      GOTO 77

77    CONTINUE  
      IF(DELZZ.EQ.0.0) GOTO 7
      IF(DELZZ.gt. 1.0E10) STOP 'at label 77: DELZZ undefined'
      J=DELZZ/(ZUNKL)
      IF(DELZZ.LT.0.0) J=J-1
      DELZZ=DELZZ-J*ZUNKL
      DZZ=0.0
C      Choose the nearest plane from the new coordinate
      DO 119 I=1,MODZKL
      JZZ=JZ+I
      IF(JZZ.GT.MODZKL) JZZ=JZZ-MODZKL
      DZZ=DUZ(JZZ-1,KL) + DZZ
      IF(DZZ.GE.DELZZ) GOTO 122
  119 CONTINUE
  122 CONTINUE
C
      DIFSUP=DZZ-DELZZ
      DIFINF=DELZZ-(DZZ-DUZ(JZZ-1,KL))
      IF(DIFSUP.LT.DIFINF) THEN
      JZ=JZZ
      ELSE
      JZ=JZZ-1
      ENDIF
      GOTO 7
C
