      PROGRAM DEDX
      implicit NONE
CALCULATION OF THE ENERGY LOSS DUE TO ELECTRONS OF FAST IONS IN
CRYSTALS.
      REAL PI, TWOPI, DEGREE
      PARAMETER(PI=3.14159265,TWOPI=2.0*PI,DEGREE=TWOPI/360.0)
C BOHR RADIUS IN ANGSTROM, RYDBERG CONSTANT IN MeV
      REAL ABOHR, RYDBERG
      PARAMETER(ABOHR=0.5291770,RYDBERG=1.360580E-5)
C H,C,AND BOLTZMANN CONSTANT IN S.I. UNITS
      REAL HBAR, C, BOLS
      PARAMETER(HBAR=1.054589E-34,C=2.997925E8, BOLS=1.380662E-23)
C AMU IN MeV,METER IN ANGSTROMS, JOULE IN MeV
      REAL AMU,METER,JOULE
      PARAMETER(AMU=931.5016,METER=1.0E10,JOULE=1.0E-6/1.602189E-19)
      REAL AME, HC
      PARAMETER(AME=0.511003)
      PARAMETER (HC=HBAR*C*METER*JOULE)
      REAL T0,Z1,Z2,A1,ZLOC,ZVAL,UA,APC
      COMMON T0,Z1,Z2,A1,ZLOC,ZVAL,UA,APC
      REAL BK0, BK1, DEDXVAL, DEDXVL1, DEDXVL2, DEDXVL3, HOMEGA
      REAL TE, VFERMI, VION, VOLAT, XM, ZFACT, ZION
      INTEGER KER

      REAL ZZE2D
      EXTERNAL ZZE2D

C defaults:
      T0=1
      Z1=1
      Z2=14
      A1=1
      ZLOC=4
      ZVAL=4
      UA=5.463
      APC=8

      CALL INREAL(T0,4,'T0 (MeV), Z1, Z2, A1')
      CALL INREAL(ZLOC,2,'ZLOC, ZVAL')
      CALL INREAL(UA,2,'UA (Angstrom), ATOMS PER CELL')
CALCULATE VOLUME PER ATOM:
      VOLAT=UA**3 / APC
CALCULATE V/C OF ION:
      VION = SQRT( T0 * (T0+2.0*A1*AMU) ) / (T0+A1*AMU)
CALCULATE EFFECTIVE CHARGE=Z1(1-EXP(-(V/C*137/Z1**(2/3))))
      ZION = Z1 * (1.0 - EXP(-VION*137.0/Z1**(2.0/3.0)))
CALCULATE FACTOR 4*PI*(ZION*E**2)**2:
      ZFACT=4.0*PI*ZZE2D(ZION,1.0,1.0)**2
C ZFACT DIVIDED BY ELECTRON MASS * VION**2  * ATOMIC VOLUME:
      TE = AME * VION**2
      ZFACT = ZFACT / ( TE * VOLAT )
C ZFACT IS NOW THE 'BASIC UNIT' WITH DIMENSION MeV/ANGSTROM.
CALCULATE HBAR*OMEGA PLASMA IN MeV:
      HOMEGA = HC * SQRT(4.0*PI*ZZE2D(ZVAL,1.0,1.0)/(AME*VOLAT))
CALCULATE VFERMI/C
      VFERMI = HC * (3.0*PI*PI*ZVAL/VOLAT)**(1.0/3.0) / AME
CALCULATE DE/DX (VALENCE,LOCAL)
C 1. USING THE FORMULA OF PINES (= MELVIN AND TOMBRELLO)
      DEDXVL1= ZFACT*ZLOC * ALOG( 2.0*AME*VION*VFERMI/ HOMEGA )
C2. USING THE FORMULA OF BELOSHITSKY AND KUMAKHOV
      XM = HOMEGA/(AME*VION*VFERMI)
      CALL BESK(XM,0,BK0,KER)
      CALL BESK(XM,1,BK1,KER)
      DEDXVL2=ZFACT*ZLOC*(XM*BK0*BK1-0.5*XM**2*(BK1-BK0)*(BK1+BK0))
C 3. USING THE APPROXIMATION TO THE ABOVE GIVEN BY BELOSHITSKY & KUMAKHO
      DEDXVL3=DEDXVL1 - ZFACT*ZLOC*(0.577+0.5)
CALCULATE DE/DX (VALENCE):
      DEDXVAL= ZFACT * ZVAL * ALOG(VION/VFERMI)
C
C PRINT SOME OF THE RESULTS.
  444 FORMAT(2(1X,A10,': ',G13.5,1X,A6))
  555 FORMAT(1X,' DE/DX ',A40,': ',G13.5,' eV/angstrom')
      WRITE(6,444)'Z ION',Z1,'e','Z EFF',ZION,'e'
      WRITE(6,444)'A ION',A1,'amu','ENERGY',T0,'MeV'
      WRITE(6,444)'AT.VOL.',VOLAT ,'A**3','FACTOR',ZFACT,'MeV/A'
      WRITE(6,444)'V ION',VION,'c','V FERMI',VFERMI,'c'
      WRITE(6,444)'m*VION**2',TE,'MeV','h*OMEGA',HOMEGA,'MeV'
      WRITE(6,555) '(VALENCE)                               ',1.0E6*DEDX
     + VAL
      WRITE(6,555) '(VAL,LOC) [PINES / MELVIN & TOMBRELLO]  ',1.0E6*DEDX
     + VL1
      WRITE(6,555) '(VAL,LOC) [BELOSHITSKY & KUMAKHOV] exact',1.0E6*DEDX
     + VL2
      WRITE(6,555) '(VAL,LOC) [BELOSHITSKY & KUMAKHOV] appr.',1.0E6*DEDX
     + VL3
      END
