C******************************************************************************
C FILE: omp_getEnvInfo.f
C DESCRIPTION:
C   OpenMP Example - Get Environment Information - Fortran Version
C   The master thread queries and prints selected environment information.
C AUTHOR: Blaise Barney  7/06
C LAST REVISED: 07/12/06
C******************************************************************************

      PROGRAM GETINFO
     
      INTEGER NTHREADS, TID, OMP_GET_NUM_THREADS,
     +  OMP_GET_THREAD_NUM, OMP_GET_NUM_PROCS, OMP_GET_MAX_THREADS,
     +  OMP_IN_PARALLEL, OMP_GET_DYNAMIC, OMP_GET_NESTED,
     +  PROCS, MAXT

      INTEGER INPAR, DYNAMIC, NESTED
      CHARACTER*4 CINPAR, CDYNAMIC, CNESTED
      DATA CINPAR, CDYNAMIC, CNESTED/ ' No', ' No', ' No'/
  
C     Start parallel region
!$OMP PARALLEL PRIVATE(NTHREADS, TID)

C     Obtain thread number
      TID = OMP_GET_THREAD_NUM()

      PRINT *, ' Hello from thread ', TID
C     Only master thread does this
      IF (TID .EQ. 0) THEN

        PRINT *, 'Thread',tid,'getting environment information'

C     Get environment information
        PROCS = OMP_GET_NUM_PROCS() 
        NTHREADS = OMP_GET_NUM_THREADS()
        MAXT = OMP_GET_MAX_THREADS()
        INPAR = OMP_IN_PARALLEL()
        DYNAMIC = OMP_GET_DYNAMIC()
        NESTED = OMP_GET_NESTED()
        if(INPAR.ne.0) CINPAR='Yes'
        if(DYNAMIC.ne.0) CDYNAMIC='Yes'
        if(INPAR.ne.0) CINPAR='Yes'

C     Print environment information
    
        PRINT *, 'Number of processors = ', PROCS
        PRINT *, 'Number of threads =    ', NTHREADS
        PRINT *, 'Max threads =          ', MAXT
        PRINT *, 'In parallel? =                  ', CINPAR
        PRINT *, 'Dynamic threads enabled? =      ', CDYNAMIC
        PRINT *, 'Nested parallelism supported? = ', CNESTED

      END IF

C     Done
!$OMP END PARALLEL

      END
